/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/incl/ap_api.h,v 1.26 2004/04/16 21:05:43 jshen Exp $
*
* Purpose:
*    This file contains the function prototypes and definitions for the
*    AP command APIs.
*
* Public Procedures:

*
* Notes:
*    None.
*
*****************************************************************************/

#ifndef _API_H_
#define _API_H_

#include "wltypes.h"
#include "osif.h"
#include "usrcfg.h"

/* Use these macros for port name */
/* Wireless LAN port */
#define PORT_NAME_WLAN "wl0" 
/* WAN logical port attached to physical port eth0 */
#define PORT_NAME_WAN  "wan0" 
/* LAN logical port attached to physical port eth0 */
#define PORT_NAME_LAN  "lan0" 
/* Physical ethernet port */
#define PORT_NAME_ETH "eth0" 
/* GPIO number cannot exceed this limit */
#define MAX_GPIO_NUM 15 
/*============================================================================= */
/*                          API for Sending Commands */
/*============================================================================= */






typedef	enum
{
    APCMD_BSS_START = 0x00000001,
    APCMD_BSS_START_REPLY,
    APCMD_GET_SSID ,
    APCMD_GET_SSID_REPLY,
    APCMD_SET_SSID ,
    APCMD_SET_SSID_REPLY,
    APCMD_GET_OPEN_SSID_EN_STATE ,
    APCMD_GET_OPEN_SSID_EN_STATE_REPLY,
    APCMD_SET_OPEN_SSID_EN_STATE,
    APCMD_SET_OPEN_SSID_EN_STATE_REPLY,
    APCMD_GET_RF_MAC_ADDRESS,
    APCMD_GET_RF_MAC_ADDRESS_REPLY,
    APCMD_SET_RF_MAC_ADDRESS,
    APCMD_SET_RF_MAC_ADDRESS_REPLY,
    APCMD_GET_RF_CHANNEL,
    APCMD_GET_RF_CHANNEL_REPLY,
    APCMD_SET_RF_CHANNEL,
    APCMD_SET_RF_CHANNEL_REPLY,
    APCMD_GET_BASIC_DATA_RATES,
    APCMD_GET_BASIC_DATA_RATES_REPLY,
    APCMD_SET_BASIC_DATA_RATES,
    APCMD_SET_BASIC_DATA_RATES_REPLY,
    APCMD_GET_SUP_DATA_RATES,
    APCMD_GET_SUP_DATA_RATES_REPLY,
    APCMD_SET_SUP_DATA_RATES,
    APCMD_SET_SUP_DATA_RATES_REPLY,
    APCMD_GET_TX_DATA_RATE,
    APCMD_GET_TX_DATA_RATE_REPLY,
    APCMD_SET_TX_DATA_RATE,
    APCMD_SET_TX_DATA_RATE_REPLY,
    APCMD_GET_TX_POWER_LEVEL,
    APCMD_GET_TX_POWER_LEVEL_REPLY,
    APCMD_SET_TX_POWER_LEVEL,
    APCMD_SET_TX_POWER_LEVEL_REPLY,
    APCMD_GET_RF_PREAMBLE_OPTION,
    APCMD_GET_RF_PREAMBLE_OPTION_REPLY,
    APCMD_SET_RF_PREAMBLE_OPTION,
    APCMD_SET_RF_PREAMBLE_OPTION_REPLY,
    APCMD_GET_ANTENNA_MODE,
    APCMD_GET_ANTENNA_MODE_REPLY,
    APCMD_SET_ANTENNA_MODE,
    APCMD_SET_ANTENNA_MODE_REPLY,
    APCMD_GET_FRAG_THRESHOLD,
    APCMD_GET_FRAG_THRESHOLD_REPLY,
    APCMD_SET_FRAG_THRESHOLD,
    APCMD_SET_FRAG_THRESHOLD_REPLY,
    APCMD_GET_RTS_THRESHOLD,
    APCMD_GET_RTS_THRESHOLD_REPLY,
    APCMD_SET_RTS_THRESHOLD,
    APCMD_SET_RTS_THRESHOLD_REPLY,
    APCMD_GET_RTS_RETRY_LIMIT,
    APCMD_GET_RTS_RETRY_LIMIT_REPLY,
    APCMD_SET_RTS_RETRY_LIMIT,
    APCMD_SET_RTS_RETRY_LIMIT_REPLY,
    APCMD_GET_DATA_RETRY_LIMIT,
    APCMD_GET_DATA_RETRY_LIMIT_REPLY,
    APCMD_SET_DATA_RETRY_LIMIT,
    APCMD_SET_DATA_RETRY_LIMIT_REPLY,
    APCMD_GET_BEACON_PERIOD,
    APCMD_GET_BEACON_PERIOD_REPLY,
    APCMD_SET_BEACON_PERIOD,
    APCMD_SET_BEACON_PERIOD_REPLY,
    APCMD_GET_DTIM_PERIOD,
    APCMD_GET_DTIM_PERIOD_REPLY,
    APCMD_SET_DTIM_PERIOD,
    APCMD_SET_DTIM_PERIOD_REPLY,
    APCMD_GET_802_11_STATS,
    APCMD_GET_802_11_STATS_REPLY,
    APCMD_ADD_WLAN_FILTER_ENTRY,
    APCMD_ADD_WLAN_FILTER_ENTRY_REPLY,
    APCMD_DEL_WLAN_FILTER_ENTRY,
    APCMD_DEL_WLAN_FILTER_ENTRY_REPLY,
    APCMD_GET_STA_LIST,
    APCMD_GET_STA_LIST_REPLY,
    APCMD_GET_STA_INFO,
    APCMD_GET_STA_INFO_REPLY,
    APCMD_DEAUTH_STA,
    APCMD_DEAUTH_STA_REPLY,
    APCMD_DISASSOC_STA,
    APCMD_DISASSOC_STA_REPLY,
    APCMD_ADD_ASSOC_FILTER_ENTRY,
    APCMD_ADD_ASSOC_FILTER_ENTRY_REPLY,
    APCMD_DEL_ASSOC_FILTER_ENTRY,
    APCMD_DEL_ASSOC_FILTER_ENTRY_REPLY,
    APCMD_GET_MAX_NUM_STA,
    APCMD_GET_MAX_NUM_STA_REPLY,
    APCMD_SET_MAX_NUM_STA,
    APCMD_SET_MAX_NUM_STA_REPLY,
    APCMD_GET_DEFAULT_WEP_KEYS,
    APCMD_GET_DEFAULT_WEP_KEYS_REPLY,
    APCMD_SET_DEFAULT_WEP_KEYS,
    APCMD_SET_DEFAULT_WEP_KEYS_REPLY,
    APCMD_SET_STA_WEP_KEY,
    APCMD_SET_STA_WEP_KEY_REPLY,
    APCMD_GET_PRIVACY_OPTION,
    APCMD_GET_PRIVACY_OPTION_REPLY,
    APCMD_SET_PRIVACY_OPTION,
    APCMD_SET_PRIVACY_OPTION_REPLY,
    APCMD_GET_AUTH_MODE,
    APCMD_GET_AUTH_MODE_REPLY,
    APCMD_SET_AUTH_MODE,
    APCMD_SET_AUTH_MODE_REPLY,
    APCMD_GET_ETH_MAC_ADDRESS,
    APCMD_GET_ETH_MAC_ADDRESS_REPLY,
    APCMD_GET_ETH_IP_CONFIG,
    APCMD_GET_ETH_IP_CONFIG_REPLY,
    APCMD_SET_ETH_IP_CONFIG,
    APCMD_SET_ETH_IP_CONFIG_REPLY,
#ifdef OS_VxW
    /* Added wireless lan and WAN ip info for VxWorks. */
    APCMD_GET_WL_IP_CONFIG,
    APCMD_GET_WL_IP_CONFIG_REPLY,
    APCMD_SET_WL_IP_CONFIG,
    APCMD_SET_WL_IP_CONFIG_REPLY,
    
    APCMD_GET_WAN_IP_CONFIG,
    APCMD_GET_WAN_IP_CONFIG_REPLY,
    APCMD_SET_WAN_IP_CONFIG,
    APCMD_SET_WAN_IP_CONFIG_REPLY,
#endif    
    APCMD_GET_ETH_PORT_STATUS,
    APCMD_GET_ETH_PORT_STATUS_REPLY,
    APCMD_SET_ETH_PORT_PARAMS,
    APCMD_SET_ETH_PORT_PARAMS_REPLY,
    APCMD_GET_ICMP_EN_STATE,
    APCMD_GET_ICMP_EN_STATE_REPLY,
    APCMD_SET_ICMP_EN_STATE,
    APCMD_SET_ICMP_EN_STATE_REPLY,
    APCMD_GET_802_3_STATES,
    APCMD_GET_802_3_STATES_REPLY,
    APCMD_READ_GPIO,
    APCMD_READ_GPIO_REPLY,
    APCMD_WRITE_GPIO,
    APCMD_WRITE_GPIO_REPLY,
    APCMD_SET_ETH_MAC_ADDRESS,
    APCMD_SET_ETH_MAC_ADDRESS_REPLY,
    APCMD_GET_WAN_MAC_ADDRESS,
    APCMD_GET_WAN_MAC_ADDRESS_REPLY,
    APCMD_SET_WAN_MAC_ADDRESS,
    APCMD_SET_WAN_MAC_ADDRESS_REPLY,
    APCMD_FW_SOFT_RESET,
    APCMD_FW_SOFT_RESET_REPLY,
    APCMD_GET_WLAN_FILTER_LIST,
    APCMD_GET_WLAN_FILTER_LIST_REPLY,
    APCMD_SET_WLAN_FILTER_LIST,
    APCMD_SET_WLAN_FILTER_LIST_REPLY,
    APCMD_GET_WLAN_FILTER_MODE,
    APCMD_GET_WLAN_FILTER_MODE_REPLY,
    APCMD_SET_WLAN_FILTER_MODE,
    APCMD_SET_WLAN_FILTER_MODE_REPLY,
    APCMD_UPDATE_FIRMWARE,
    APCMD_UPDATE_FIRMWARE_REPLY,
    APCMD_SAVE_USER_CONFIG,
    APCMD_SAVE_USER_CONFIG_REPLY,
    APCMD_SET_STA_AGING_TIME_IN_MINUTES,
    APCMD_SET_STA_AGING_TIME_IN_MINUTES_REPLY,
    APCMD_GET_FIRMWARE_VERSION,
    APCMD_GET_FIRMWARE_VERSION_REPLY,
    APCMD_SET_BEACON_TX_MODE,         /*on or off */
    APCMD_SET_BEACON_TX_MODE_REPLY,
    APCMD_SET_RATE_ADAPTATION_METHOD,
    APCMD_SET_RATE_ADAPTATION_METHOD_REPLY,
    APCMD_GET_RATE_ADAPTATION_PARAMS,
    APCMD_GET_RATE_ADAPTATION_PARAMS_REPLY,
    APCMD_SET_RATE_ADAPTATION_PARAMS,
    APCMD_SET_RATE_ADAPTATION_PARAMS_REPLY,
    APCMD_SET_SDRAM_BURST_MODE,
    APCMD_SET_SDRAM_BURST_MODE_REPLY,
    APCMD_GET_DEVICE_NAME,
    APCMD_GET_DEVICE_NAME_REPLY,
    APCMD_SET_DEVICE_NAME,
    APCMD_SET_DEVICE_NAME_REPLY,        
    
/* GET/SET Baseband Reg */
    APCMD_GET_BB_REG,
    APCMD_GET_BB_REG_REPLY,
    APCMD_SET_BB_REG,
    APCMD_SET_BB_REG_REPLY,
/* GET/SET Baseband Reg end */

    APCMD_GET_CUR_RADIO_TX_RATE,
    APCMD_GET_CUR_RADIO_TX_RATE_REPLY,
/* GET/SET 11g commands */
   APCMD_GET_BASIC_DATA_RATES_G,
   APCMD_GET_BASIC_DATA_RATES_G_REPLY,
   APCMD_SET_BASIC_DATA_RATES_G,
   APCMD_SET_BASIC_DATA_RATES_G_REPLY,
   APCMD_GET_TX_DATA_RATE_G,
   APCMD_GET_TX_DATA_RATE_G_REPLY,
   APCMD_SET_TX_DATA_RATE_G,
   APCMD_SET_TX_DATA_RATE_G_REPLY,
   APCMD_GET_AP_MODE,
   APCMD_GET_AP_MODE_REPLY,
   APCMD_SET_AP_MODE,
   APCMD_SET_AP_MODE_REPLY,
   APCMD_GET_STA_LIST_G,
   APCMD_GET_STA_LIST_G_REPLY,
   APCMD_GET_STA_INFO_G,
   APCMD_GET_STA_INFO_G_REPLY,
   /*GET/SET 11g commands end */
   APCMD_GET_ETH_CONFIG,
   APCMD_GET_ETH_CONFIG_REPLY,
   APCMD_SET_ETH_CONFIG,
   APCMD_SET_ETH_CONFIG_REPLY,
   APCMD_GET_PRIVACY_TBL_RSN_ENABLED,
   APCMD_GET_PRIVACY_TBL_RSN_ENABLED_REPLY,
   APCMD_SET_PRIVACY_TBL_RSN_ENABLED,
   APCMD_SET_PRIVACY_TBL_RSN_ENABLED_REPLY,
   APCMD_GET_RSN_CFG_AUTH_SUITE,
   APCMD_GET_RSN_CFG_AUTH_SUITE_REPLY,
   APCMD_SET_RSN_CFG_AUTH_SUITE,
   APCMD_SET_RSN_CFG_AUTH_SUITE_REPLY,
   APCMD_GET_RSN_CFG_UNICAST_CIPHERS,
   APCMD_GET_RSN_CFG_UNICAST_CIPHERS_REPLY,
   APCMD_SET_RSN_CFG_UNICAST_CIPHERS,
   APCMD_SET_RSN_CFG_UNICAST_CIPHERS_REPLY,
   APCMD_SET_RSN_CFG_MULTICAST_CIPHERS,
   APCMD_SET_RSN_CFG_MULTICAST_REPLY,
   APCMD_GET_RSN_CFG,
   APCMD_GET_RSN_CFG_REPLY,
   APCMD_SET_PSK_PASSPHRASE,
   APCMD_SET_PSK_PASSPHRASE_REPLY,
   APCMD_SET_GRP_REKEY_TIME,
   APCMD_SET_GRP_REKEY_TIME_REPLY,
   APCMD_GET_RSN_STATS,
   APCMD_GET_RSN_STATS_REPLY,

#if defined(WDS_FEATURE) || defined(AP31E) || defined(AP31CLIENT)
    APCMD_GET_WDS_MODE,
    APCMD_GET_WDS_MODE_REPLY,
    APCMD_SET_WDS_MODE,
    APCMD_SET_WDS_MODE_REPLY,
    APCMD_GET_WDS_LIST,
    APCMD_GET_WDS_LIST_REPLY,
    APCMD_SET_WDS_LIST,
    APCMD_SET_WDS_LIST_REPLY,
    APCMD_GET_DISABLE_ASSOC,
    APCMD_GET_DISABLE_ASSOC_REPLY,
    APCMD_SET_DISABLE_ASSOC,
    APCMD_SET_DISABLE_ASSOC_REPLY,
    /* WDS interop option */
    APCMD_GET_WDS_OPTION,
    APCMD_GET_WDS_OPTION_REPLY,
    APCMD_SET_WDS_OPTION,
    APCMD_SET_WDS_OPTION_REPLY,
#endif /* WDS_FEATURE*/

    APCMD_GET_FORCE_PROTECTION_MODE,
    APCMD_GET_FORCE_PROTECTION_MODE_REPLY,
    APCMD_SET_FORCE_PROTECTION_MODE,
    APCMD_SET_FORCE_PROTECTION_MODE_REPLY,

#if defined(WIPOD)
    /* WiPod 5-in-1 */
    APCMD_GET_WIPOD_MODE,
    APCMD_GET_WIPOD_MODE_REPLY,
    APCMD_SET_WIPOD_MODE,
    APCMD_SET_WIPOD_MODE_REPLY,
#endif

#if defined(BURST_MODE)
    APCMD_GET_BURST_MODE,
    APCMD_GET_BURST_MODE_REPLY,
    APCMD_SET_BURST_MODE,
    APCMD_SET_BURST_MODE_REPLY,
#endif

#ifdef AP_SITE_SURVEY
    APCMD_SET_SURVEY_SCAN,
    APCMD_SET_SURVEY_SCAN_REPLY,
    APCMD_GET_SURVEY_INFO,
    APCMD_GET_SURVEY_INFO_REPLY,
#endif /* AP_SITE_SURVEY */
#ifdef SELF_CTS
    APCMD_SET_SELF_CTS,
    APCMD_SET_SELF_CTS_REPLY,
    APCMD_GET_SELF_CTS,
    APCMD_GET_SELF_CTS_REPLY,
#endif
    /* Alway add items above this line */
} APCMD;
typedef struct _APICMDBUF
{
    UINT16 cmdCode;
    UINT16 seqNum;
    UINT16 cmdStatus;
    UINT16 cmdBodyLen;
    UINT8 *cmdBody;
}
APICMDBUF;
#if defined(AP31HOST) || defined(AP31E) || defined(AP31CLIENT)
#define APICMDHEADER   unsigned short cmdCode; \
                       unsigned short seqNum; \
                       unsigned short cmdStatus; \
                       unsigned short cmdBodyLen; \
                       unsigned int *cmdBody
#else
#define APICMDHEADER   unsigned short cmdCode; \
                       unsigned short seqNum; \
                       unsigned short cmdStatus; \
                       unsigned short cmdBodyLen
#endif

typedef struct _APICMDBUF_GET_SELF_CTS
{
    APICMDHEADER;
    unsigned char SelfCts;
}
APICMDBUF_GET_SELF_CTS;
typedef struct _APICMDBUF_SET_SELF_CTS
{
    APICMDHEADER;
    unsigned char SelfCts;
}
APICMDBUF_SET_SELF_CTS;
typedef struct _APICMDBUF_GET_FORCE_PROTECTION_MODE
{
    APICMDHEADER;
    unsigned short forceProtectMode;
}
APICMDBUF_GET_FORCE_PROTECTION_MODE;

typedef struct _APICMDBUF_SET_FORCE_PROTECTION_MODE
{
    APICMDHEADER;
    unsigned short forceProtectMode;
}
APICMDBUF_SET_FORCE_PROTECTION_MODE;

#ifdef BURST_MODE
typedef struct _APICMDBUF_GET_BURST_MODE
{
    APICMDHEADER;
	unsigned char burstMode;
	unsigned long burstRate;	
}
APICMDBUF_GET_BURST_MODE;

typedef struct _APICMDBUF_SET_BURST_MODE
{
    APICMDHEADER;
	unsigned char burstMode;
	unsigned long burstRate;	
}
APICMDBUF_SET_BURST_MODE;
#endif /* BURST_MODE */

#ifdef WDS_FEATURE
typedef enum{
    WDS_MODE_DISABLE,
    WDS_MODE_STATIC,
    WDS_MODE_DYNAMIC,
}WDS_MODE_TYPE;
#endif /* WDS_FEATURE*/

typedef enum
{
    APCTL_OK = 1,
    APCTL_BUF_TOO_SMALL,
    APCTL_BAD_CMD,
    APCTL_CMD_FAILED,
    APCTL_TIMEOUT,
    APCTL_ERROR,
}APCMD_STATUS;


#define apio_handle_t UINT32
#define APIO_NOERROR 1
#define APIO_ERROR  0
#define apio_ErrCode_t UINT8

typedef struct apio_bufdescr_t
{
    UINT16 frameLen;  /*Length of the frame */
    UINT16 reserved;  /*reserved field */
    UINT8 *framePtr;  /*Pointer to the frame */
#ifdef OS_VxW
    void  *cookie;    /**/
#endif
}
apio_bufdescr_t;


extern WL_STATUS apctl(APICMDBUF * apicmdbuf);
extern apio_ErrCode_t apio_open(char *pName, apio_handle_t *pHandle, void (*) (apio_bufdescr_t *));
extern apio_ErrCode_t apio_close(apio_handle_t);
extern apio_ErrCode_t apio_read(apio_handle_t handle, apio_bufdescr_t *pBufDescr);
extern apio_ErrCode_t apio_write(apio_handle_t handle, apio_bufdescr_t *pBufDescr);
extern apio_ErrCode_t apio_alloc(apio_handle_t handle, apio_bufdescr_t *pBufDescr);
extern apio_ErrCode_t apio_free(apio_handle_t, apio_bufdescr_t *pBufDescr);
extern UINT32 apio_select(void);

typedef enum
{
    OPEN_SYSTEM_ONLY = 1,
    SHARED_KEY_ONLY,
    OPEN_SYSTEM_AND_SHARED_KEY,
}AUTH_MODE;

#define ds_802_11_DATA_RCVD         (1<<0)
#define ds_802_3_DATA_RCVD          (1<<1)
#define ds_MGMT_NOTIFICATION_RCVD   (1<<2)
#define ds_LLC_DATA_RCVD            (1<<3)
#define ds_802_3_TX_DONE            (1<<4)
#define ds_802_11_TX_DONE           (1<<5)
#define ds_POLLING_TIMEOUT_RCVD     (1<<6)
#define ds_POLLING_WPA_MSG          (1<<7)

typedef enum
{
    APIO_POLL_RADIO_DATA_RDY      = ds_802_11_DATA_RCVD,
    APIO_POLL_ETH_DATA_RDY        = ds_802_3_DATA_RCVD,  /* Ethernet port has received data */
    APIO_POLL_PROT_STACK_DATA_RDY = ds_LLC_DATA_RCVD,
	APIO_POLL_ETH_TX_DONE         = ds_802_3_TX_DONE,
	APIO_POLL_WLAN_TX_DONE        = ds_802_11_TX_DONE,
	APIO_POLL_WPA_MSG             = ds_POLLING_WPA_MSG,
    APIO_POLL_WAN_DATA_RDY        = (1 << 7 ),
}POLL_DATA;



typedef enum
{
	AP_MODE_B_ONLY,
	AP_MODE_G_ONLY,
	AP_MODE_MIXED,
}AP_ERP_MODE;

typedef enum
{
	CLIENT_MODE_B,
	CLIENT_MODE_G,
}CLIENT_MODE;

 /* GET/SET Baseband Reg */
typedef struct _APICMDBUF_GET_BB_REG{

    APICMDHEADER;
unsigned short regNum;
unsigned char regVal;
 
}APICMDBUF_GET_BB_REG;

typedef struct _APICMDBUF_SET_BB_REG{

    APICMDHEADER;
unsigned short regNum;
unsigned char regVal;
 
}APICMDBUF_SET_BB_REG;
 /* GET/SET Baseband Reg end*/

typedef struct _APICMDBUF_GET_RF_CHANNEL
{
    APICMDHEADER;
    unsigned short rfModulationType;
    char	availChanList[14];
    unsigned short curChanNum;

}
APICMDBUF_GET_RF_CHANNEL;

typedef struct _APICMDBUF_GET_OPEN_SSID_EN_STATE
{
    APICMDHEADER;
    unsigned char openSSIDEnabled;
}
APICMDBUF_GET_OPEN_SSID_EN_STATE;

typedef struct _APICMDBUF_SET_OPEN_SSID_EN_STATE
{
    APICMDHEADER;
    unsigned char openSSIDEnabled;
}
APICMDBUF_SET_OPEN_SSID_EN_STATE;


typedef struct _APICMDBUF_SET_RF_CHANNEL
{
    APICMDHEADER;
    unsigned char curChanNum;

}
APICMDBUF_SET_RF_CHANNEL;

typedef struct _APICMDBUF_GET_RF_MACADDR
{
    APICMDHEADER;
    unsigned char physAddr[6];
}
APICMDBUF_GET_RF_MACADDR;

typedef struct _APICMDBUF_SET_RF_MACADDR
{
    APICMDHEADER;
    unsigned char physAddr[6];
}
APICMDBUF_SET_RF_MACADDR;

typedef struct _APICMDBUF_GET_BASIC_DATA_RATES
{
    APICMDHEADER;
    unsigned char basicDataRates[14];
}
APICMDBUF_GET_BASIC_DATA_RATES;

typedef struct _APICMDBUF_SET_BASIC_DATA_RATES
{
    APICMDHEADER;
    unsigned char basicDataRates[14];
}
APICMDBUF_SET_BASIC_DATA_RATES;

typedef struct _APICMDBUF_GET_SUP_DATA_RATES
{
    APICMDHEADER;
    unsigned char txDataRate[14];
}
APICMDBUF_GET_SUP_DATA_RATES;

typedef struct _APICMDBUF_SET_SUP_DATA_RATES
{
    APICMDHEADER;
    unsigned char txDataRate[14];
}
APICMDBUF_SET_SUP_DATA_RATES;

typedef struct _APICMDBUF_GET_TX_DATA_RATE
{
    APICMDHEADER;
    unsigned char txDataRate;
}
APICMDBUF_GET_TX_DATA_RATE;

typedef struct _APICMDBUF_SET_TX_DATA_RATE
{
    APICMDHEADER;
    unsigned char txDataRate;
}
APICMDBUF_SET_TX_DATA_RATE;

typedef struct _APICMDBUF_GET_TX_POWER_LEVEL
{
    APICMDHEADER;
    unsigned char txPowerLevel;
    unsigned char powerLevelList[8];
}
APICMDBUF_GET_TX_POWER_LEVEL;

typedef struct _APICMDBUF_SET_TX_POWER_LEVEL
{
    APICMDHEADER;
    unsigned char txPowerLevel;
}
APICMDBUF_SET_TX_POWER_LEVEL;

typedef struct _APICMBUF_GET_RF_PREAMBLE_OPTION
{
    APICMDHEADER;
    unsigned char rfPreambleOption;
}
APICMBUF_GET_RF_PREAMBLE_OPTION;

typedef struct _APICMBUF_SET_RF_PREAMBLE_OPTION
{
    APICMDHEADER;
    unsigned char rfPreambleOption;
}
APICMBUF_SET_RF_PREAMBLE_OPTION;

typedef enum{
    PREAMBLE_SHORT,
    PREAMBLE_LONG,
    PREAMBLE_AUTO_SELECT,
}PREAMBLE_TYPE;

typedef struct _APICMDBUF_GET_ANTENNA_MODE
{
    APICMDHEADER;
    unsigned char rxAntennaMode;
    unsigned char txAntennaMode;
}
APICMDBUF_GET_ANTENNA_MODE;

typedef struct _APICMDBUF_SET_ANTENNA_MODE
{
    APICMDHEADER;
    unsigned char whichAnt;
    unsigned char antennaMode;
}
APICMDBUF_SET_ANTENNA_MODE;

typedef enum{
    AP_RX_ANTENNA,
    AP_TX_ANTENNA,
}ANTENNA_MODE_TYPE;


typedef struct _APICMDBUF_GET_FRAG_THRESHOLD
{
    APICMDHEADER;
    unsigned short fragThreshold;
}
APICMDBUF_GET_FRAG_THRESHOLD;

typedef struct _APICMDBUF_SET_FRAG_THRESHOLD
{
    APICMDHEADER;
    unsigned short fragThreshold;
}
APICMDBUF_SET_FRAG_THRESHOLD;

typedef struct _APICMDBUF_GET_RTS_THRESHOLD
{
    APICMDHEADER;
    unsigned short rtsThreshold;
}
APICMDBUF_GET_RTS_THRESHOLD;

typedef struct _APICMDBUF_SET_RTS_THRESHOLD
{
    APICMDHEADER;
    unsigned short rtsThreshold;
}
APICMDBUF_SET_RTS_THRESHOLD;


typedef struct _APICMDBUF_GET_RTS_RETRY_LIMIT
{
    APICMDHEADER;
    unsigned short rtsRetryLimit;
}
APICMDBUF_GET_RTS_RETRY_LIMIT;

typedef struct _APICMDBUF_SET_RTS_RETRY_LIMIT
{
    APICMDHEADER;
    unsigned short rtsRetryLimit;
}
APICMDBUF_SET_RTS_RETRY_LIMIT;

typedef struct _APICMDBUF_GET_DATA_RETRY_LIMIT
{
    APICMDHEADER;
    unsigned short dataRetryLimit;
}
APICMDBUF_GET_DATA_RETRY_LIMIT;

typedef struct _APICMDBUF_SET_DATA_RETRY_LIMIT
{
    APICMDHEADER;
    unsigned short dataRetryLimit;
}
APICMDBUF_SET_DATA_RETRY_LIMIT;

typedef struct _APICMDBUF_GET_BEACON_PERIOD
{
    APICMDHEADER;
    unsigned long beaconPeriod;
}
APICMDBUF_GET_BEACON_PERIOD;

typedef struct _APICMDBUF_SET_BEACON_PERIOD
{
    APICMDHEADER;
    unsigned long beaconPeriod;
}
APICMDBUF_SET_BEACON_PERIOD;

typedef struct _APICMDBUF_GET_DTIM_PERIOD
{
    APICMDHEADER;
    unsigned long dtimPeriod;
}
APICMDBUF_GET_DTIM_PERIOD;


typedef struct _APICMDBUF_SET_DTIM_PERIOD
{
    APICMDHEADER;
    unsigned long dtimPeriod;
}
APICMDBUF_SET_DTIM_PERIOD;

typedef struct _APICMDBUF_GET_802_11_STATS
{
    APICMDHEADER;
    unsigned long rxFrmCnt;
    unsigned long txFrmCnt;
    unsigned long totaltxBytes;
    unsigned long totalRxBytes;
    unsigned long cntMcastPackets;
    unsigned long cntUcastPackets;
    unsigned long cntTxBad;
    unsigned long cntRetry;
    unsigned long cntMultRetry;
    unsigned long rtsOKCnt;
    unsigned long rtsBadCnt;
    unsigned long ackBadCnt;
    unsigned long rxMcastOkCnt;
    unsigned long rxUcastOkCnt;
    unsigned long fcsErrorCnt;
    unsigned long duplicateCnt;
    unsigned long wepDecryptBadCnt;
}
APICMDBUF_GET_802_11_STATS;

typedef struct _APICMDBUF_GET_ETH_MAC_ADDRESS
{
    APICMDHEADER;
    unsigned char phyAddress[6];
}
APICMDBUF_GET_ETH_MAC_ADDRESS;

typedef struct _APICMDBUF_SET_ETH_MAC_ADDRESS
{
    APICMDHEADER;
    unsigned char phyAddress[6];
}
APICMDBUF_SET_ETH_MAC_ADDRESS;

typedef struct _APICMDBUF_GET_WAN_MAC_ADDRESS
{
    APICMDHEADER;
    unsigned char phyAddress[6];
}
APICMDBUF_GET_WAN_MAC_ADDRESS;

typedef struct _APICMDBUF_SET_WAN_MAC_ADDRESS
{
    APICMDHEADER;
    unsigned char phyAddress[6];
}
APICMDBUF_SET_WAN_MAC_ADDRESS;

typedef struct _APICMDBUF_GET_ETH_IP_CONFIG
{
    APICMDHEADER;
    unsigned long dhcpEnabled;
    unsigned long ipAddress;
    unsigned long subnetMask;
    unsigned long gatewayAddress;
}
APICMDBUF_GET_ETH_IP_CONFIG;

typedef struct _APICMDBUF_SET_ETH_IP_CONFIG
{
    APICMDHEADER;
    unsigned long dhcpEnabled;
    unsigned long ipAddress;
    unsigned long subnetMask;
    unsigned long gatewayAddress;
}
APICMDBUF_SET_ETH_IP_CONFIG;

typedef struct _APICMDBUF_GET_ETH_PORT_STATUS
{
    APICMDHEADER;
    unsigned char portnumber;
    unsigned char ethOperStatus;
    unsigned char ethDuplex;
    unsigned char ethLinkSpeed;
}
APICMDBUF_GET_ETH_PORT_STATUS;

typedef enum
{
    ETH_OPER_STATUS_UP,
    ETH_OPER_STATUS_DOWN,
}ETHER_PORTSTATUS;


typedef struct _APICMDBUF_SET_ETH_PORT_PARAMS
{
    APICMDHEADER;
    unsigned short linkSpeed;
    unsigned short ethDuplex;
}
APICMDBUF_SET_ETH_PORT_PARAMS;

typedef struct _APICMDBUF_GET_ICMP_EN_STATE
{
    APICMDHEADER;
    unsigned char icmpEnabled;
}
APICMDBUF_GET_ICMP_EN_STATE;

typedef struct _APICMDBUF_SET_ICMP_EN_STATE
{
    APICMDHEADER;
    unsigned char icmpEnabled;
}
APICMDBUF_SET_ICMP_EN_STATE;


typedef struct _APICMDBUF_GET_802_3_STATS
{
    APICMDHEADER;
    unsigned long clearStats;
    unsigned long totalTxBytes;
    unsigned long cntMcastPackets;
    unsigned long cntUcastPackets;
    unsigned long cntTxBad;
    unsigned long totalRxBytes;
    unsigned long rxBadCnt;
    unsigned long rxMcastOKCnt;
    unsigned long rxUcastOKCnt;
    unsigned long crcErrorCnt;
}
APICMDBUF_GET_802_3_STATS;


typedef struct _APICMDBUF_GET_STA_INFO
{
    APICMDHEADER;
    unsigned char staMACAddress[6];
    unsigned char staIPAddress;
    unsigned char staPowerSaveMode;
    unsigned char staWEPStatus;
    unsigned int staRSSI;
    unsigned int staSQ;
}
_APICMDBUF_GET_STA_INFO;

typedef struct _APICMDBUF_DEAUTH_STA
{
    APICMDHEADER;
    unsigned char staMACAddress[6];
}
APICMDBUF_DEAUTH_STA;

typedef struct _APICMDBUF_DISASSOC_STA
{
    APICMDHEADER;
    unsigned char staMACAddress[6];
}
APICMDBUF_DISASSOC_STA;

/* SECURITY COMMANDS */
typedef struct _APICMDBUF_GET_DEFAULT_WEP_KEYS
{
    APICMDHEADER;
    unsigned short keyindex; /*cntWEPKEYS; */
    unsigned short keyType0;
    unsigned char keyValue0[16];
    unsigned short keyType1;
    unsigned char keyValue1[16];
    unsigned short keyType2;
    unsigned char keyValue2[16];
    unsigned short keyType3;
    unsigned char keyValue3[16];
}
APICMDBUF_GET_DEFAULT_WEP_KEYS;

typedef struct _APICMDBUF_SET_DEFAULT_WEP_KEYS
{
    APICMDHEADER;
    unsigned short keyindex;
    unsigned short keyType0;
    unsigned char keyValue0[16];
    unsigned short keyType1;
    unsigned char keyValue1[16];
    unsigned short keyType2;
    unsigned char keyValue2[16];
    unsigned short keyType3;
    unsigned char keyValue3[16];
}
APICMDBUF_SET_DEFAULT_WEP_KEYS;

typedef struct _APICMDBUF_SET_STA_WEP_KEY
{
    APICMDHEADER;
    unsigned char staMACAddress[6];
    unsigned short keyType;
    unsigned short KeyValue[16];
}
APICMDBUF_SET_STA_WEP_KEY;

typedef enum{
    WEP_NOT_SET,
    WEP_40_BIT,
    WEP_104_BIT,
}WEP_KEY_TYPE;

typedef struct _APICMDBUF_GET_PRIVACY_OPTION
{
    APICMDHEADER;
    unsigned char dataEncrypt;
}
APICMDBUF_GET_PRIVACY_OPTION;

typedef struct _APICMDBUF_SET_PRIVACY_OPTION
{
    APICMDHEADER;
    unsigned char dataEncrypt;
}
APICMDBUF_SET_PRIVACY_OPTION;

typedef struct _APICMDBUF_SET_PSK_PASSPHRASE
{
    APICMDHEADER;
    unsigned char passphrase[64];
}
APICMDBUF_SET_PSK_PASSPHRASE;

typedef struct _APICMDBUF_SET_GRP_REKEY_TIME
{
    APICMDHEADER;
    unsigned long rekey_time;
}
APICMDBUF_SET_GRP_REKEY_TIME;

typedef enum {
    DATA_ENCRYPT_NOT_REQUIRED,
    DATA_ENCRYPT_OPTIONA,
    FULL_DATA_ENCRYPT_REQUIRED,
}PRIVACY_TYPE;

typedef struct _APICMDBUF_GET_AUTH_MODE
{
    APICMDHEADER;
    unsigned char authMode;
}
APICMDBUF_GET_AUTH_MODE;

typedef struct _APICMDBUF_SET_AUTH_MODE
{
    APICMDHEADER;
    unsigned char authMode;
}
APICMDBUF_SET_AUTH_MODE;

/*AP SYSTEM COMMANDS */
typedef struct _APICMDBUF_GET_API_VER
{
    APICMDHEADER;
    unsigned char apAPIVer[32];
}
APICMDBUF_GET_API_VER;

typedef struct _APICMDBUF_GET_AP_STATUS
{
    APICMDHEADER;
    unsigned short macStatus;
    unsigned short rfPortStatus;
    unsigned short ethPortStatus;
    unsigned short curChannel;
    unsigned char apname[32];
    unsigned char macAddress[6];
    unsigned short cntAssocSta;
    unsigned long maxLinkSpeed;
    unsigned char apFwVer[32];
    unsigned long apFwChecksum;
}
APICMDBUF_GET_AP_STATUS;

typedef enum{
    OPER_STATUS_UP,
    OPER_STATUS_DOWN,
}AP_STATUS_TYPE;

typedef struct _APICMDBUF_GET_EVENT_LOG
{
    APICMDHEADER;
    unsigned char eventlog;
}
APICMDBUF_GET_EVENT_LOG;

typedef struct _APICMDBUF_PURGE_EVENT_LOG
{
    APICMDHEADER;
}
APICMDBUF_PURGE_EVENT_LOG;

typedef struct _APICMDBUF_UPDATE_FIRMWARE
{
    APICMDHEADER;
    unsigned char *imgPtr;
}
APICMDBUF_UPDATE_FIRMWARE;

typedef enum{
    FW_UPDATE_OK,
    FW_UPDATE_FAIL_FLASH,
    FW_UPDATE_FAIL_CHECKUSM,
    FW_UPDATE_SAME_VER,
}UPDATE_FIRMWARE_TYPE;

typedef struct _APICMDBUF_RUN_DIAG
{
    APICMDHEADER;
    unsigned short testNum;
    unsigned short testResult;
}
APICMDBUF_RUN_DIAG;

typedef enum {
    TEST_PASS,
    TEST_FAIL,
    TEST_INCONCLUSIVE,
}DIAG_TYPE;

typedef struct _APICMDBUF_START_LINK_TEST
{
    APICMDHEADER;
    unsigned char staMACAdress[6];
    unsigned long cntTxPacketsOK;
    unsigned long totalErrors;
    unsigned long totalWEPErrors;
}
APICMDBUF_START_LINK_TEST;

typedef struct _APICMDBUF_READ_GPIO
{
    APICMDHEADER;
    unsigned char gpioNum;
    unsigned char gpioVal;
}
APICMDBUF_READ_GPIO;

typedef struct _APICMDBUF_WRITE_GPIO
{
    APICMDHEADER;
    unsigned char gpioNum;
    unsigned char gpioVal;
}
APICMDBUF_WRITE_GPIO;

typedef struct _APICMDBUF_SET_STA_AGING_TIME
{
    APICMDHEADER;
    unsigned short timeInMinutes;

}
APICMDBUF_SET_STA_AGING_TIME;

typedef struct _APICMDBUF_SET_BEACON_TX_MODE
{
    APICMDHEADER;
    unsigned char txBcnDisable;

}
APICMDBUF_SET_BEACON_TX_MODE;

#ifdef ENABLE_RATE_ADAPTATION
typedef struct _APICMDBUF_RATE_ADAPTATION_PARAMS
{
    APICMDHEADER;
    UINT8 tx_success_rate_limit;
    UINT8 tx_failure_rate_limit;
    UINT8 tx_retry_as_failure;

}
APICMDBUF_RATE_ADAPTATION_PARAMS;

#define RATE_ADAPT_NONE 0
#define RATE_ADAPT_TX   1
#define RATE_FOLLOW_STN 2
extern UINT8 txRateAdaptMethod;     /* Use TX_RATE_ADAPTATION by default */
extern void SetupTxRateProb();
extern UINT8 tx_success_rate_limit;
extern UINT8 tx_failure_rate_limit;
extern UINT8 tx_retry_as_failure;
#endif  /* ENABLE_RATE_ADAPTATION */

#define SDRAM_BURST_REG (WL_SDRAM_CFG_BASE+0x14)
#define SDRAM_BURST_1   0
#define SDRAM_BURST_2   1
#define SDRAM_BURST_4   2
#define SDRAM_BURST_8   3
typedef struct _APICMDBUF_SDRAM_BURST_MODE
{
    APICMDHEADER;
    UINT8 sdramBurstMode;

}
APICMDBUF_SDRAM_BURST_MODE;

typedef enum{
    FILTER_MODE_DISABLE,
    FILTER_MODE_ALLOW,
    FILTER_MODE_BLOCK,
}FILTER_MODE_TYPE;

typedef struct _APICMDBUF_SSID
{
    APICMDHEADER;
    unsigned char  *pSSID;
}
APICMDBUF_SSID;
#ifdef STA_INFO_DB
typedef struct _STA_INFO
{
    UINT8 macAdd[6];
    UINT8 assocState;
    UINT8 staMode;
    UINT8 rate;
    UINT8 sq2;
    UINT8 sq1;
    UINT8 RSSI;
    UINT8 powerSave;
}
PACK_END STA_INFO;
#else
typedef struct _STA_INFO
{
    UINT8 macAdd[6];
    UINT16 assocState;
}
PACK_END STA_INFO;
#endif
typedef struct _APICMDBUF_STA_LIST
{
    APICMDHEADER;
    UINT16 numStas;
    STA_INFO Sta[1];  
}
APICMDBUF_STA_LIST;

typedef struct _APICMDBUF_FILTER_LIST
{
    APICMDHEADER;
    unsigned char  *pFilterList; /* 2 bytes (number of filters)  + mac address + .... */
}
APICMDBUF_FILTER_LIST;

#if defined(WIPOD_NEW_GUI) /* added horman's code */
typedef struct _APICMDBUF_GET_FILTER_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use FILTER_MODE_TYPE enum */
}
APICMDBUF_GET_FILTER_MODE;

typedef struct _APICMDBUF_SET_FILTER_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use FILTER_MODE_TYPE enum */
}
APICMDBUF_SET_FILTER_MODE;
#endif /* WIPOD_NEW_GUI */

typedef struct _APICMDBUF_FILTER_MODE
{
    APICMDHEADER;
    unsigned char  mode; 
}
APICMDBUF_FILTER_MODE;

typedef struct _APICMDBUF_GET_CUR_RADIO_TX_RATE
{
    APICMDHEADER;
    unsigned short txRate;
}
APICMDBUF_GET_CUR_RADIO_TX_RATE;
typedef struct _APICMDBUF_GET_BASIC_DATA_RATES_G{
    APICMDHEADER;
    unsigned char basicDataRates[16];
}APICMDBUF_GET_BASIC_DATA_RATES_G;

typedef struct _APICMDBUF_SET_BASIC_DATA_RATES_G{
    APICMDHEADER;
    unsigned char basicDataRates[16];
}APICMDBUF_SET_BASIC_DATA_RATES_G;

typedef struct _APICMDBUF_GET_TX_DATA_RATE_G{
    APICMDHEADER;
    unsigned char txDataRate;
}APICMDBUF_GET_TX_DATA_RATE_G;

typedef struct _APICMDBUF_SET_TX_DATA_RATE_G{
    APICMDHEADER;
    unsigned char txDataRate;
}APICMDBUF_SET_TX_DATA_RATE_G;

typedef struct _APICMDBUF_GET_AP_MODE{
    APICMDHEADER;
    unsigned int apMode;
}APICMDBUF_GET_AP_MODE;

typedef struct _APICMDBUF_SET_AP_MODE{
    APICMDHEADER;
    unsigned int apMode;
}APICMDBUF_SET_AP_MODE;

typedef struct _APICMDBUF_GET_ETH_CONFIG{
    APICMDHEADER;
    unsigned int apMode;
}APICMDBUF_GET_ETH_CONFIG;

typedef struct _APICMDBUF_SET_ETH_CONFIG{
    APICMDHEADER;
    unsigned int apMode;
}APICMDBUF_SET_ETH_CONFIG;

typedef struct _APICMDBUF_GET_STA_INFO_G{
    APICMDHEADER;
    unsigned char staMACAddress[6];
    unsigned char staIPAddress;
    unsigned char staPowerSaveMode;
    unsigned char staWEPStatus;
    unsigned int staRSSI;
    unsigned int staSQ;
    unsigned short staMode;
}_APICMDBUF_GET_STA_INFO_G;

typedef struct _APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED
{
    APICMDHEADER;
    unsigned long Enabled;
}
APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED;

typedef struct _APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED
{
    APICMDHEADER;
    unsigned long Enabled;
}
APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED;

typedef struct _APICMDBUF_GET_RSN_CFG_AUTH_SUITE
{
    APICMDHEADER;
    unsigned char AuthSuites[4];
    unsigned char Enabled;
}
APICMDBUF_GET_RSN_CFG_AUTH_SUITE;

typedef struct _APICMDBUF_SET_RSN_CFG_AUTH_SUITE
{
    APICMDHEADER;
    unsigned char AuthSuites[4];
    unsigned char Enabled;
}
APICMDBUF_SET_RSN_CFG_AUTH_SUITE;

typedef struct _APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS
{
    APICMDHEADER;
    unsigned char MulticastCipher[4];
}
APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS;

typedef struct _APICMDBUF_GET_RSN_CFG_UNICAST_CIPHERS
{
    APICMDHEADER;
    unsigned char UnicastCipher[4];
    unsigned char Enabled;
}
APICMDBUF_GET_RSN_CFG_UNICAST_CIPHERS;

typedef struct _APICMDBUF_SET_RSN_CFG_UNICAST_CIPHERS
{
    APICMDHEADER;
    unsigned char UnicastCipher[4];
    unsigned char Enabled;
}
APICMDBUF_SET_RSN_CFG_UNICAST_CIPHERS;

typedef struct _APICMDBUF_GET_RSN_STATS
{
    APICMDHEADER;
    unsigned char MacAddr[6];
    unsigned char Version;
    unsigned char SelectedUnicastCipher[4];
    unsigned long TKIPICVErrors;
    unsigned long TKIPLocalMICFailures;
    unsigned long TKIPRemoteMICFailures;
    unsigned long TKIPCounterMeasuresInvoked;
    unsigned long CCMPFormatErrors;
    unsigned long CCMPReplays;
    unsigned long CCMPDecryptErrors;
}
APICMDBUF_GET_RSN_STATS;

typedef struct _APICMDBUF_GET_RSN_CFG
{
    APICMDHEADER;
    unsigned long Version;
    unsigned long PairwiseKeysSupported;
    unsigned char MulticastCipher[4];
    unsigned char GroupRekeyMethod;
    unsigned long GroupRekeyTime;
    unsigned long GroupRekeyPackets;
    unsigned char GroupRekeyStrict;
    //unsigned char  PSKValue[32];  // write only
    //unsigned char  PSKPassPhrase[64]; // write only
    unsigned char TSNEnabled;
    unsigned long GroupMasterRekeyTime;
    unsigned long GroupUpdateTimeOut;
    unsigned long GroupUpdateCount;
    unsigned long PairwiseUpdateTimeOut;
    unsigned long PairwiseUpdateCount;
}
APICMDBUF_GET_RSN_CFG;

#if defined(WIPOD)
#define WIPOD_TYPE_AP 0x80
typedef enum
{
	WIPOD_MODE_CLIENT_BRIDGE = 0x01,
	WIPOD_MODE_AP = 0x82,
	WIPOD_MODE_REPEATER = 0x83,
	WIPOD_MODE_PT_2_PT = 0x84,
	WIPOD_MODE_PT_2_MULTIPT = 0x85
}
WIPOD_MODE;

typedef struct _APICMDBUF_GET_WIPOD_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use WIPOD_MODE enum */
	unsigned char  body[63];
}
APICMDBUF_GET_WIPOD_MODE;

typedef struct _APICMDBUF_SET_WIPOD_MODE
{
    APICMDHEADER;
    unsigned char mode; /* use WIPOD_MODE enum */
	unsigned char body[63];
}
APICMDBUF_SET_WIPOD_MODE;

typedef struct _APICMDBUF_WIPOD_REPEATER_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use WIPOD_MODE enum */
    unsigned char  macAddr1[6]; /* Set to all zero if not used */
	unsigned char  macAddr2[6]; /* Set to all zero if not used */
	unsigned char  enableApFunc; /* True, False */
}
APICMDBUF_WIPOD_REPEATER_MODE;

typedef struct _APICMDBUF_WIPOD_P2P_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use WIPOD_MODE enum */
	unsigned char  macAddr[6]; /* Set to all zero if not used */
}
APICMDBUF_WIPOD_P2P_MODE;

typedef struct _APICMDBUF_WIPOD_P2MP_MODE
{
    APICMDHEADER;
    unsigned char  mode; /* use WIPOD_MODE enum */
	unsigned char  macAddr1[6]; /* Set to all zero if not used */
	unsigned char  macAddr2[6]; /* Set to all zero if not used */
	unsigned char  macAddr3[6]; /* Set to all zero if not used */
	unsigned char  macAddr4[6]; /* Set to all zero if not used */
	unsigned char  macAddr5[6]; /* Set to all zero if not used */
	unsigned char  macAddr6[6]; /* Set to all zero if not used */
	unsigned char  enableDynamic; /* True or False */
}
APICMDBUF_WIPOD_P2MP_MODE;

#endif /* WIPOD */

/*EVENTS MESSAGES */
typedef struct _APEVT_STA_ASSOC_TYPE
{
    unsigned short evtCode;
    unsigned short evtBodyLen;
    unsigned long evtTimeStamp;
    unsigned char staMACAddress[6];
    unsigned short assocType;
}
APEVT_STA_ASSOC_TYPE;


typedef enum{
    APEVT_STA_AUTHENTICATED,
    APEVT_STA_ASSOCIATED,
    APEVT_STA_DEAUTHENTICATED,
    APEVT_STA_DISASSOCIATED,
    APEVT_STA_AUTHENTICATE_FAIL,
}STA_ASSOC_TYPE;

typedef struct _ApEvtMsg
{
    UINT16 evtCode;
    UINT16 evtBodyLen;
    UINT32 evtTimeStamp;
    UINT8 *evtBody;
}
ApEvtMsg_t;

typedef enum
{
    APEVT_RST_BTN_PRESSED = 1,
    APEVT_ETH_PORT_STATUS_CHANGE = (1 << 1),
    APEVT_STA_ASSOC = (1 << 2),
#ifdef WDS_FEATURE
    APEVT_UNKNOWN_WDS_ROUTE = (1 << 3)
#endif /* WDS_FEATURE*/
}APEVT;

#ifdef AP_SITE_SURVEY
typedef struct _APICMDBUF_GET_SURVEY_INFO
{
    unsigned short cmdCode;
    unsigned short seqNum;
    unsigned short cmdStatus;
    unsigned short cmdBodyLen;
    unsigned char  busyScan;
    unsigned char  maxEntry;
    unsigned char  *infoAddr;

}APICMDBUF_GET_SURVEY_INFO;

typedef struct _API_SURVEY_ENTRY
{
   unsigned char dirty;
   unsigned char BssId[6];
   unsigned char SsId[32];
   unsigned char RSSI;
   unsigned char channel;
   unsigned char IBSS:1;
   unsigned char wepEnabled:1;
   unsigned char B_Support:1;
   unsigned char G_Support:1;
   unsigned char wpaEnabled:1;
   unsigned char reserve:3;

}API_SURVEY_ENTRY;
#endif /* AP_SITE_SURVEY */

/* maximum events */
#define API_EVENT_MAX_EVENT 3

/* maximun subscribers */
#define API_EVENT_MAX_SUB 2*API_EVENT_MAX_EVENT 
/*
 ** apEvtSub
 *
 *  PARAMETERS: 
 *      eventSet - the set of events the caller want to subcribe. This parameter is a bit map
 *          each bit corresponds to an event type. Set the bit to 1 to subscribe for the event
 *      *evtCbFunc - Pointer to the callback function
 *      pSubID - Pointer to the variable that will receive the subscription ID. The caller must 
 *          save the subscription ID for later use to unscribe for the event
 *
 *  DESCRIPTION:
 *
 *  RETURNS: TRUE - the subscription is successful
 *           FALSE - the subscription fail
 *
 */
BOOLEAN apEvtSub(unsigned long eventSet, void (*evtCbFunc)(ApEvtMsg_t *), unsigned int *pSubID);

/*
 ** apEvtUnsub
 *
 *  PARAMETERS:
 *      eventSet - the set of events the caller want to subcribe. This parameter is a bit map
 *          each bit corresponds to an event type. Set the bit to 1 to subscribe for the event
 *      subID - the subscription ID
 *
 *  DESCRIPTION:
 *
 *  RETURNS: TRUE - the unsubscription is successful
 *           FALSE - the unsubscription fail
 *
 */
BOOLEAN apEvtUnsub(unsigned long eventSet, unsigned int subID);

/* Timer API */
/**
 * Create a periodic timer. The callback function will run in the
 * Delayed Service Routine of the real-time clock interrupt.
 * 
 * @param period  The period in 100 milliseconds
 * @param timerCb The callback function
 * @return 0: failed to create timer because exceed maximum
 *         number of timers supported
 *         >0: the timer index, to be used in
 *         subsequent call to apctlTimerDelete()
 */
unsigned long apctlTimerCreate(int period, void (*timerCb)(UINT8 *));

/**
 * Delete a timer
 * 
 * @param timerIndex The timer index returned by apctlTimerCreate()
 * @return TRUE: success
 *         FALSE: failure because timer index is invalid
 */
int apctlTimerDelete(unsigned long timerIndex);

/* Interrupt control API */

/**
 * Get interrupt enable status
 * 
 * @return Interrupt status
 */
int apctlGetIntStatus(void);

/**
 * Enable all interrupts
 * 
 * @param status Status word returned by apctlIntDisable()
 * @return Interrupt status
 */
int apctlIntEnable(int status);
/**
 * Disable all interrupts
 * 
 * @return Interrupt status
 */
int apctlIntDisable(void);

/* GPIO control API */

/**
 * Initialize the GPIO pin for output or input
 * 
 * @param dirMap The GPIO direction bit map.
 *               Bit set to 1: the corresponding GPIO pin is configured
 *               for input.
 *               Bit set to 0: the corresponding GPIO pin is configured
 *               for output
 */
void apctlGPIOInit(unsigned long dirMap);

/**
 * Read the state of a GPIO pin
 * 
 * @param gpioNum the GPIO pin number
 * @return 0: GPIO state is "low"
 *         1: GPIO state is "high"
 *        -1: Error: invalid GPIO number
 */
int apctlGPIORead(int gpioNum);

/**
 * Set the state of a GPIO pin. The new GPIO state
 * after write is returned.
 * 
 * @param gpioNum The GPIO pin number
 * @param state   The state to set:
 *                0: set to "low"
 *                1: set to "high"
 * @return 0: the GPIO state is "low"
 *         1: the GPIO state is "high"
 *        -1: Error: invalid GPIO number
 *        -2: Error: GPIO pin is in input mode
 */
int apctlGPIOWrite(int gpioNum, int state);

/**
 * Enable SW LED brinking function
 * 
 * @param gpioport The GPIO pin number 0 - 15
 * 
 * @return none
 */
void apctlSwLedEnable(unsigned char gpioport);

/**
 * Disable SW LED brinking function
 * 
 * @param gpioport The GPIO pin number 0 - 15
 * 
 * @return none
 */
unsigned char apctlSwLedDisable(unsigned char gpioport);

/**
 * Set the SW led brinking cycle and duty cycle
 * 
 * @param gpioport The GPIO pin number 0 - 15
 * @param cycle   0 - 37ms
 *                1 - 74ms
 *                2 - 149ms
 *                3 - 298ms
 *                4 - 596ms
 *                5 - 1192ms
 *                6 & up reserved
 * @param duty    0 - 1/2
 *                1 - 1/4
 *                2 - 1/8
 *                3 - 1/16
 *                4 - 1/32
 *                5 & up reserved
 * 
 * @return none
 */
void apctlSwLedSetCycle(unsigned char gpioport, unsigned int cycle, unsigned int duty);




extern unsigned int packet_cnt[2];

#define ADD_ETHERDATA_CNT(x) ( packet_cnt[0] += x);

#define ADD_WLANDATA_CNT(x)  ( packet_cnt[1] += x);

#ifdef WDS_FEATURE
/*macroes used in apio_wirelessRead()*/
#define APIO_WLAREAD_NO_PACKET		0
#define APIO_WLAREAD_PACKET_BSS		1
#define APIO_WLAREAD_PACKET_WDS		2
#endif /* WDS_FEATURE*/

#endif /* _SMEMAIN_H_ */




