/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/src/cache.c,v 1.3 2004/06/16 18:36:20 jshen Exp $
*
* Purpose:
*    This file provides functions to enable and disable cache.
*
* Public Procedures:
*    None.
*
* Private Procedures:
*    None.
*
* Notes:
*    None.
*
*****************************************************************************/
extern void iCacheEnable(void);
void cacheenable(void);
void cachedisable(void);
void cacheenable(void)
{
    asm("	mov	r3,#0x80");
    asm("	mcr	p15, 0, r3, c2, c0, 1   @ inst cache region 7 enable");
}
void cachedisable(void)
{
    asm("	mov	r3,#0x0");
    asm("	mcr	p15, 0, r3, c2, c0, 1   @ inst cache region 7 disable");
}
void iCacheEnable(void)
{

    asm(".equ	Protection_Unit_Enable,	(1 << 0)");

    asm(".equ	D_Cache_Enable,		(1 << 2)");
    asm(".equ	Big_Endian_Enable,	(1 << 7)");
    asm(".equ	I_Cache_Enable,		(1 << 12)");
    asm(".equ    DSRAM_Enable,		(1 << 16)");
    asm(".equ	ISRAM_Enable,		(1 << 18)");
    asm(".equ	ISRAM_Load,		(1 << 19)");

    asm(".equ	Mode_USR,        	0x10");
    asm(".equ	Mode_FIQ,             0x11");
    asm(".equ	Mode_IRQ,             0x12");
    asm(".equ	Mode_SVC,             0x13");
    asm(".equ	Mode_ABT,             0x17");
    asm(".equ	Mode_UNDEF,           0x1B");
    asm(".equ	Mode_SYS,             0x1F @ available on ARM Arch 4 and later");

    asm(".equ	I_Bit,                0x80 @ when I bit is set, IRQ is disabled");
    asm(".equ	F_Bit,                0x40 @ when F bit is set, FIQ is disabled");




    asm(".equ DSRAM_Start,            0x98000000");
    asm(".equ DSRAM_Limit,            DSRAM_Start + (8*1024)");

    asm(".equ TCM_8k,		       (4 << 1)");
    asm(".equ ISRAM_Limit,            0x0 + (128*1024)");
    asm(".equ ISRAM_Start,            0x0");

    asm(".equ SVC_Stack,              DSRAM_Limit           @ SVC stack at top of DSRAM");
    asm(".equ IRQ_Stack,              DSRAM_Limit - 0x400   @ IRQ stack at top of DSRAM - 0x400");
    /*asm("@ add FIQ_Stack, ABT_Stack, UNDEF_Stack here if you need them"); */
    asm(".equ USR_Stack,              DSRAM_Limit - 0x800");

    asm("	.globl low_level_init");
    asm("low_level_init:");
    /*asm("	@@ Manipulate cp15 to enable the cache"); */
    asm("	mov	r3,#0");
    asm("	mcr	p15, 0, r3, c7, c5, 0   @ flush I-cache");
    asm("	mcr	p15, 0, r3, c7, c6, 0   @ flush D-cache");

    asm("	mrc	p15, 0, r3, c1, c0, 0");
    asm("	bic	r3, r3, #Protection_Unit_Enable");
    asm("	mcr	p15, 0, r3, c1, c0, 0");

    /*asm("@ region 0"); */
    asm("	ldr	r3,=(0xffc00000 | (0x15 << 1) | 1)	@ 4MB & enable @ffc00000");
    asm("	mcr	p15, 0, r3, c6, c0, 0   @ protection enabled");

    /*asm("@ region 1"); */
    asm("	ldr	r3,=(0xd0000000 | (0x16 << 1) | 1)	@ 8MB & enable @d0000000");
    asm("	mcr	p15, 0, r3, c6, c1, 0   @ protection enabled");

    /*asm("@ region 2"); */
    asm("	ldr	r3,=(0x0 | (0x10 << 1) | 1)	        @ 128kB & enable @0");
    asm("	mcr	p15, 0, r3, c6, c2, 0   @ protection enabled");

    /*asm("@ region 3"); */
    asm("	ldr	r3,=(0x90008000 | (0x10 << 1) | 1)	        @ 128kB & enable @0x90008000");
    asm("	mcr	p15, 0, r3, c6, c3, 0   @ protection enabled");

    /*asm("@ region 4"); */
    asm("	ldr	r3,=(0xc0000000 | (0xf << 1) | 1)	        @ 64kB & enable @0xc0000000");
    asm("	mcr	p15, 0, r3, c6, c4, 0   @ protection enabled");

    /*asm("@ region 5"); */
    asm("	ldr	r3,=(0x80000000 | (0x10 << 1) | 1)	        @ 128kB & enable @0x80000000");
    asm("	mcr	p15, 0, r3, c6, c5, 0   @ protection enabled");

    /*asm("@ region 6"); */
    asm("	ldr	r3,=(0x98000000 | (0xc << 1) | 1)	        @ 8kB & enable @0x98000000");
    asm("	mcr	p15, 0, r3, c6, c6, 0   @ protection enabled");

    /*asm("@ region 7"); */
    /*asm("	ldr	r3,=(0xd0000000 | (0x13 << 1) | 1)		@ 1MB & enable @d0000000"); */
    asm("	ldr	r3,=(0xd0000000 | (0x13 << 1) | 1)		@ 1MB & enable @d0000000");
    asm("	mcr	p15, 0, r3, c6, c7, 0   @ protection disabled ");

    asm("	ldr	r3,=(0x3 << 28) | (0x3 << 24) | (0x3 << 20) | (0x3 << 16) | (0x3 << 12) | (0x3 << 8) | (0x3 << 4) | 3 	@ r6:RW, r5:RW, r4:RW, r3:RW, r2: RW, r1: RW, r0: RW data");
    asm("	mcr	p15, 0, r3, c5, c0, 2   @ data prot");

    asm("	ldr	r3,=(0x6 << 28) | (0x0 << 24) | (0x0 << 20 ) | (0x6 << 16) | (0x0 << 12) | (0x6 << 8) | (0x6 << 4) | 6 	@ r6:- r5:-, r4:R, r3:X, r2: R, r1: R, r0: R code");
    asm("	mcr	p15, 0, r3, c5, c0, 3   @ inst prot");

    asm("	LDR	r3,=(I_Cache_Enable | ISRAM_Enable | DSRAM_Enable | Protection_Unit_Enable)");
    asm("	mcr	p15, 0, r3, c1, c0, 0");

    /*asm("	@@ Data cache is disabled"); */
    asm("	mov	r3,#0x0");
    asm("	mcr	p15, 0, r3, c2, c0, 0   @ data cache region 0 enable");

    asm("	mov	r3,#0x80");
    asm("	mcr	p15, 0, r3, c2, c0, 1   @ inst cache region 7 enable");

    asm("	bx	r14");

    /*asm("	.end"); */
}


