#include "domain.h"
#include "apcfg.h"
#include "oem.h"
#include "wltypes.h"
#include "IEEE_types.h"
#include "timer.h"
#include "wl_mib.h"
#include "wl_hal.h"

typedef struct _DOMAIN
{
    UINT8 domainCode;
    UINT8 minChannel;
    UINT8 maxChannel;
    UINT8 defaultChannel;
}
DOMAIN;

DOMAIN regatory_domain[] =
{
    {DOMAIN_CODE_FCC, 1, 11, 6},
    {DOMAIN_CODE_IC, 1, 11, 6},
    {DOMAIN_CODE_ETSI, 1, 13, 11},
    {DOMAIN_CODE_SPAIN, 10, 11, 11},
    {DOMAIN_CODE_FRANCE, 10, 13, 11},
    {DOMAIN_CODE_MKK, 1, 14, 14},
    {DOAMIN_CODE_ISRAEL, 5, 8, 6},
    {0, 0, 0, 0}
};

/*
 ** domainGetInfo
 *
 *  FILENAME: D:\jshen\802.11_MAC-DRIVER_SW\AP\Src\domain.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
WL_STATUS domainGetInfo(UINT8 *minChannel, UINT8 *maxChannel, UINT8 *defaultChannel)
{
    int i = 0;
    UINT8 domainCode;
    MFG_CAL_DATA *mfg;
#ifdef EEPROM
    mfg = GetCalData();
#else
    mfg = (MFG_CAL_DATA *)(MFG_DATA_ADDRESS);
#endif
    domainCode = mfg->Domain;

    while (regatory_domain[i].domainCode)
    {
        if (domainCode == regatory_domain[i].domainCode)
        {
            *minChannel = regatory_domain[i].minChannel;
            *maxChannel = regatory_domain[i].maxChannel;
            *defaultChannel = regatory_domain[i].defaultChannel;
            return OS_SUCCESS;
        }
        i++;
    }
    return OS_FAIL;
}

UINT8 domainGetCode(void)
{

    int i = 0;
    UINT8 domainCode;
    MFG_CAL_DATA *mfg;
#ifdef EEPROM
    mfg = GetCalData();
#else
    mfg = (MFG_CAL_DATA *)(MFG_DATA_ADDRESS);
#endif
    domainCode = mfg->Domain;

    while (regatory_domain[i].domainCode)
    {
        if (domainCode == regatory_domain[i].domainCode)
        {
            return domainCode;
        }
        i++;
    }
    return -1;
}

