/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/src/hw.c,v 1.21 2004/03/15 00:04:17 ctlaw Exp $ 
* 
* Purpose: 
* 
* Public Procedures: 
* 
* Private Procedures: 
* 
* Notes: 
*    None. 
* 
*****************************************************************************/

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "buildModes.h"
#include "IEEE_types.h"
#include "tkip.h"
#include "StaDb.h"
#include "osif.h"
#include "macmgmtap.h"
#include "macMgmtMlme.h"
#include "sysinfo.h"
#include "memmap.h"
#include "rx80211.h"
#include "tx80211.h"
#include "ds.h"
#include "ether.h"
#include "txsched.h"
#include "ap_mib.h"

#include "wltypes.h"
#include "bufmgt.h"
#include "wl_macros.h"
#include "isr.h"
#include "wlmac.h"

#ifndef UINT32
    #define UINT32 UINT32
#endif

#ifndef UINT16
    #define UINT16 UINT16
#endif

#ifndef UINT8
    #define UINT8 UINT8
#endif

#define SZ_PHY_ADDR 6
extern QHANDLE ethRxQ, ethTxQ, wlRxQ, wlTxQ;
#define PLL_SWITCH_IN_ITCM  1 
/*============================================================================= */
/*                                DEFINITIONS */
/*============================================================================= */
#define ALIGN4BYTE(x)   (x = (( x+4-1)/4) * 4)

#ifndef SQRAM_ONLY
    #define RXDATA_NFRAG_BUFSIZE   (63 * 1024)  /* 40Kbytes) */
    #define RXMGMT_NFRAG_BUFSIZE  (8 * 1024)   /* 1 Kytes */
    #define RX_FRAG0_BUFSIZE   (20 * 1024)   /* 3 Kbytes */
    #define RX_FRAG1_BUFSIZE   (20 * 1024)   /* 3 Kbytes */
    #define RX_FRAG2_BUFSIZE   (20 * 1024)   /* 3 Kbytes */
    #define RX_BCN_BUFSIZE     (16 * 1024)
#else
    #define RXDATA_NFRAG_BUFSIZE   (4 * 1024)  /* 40Kbytes) */
    #define RXMGMT_NFRAG_BUFSIZE  (1 * 1024)   /* 1 Kytes */
    #define RX_FRAG0_BUFSIZE   (1 * 1024)   /* 3 Kbytes */
    #define RX_FRAG1_BUFSIZE   (1 * 1024)   /* 3 Kbytes */
    #define RX_FRAG2_BUFSIZE   (1 * 1024)   /* 3 Kbytes */
    #define RX_BCN_BUFSIZE     (1 * 1024)
#endif


/*============================================================================= */
/*                             GLOBAL VARIABLES */
/*============================================================================= */
extern void IsrCreate(void);
extern void IsrAttach(void);
extern void Reset(void);
extern void TxMDS_BufReset(void);
extern UINT32 getFwMode (void);

UINT8   *ethAllocBuf(UINT32 align, UINT32 size);
BOOLEAN ethFreeBuf(void *dataPtr);

extern UINT8* allocMemTest0(UINT32 allign, UINT32 size);

extern txInfo_t *BcnTxInfo;

extern txBcnInfo_t *PrbRspTxInfo;
extern MIB_AUTH_ALG mib_AuthAlg;
extern unsigned long WepTypeAll;
UINT32 RxNF0BufBase, RxNF0BufEnd, RxNF1BufBase, RxNF1BufEnd,
RxNF2BufBase, RxNF2BufEnd;
UINT32 RxMRdPtr = 0;
UINT32 RxDRdPtr = 0;
UINT32 RxDropDRdPtr;  /* Used in workaround for the hw rx packet problem that
                       * occurs at wrap around boundary */


/* Table of Read Pointer Registers for each queue, indexed by TC0_QID..DONE_QID */
static UINT32 rdPtrRegList[MAX_QID] = {
    TX_TCQ0_RDPTR, TX_TCQ1_RDPTR, TX_TCQ2_RDPTR, TX_TCQ3_RDPTR,
    TX_TCQ4_RDPTR, TX_TCQ5_RDPTR, TX_TCQ6_RDPTR, TX_TCQ7_RDPTR,
    TX_CM_RDPTR,   TX_BW_RDPTR,   TX_PS_RDPTR,   TX_CF_RDPTR,
    TX_MC_RDPTR,   TX_DONE_RDPTR
};

/* Table of Write Pointer Registers for each queue, indexed by TC0_QID..DONE_QID */
static UINT32 wrPtrRegList[MAX_QID] = {
    TX_TCQ0_WRPTR, TX_TCQ1_WRPTR, TX_TCQ2_WRPTR, TX_TCQ3_WRPTR,
    TX_TCQ4_WRPTR, TX_TCQ5_WRPTR, TX_TCQ6_WRPTR, TX_TCQ7_WRPTR,
    TX_CM_WRPTR,   TX_BW_WRPTR,   TX_PS_WRPTR,   TX_CF_WRPTR,
    TX_MC_WRPTR,   TX_DONE_WRPTR
};

#ifdef ECOS
UINT32 TxQSpace[14 * 64+ 1024]__attribute__ ((section (".sqbuf")));
/* 14 Queues, each with length 64 entries
 * or 256 bytes , 512 words are added for
 * alignment */


#ifdef SQRAM_ONLY
UINT32 RxDataNFragBuf[RXDATA_NFRAG_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
UINT32 RxMgmtNFragBuf[RXMGMT_NFRAG_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
UINT32 RxFrag0Buf[RX_FRAG0_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
UINT32 RxFrag1Buf[RX_FRAG1_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
UINT32 RxFrag2Buf[RX_FRAG2_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
UINT32 RxBcnBuf[RX_BCN_BUFSIZE/4] __attribute__ ((section (".sqbuf")));
#else
UINT32 RxDataNFragBuf[RXDATA_NFRAG_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
UINT32 RxMgmtNFragBuf[RXMGMT_NFRAG_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
UINT32 RxFrag0Buf[RX_FRAG0_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
UINT32 RxFrag1Buf[RX_FRAG1_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
UINT32 RxFrag2Buf[RX_FRAG2_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
UINT32 RxBcnBuf[RX_BCN_BUFSIZE / 4] __attribute__ ((section (".sdbuf")));
#endif

UINT32 *pRxDataNFragBuf = &RxDataNFragBuf[0];
UINT32 *pRxMgmtNFragBuf = &RxMgmtNFragBuf[0];
UINT32 *pRxFrag0Buf     = &RxFrag0Buf[0];
UINT32 *pRxFrag1Buf     = &RxFrag1Buf[0];
UINT32 *pRxFrag2Buf     = &RxFrag2Buf[0];
UINT32 *pRxBcnBuf       = &RxBcnBuf[0];
#endif /* ECOS */




UINT16 PhyRates[IEEEtypes_MAX_DATA_RATES_G] = {2,4,11,22,44,12,18,24,36,48,72,96,108,144};

/* Values are copied from the phy mib and in the
* same order as they are programmed in the Rate 
* registers. The index in the array will be used
* to specify the rate in the TxInfo structure
* for easy comparision with MLME primitive date
* the values are stored in units of 500kbits,
* In the registers, it will in units of 100kbits
*/

/*============================================================================= */
/*                         CODED PUBLIC PROCEDURES */
/*============================================================================= */

extern void InitWep(int);
/******************************************************************************
 * 
 * Name: 
 * 
 * Description: 
 * 
 * Conditions For Use: 
 * 
 * Arguments: 
 * 
 * Return Value: 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/

void hw_Init(void)
{

#ifdef ECOS
    IsrCreate();
    IsrAttach();
#endif

    msi_wl_InitSpecHw();
    InitWep(mib_defaultkeyindex);

#ifndef ONTHEFLY_DECRYPT_DISABLED
    if ( (mib_StaCfg_p->PrivOption && mib_PrivacyTable_p->PrivInvoked ) )
    {
        /*WL_REGS8_SETBITS(RX_WEP_ENABLE, 1); */
        msi_wl_EnableRxWEP(TRUE);
    }
    else
    {
        /*WL_REGS8_CLRBITS(RX_WEP_ENABLE, 1); */
        msi_wl_EnableRxWEP(FALSE);
    }

    if (WepTypeAll == 2)
        /*WL_REGS32_SETBITS(RX_WEP_ENABLE, 0x2); */
        msi_wl_EnableRxWEP104bit();
    else
        msi_wl_EnableRxWEP40bit();

    if (mib_PrivacyTable_p->RSNEnabled)
    {
        WL_WRITE_WORD(RX_WEP_ENABLE, 0x07);
        WL_WRITE_WORD(RX_AES_MODE_LO,0xffffffff);
        WL_WRITE_WORD(RX_AES_MODE_HI,0xffffffff);
    }
#else

    /*WL_WRITE_WORD(RX_WEP_ENABLE, 0x5); */
    /* AES mode passes the data undecrypted */
    msi_wl_EnableRxWEP(TRUE);
    msi_wl_EnableRxWEP104bit();
    msi_wl_EnableRxWEPAESMode(TRUE);
    WL_WRITE_WORD(RX_AES_MODE_LO,0xffffffff);
    WL_WRITE_WORD(RX_AES_MODE_HI,0xffffffff);


#endif


    /* Enable wireless mac interrupts. */
    msi_wl_SetWLMacIntrMask(MSK_INTERRUPT_ENABLE);

    WDSInit();

    /* Enable all bits for clear on read. */
    msi_wl_SetWLMacRsrIntrMask(RSR_CLEAR_ON_READ_ALL);
#ifndef WEP_IN_INTR_MODE
    WL_REGS32_CLRBITS(MIR_INTR_MASK, TXWEP_DONE);
#endif


    /* Set wireless transmit watchdog. */
    msi_wl_SetWLMacTransmitWatchDog(0x1000);

}

/******************************************************************************
 * 
 * Name: hw_GetPhyRateIndex
 * 
 * Description: 
 * 
 * Conditions For Use: 
 * 
 * Arguments: 
 *      Rate  (i)  - Specified in 500k bits/sec
 * 
 * Return Value: 
 *      Returns the index ( 0 ...7) to the DataRate Reg that has the
 *      passed rate programmed in.
 * 
 * Notes: 
 *   This function is also used to check if a Given Rate is supported
 *   by the Phy layer. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/

UINT32 hw_GetPhyRxRateIndex(RxSign_t *RxSign_p)
{
    UINT32 i, RegRate,RateCode,RxParam; 
    RateCode = RxSign_p->Rate ;
    RxParam = RxSign_p->RxParam;
    for (i=0; i < IEEEtypes_MAX_DATA_RATES_G-1; i++)
    {

        WL_READ_WORD((TX_DATA_RATE0 + (i *4)), RegRate) ;
        if (RegRate == RateCode)
        {
            /* The follwoing code takes care of the fact that value 0xA occurs in two
             * places in the register set, once for 1M and once for a G rate */
            if ( i != 0 && i != 7 )
            {
                return i;
            }
            else
            {
                if ((i == 0) && (RxParam & 1))   /*  CCK  */
                    return i;
                else if ((i == 7)  && (RxParam & 0))  /* OFDM */
                    return i;
                else
                    continue ;
            }

        }

    }

    return(IEEEtypes_MAX_DATA_RATES_G+1);

}
UINT32 hw_GetPhyRateIndex(UINT32 Rate)
{
    UINT32 i, RegRate; 

    for (i=0; i < IEEEtypes_MAX_DATA_RATES_G-1; i++)
    {


        if (PhyRates[i] == Rate)
        {
            return i;
        }

    }

    return(IEEEtypes_MAX_DATA_RATES_G+1);

}


/*
 ** WatchdogEnable
 *
 *  FILENAME: eaglehw.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void WatchdogEnable(void)
{
#ifdef WATCHDOG_ENABLE
    WL_WRITE_WORD(WL_LBU_PMU_WDG_INTVL, (WATCHDOG_TIMER_INTERVAL_IN_SECONDS & 0x0003 - 1)); /*maxmimum 4 sec */
    WL_WRITE_WORD(WL_LBU_PMU_CTRL, WL_REGS32(WL_LBU_PMU_CTRL) | 0x0001);
#endif
}
/*
 ** WatchdogDisable
 *
 *  FILENAME: eaglehw.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void WatchdogDisable(void)
{
#ifdef WATCHDOG_ENABLE
    WL_WRITE_WORD(WL_LBU_PMU_CTRL, WL_REGS32(WL_LBU_PMU_CTRL) & 0xfffe);
#endif
}
/*
 ** WatchdogReset
 *
 *  FILENAME: eaglehw.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void WatchdogReset(void)
{
#ifdef WATCHDOG_ENABLE
    WL_WRITE_WORD(WL_LBU_PMU_WDG_TIMER_CLEAR, 1);
#endif
}
void ResetRx(void)
{
os_EnterCriticalSection;
	 WL_WRITE_WORD(RX_DNF_RD_PTR, 0);
	 RxDRdPtr = 0;
    
    WL_WRITE_WORD(RX_MNF_RD_PTR, 0);
    
    RxMRdPtr = 0;    /* set global vars used in Rx Processing */

    WL_WRITE_WORD(RX_F0_RD_PTR, 0x00);
   
    WL_WRITE_WORD(RX_F1_RD_PTR, 0x00);
    
    WL_WRITE_WORD(RX_F2_RD_PTR, 0x00);
   

    /* initialise Fragment buffer info */

    WL_WRITE_WORD(MTD_MCU_RESET, RESET_RX);
os_ExitCriticalSection;
}

