/*******************************************************************************
 *                                                            
 *   roaming.c                                                
 *   Copy Righti(2001) Marvell Semiconductors, Inc.           
 *                                                            
 *                                                            
 *   Author(s):    Jiaqi Shen                                 
 *   Date:         2003-04-15                                 
 *   Description:  This module implemented a simple ap roaming handover feature       
 *                                          
 *******************************************************************************
 */
#include "wltypes.h" 
#include "ap_api.h"
#include "IEEE_types.h"
#include "dsport.h"

/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    The function will be called when a STA is associated to AP  
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/

void arprequest_for_handover(IEEEtypes_MacAddr_t *sa_ptr)
{
    apio_bufdescr_t BufDescr;
    /*IEEEtypes_MacAddr_t BcastAddr = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}; */
    if ((BufDescr.framePtr = (UINT8 *)apio_GetWlanTxBuf()) != NULL)
    {
        memset(BufDescr.framePtr, 0xff, sizeof(IEEEtypes_MacAddr_t));
        memcpy(BufDescr.framePtr+6, sa_ptr, sizeof(IEEEtypes_MacAddr_t));
        BufDescr.framePtr[12] = 0x08; /* IP ARP */
        BufDescr.framePtr[13] = 0x06; /* IP ARP */
        BufDescr.framePtr[14] = 0x00;
        BufDescr.framePtr[15] = 0x01; /* Hardware - 10M */
        BufDescr.framePtr[16] = 0x08;
        BufDescr.framePtr[17] = 0x00; /* Protocol - IP */
        BufDescr.framePtr[18] = 0x06; /* Hardware Address Length */
        BufDescr.framePtr[19] = 0x04; /* Protocol Address Length */
        BufDescr.framePtr[20] = 0x00;
        BufDescr.framePtr[21] = 0x01; /* Operation - ARP Request */
        memset(BufDescr.framePtr+22, 0, 48);
        BufDescr.frameLen = 60;
        dsPort_Write(&BufDescr);
    }
}

/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    The function below will be called if broadcast packet received from ether port 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
int Check_ArpRequest_for_Handover(IEEEtypes_8023_Frame_t  *DataEtherFrame_p)
{
    if (DataEtherFrame_p->Hdr.type == 0x0608 && /*IP ARP */
        DataEtherFrame_p->Body[6] == 0 && DataEtherFrame_p->Body[7] == 1) /*ARP request */
    {
        extStaDb_RemoveSta(DataEtherFrame_p->Hdr.sa);
        return 1;
    }
    return 0;
}
