/*#define TEST_PAGE		1 */

#define RETCODE_OK				200
#define RETCODE_BAD_REQ			400
#define RETCODE_INT_ERR			500

#define RF_PAGE			0
#define SUBMIT_CHANGE	1
#define START_TX_CONT	2
#define STOP_TX_CONT	3
#define START_RX_SEN	4
#define STOP_RX_SEN		5
#define START_CW_TX		6
#define STOP_CW_TX		7
#define START_CAR_SUP	8
#define STOP_CAR_SUP	9

#define AUTO_SELECT		0
#define NUM_DATA_RATE	5
#define RATE_1MBPS		0x0A	/* 2 */
#define RATE_2MBPS		0x14	/* 4 */
#define RATE_5_5MBPS	0x37	/* 11 */
#define RATE_11MBPS		0x6E	/* 22 */
#define RATE_22MBPS		0xDC	/* 44 */

#define MIN_PWR_LVL		0 /*4 */
#define MAX_PWR_LVL		20 /*24 */
#define PWL_LVL_OFFSET	0 /*4		MIN_POWER_LEVEL = 4 dBm */
#define PWR_TBL_SIZE	(MAX_PWR_LVL-MIN_PWR_LVL+1)

#define ANTENNA_SEL_SIZE    3

#define TX_VGA_OFFSET		10
#define PADRV_OFFSET		8

/*typedef unsigned  char UCHAR;
typedef unsigned long ULONG;
typedef unsigned short USHORT;*/

int GetChannel();
void SetChannel(int);
int GetOutputPower();
void SetOutputPower(int); 
int GetTxDataRate();
void SetTxDataRate(int);
int GetBeaconInterval();
void SetBeaconInterval(int);
void SetTxAntenna(int);
void SetRxAntenna(int);
void SetPaGaGbIDrv(char_t* query);
void ToBinary(int, char*, int);

int RfTest(webs_t wp, char_t* query, unsigned char testMode);
void ChangeSetting(char_t* query);
void StartContTxTest();
void StopContTxTest();
void StartRxSensitivityTest();
unsigned long StopRxSensitivityTest();
void StartCwTxTest();
void StopCwTxTest();
void StartCarSupTest();
void StopCarSupTest();

unsigned char webReadRfReg(unsigned char index);
void webWriteRfReg(unsigned char index, unsigned char value);
unsigned char webReadBbReg(unsigned char index);
void webWriteBbReg(unsigned char index, unsigned char value);


extern unsigned long ReadMacReg(unsigned long index);
extern void WriteMacReg(unsigned long index, unsigned long value);
extern unsigned char ReadRfReg(unsigned char index);
extern void WriteRfReg(unsigned char index, unsigned char value);
extern unsigned char ReadBbReg(unsigned char index);
extern void WriteBbReg(unsigned char index, unsigned char value);
extern void W81_BBPInitAccess(void);
extern void W81_InitW8000Access(void);

unsigned short webDataRate[5] = {RATE_1MBPS, RATE_2MBPS, RATE_5_5MBPS, RATE_11MBPS,  RATE_22MBPS};

unsigned short OPT_EFFI_TABLE[PWR_TBL_SIZE] =
{	 /*0xXYZV, where X=PA-GA, Y=PA-GB, Z=PA-I, V=PA_DRV, X,Y,Z,V are hexadecimal digits */
	0x1414, 0x1514,								/* 4dBm - 5dBm */
	0x1614, 0x2414, 0x1814, 0x1A14, 0x1C14,		/* 6dBm - 10dBm */
	0x4414, 0x3614, 0x3714, 0x3914, 0x5614,		/* 11dBm - 15dBm */
	0x6614, 0x4B14, 0x7714, 0x5D14, 0x6A24,		/* 16dBm - 20dBm */
	0x6D24, 0x6B44, 0x6E44, 0x6F64				/* 21dBm - 24dBm */
};

unsigned short OPT_SPEC_MASK_TABLE[PWR_TBL_SIZE] =
{	/*0xXYZV, where X=PA-GA, Y=PA-GB, Z=PA-I, V=PA_DRV, X,Y,Z,V are hexadecimal digits */
	0x1513, 0x1713,								/* 4dBm - 5dBm */
	0x3313, 0x3323, 0x2613, 0x3513, 0x3613,		/* 6dBm - 10dBm */
	0x3713, 0x4613, 0x3A13, 0x3C13, 0x5813,		/* 11dBm - 15dBm */
	0x5A13, 0x6823, 0x5A33, 0x5C33, 0x5D43,		/* 16dBm - 20dBm */
	0x5E53, 0x6D63, 0x6F73, 0x7F73				/* 21dBm - 24dBm */
};
