#include "wltypes.h"
#include "IEEE_types.h"
#include	"wsIntrn.h"
#ifdef UEMF
	#include	"uemf.h"
#else
	#include	"../basic/basicInternal.h"
#endif

#include  "Mrvap.h"

void dummy_CmdProc(void) {
}

WL_STATUS ApCmdGetProc(UINT16 CmdCode, char *pResult)
{
	APICMDBUF *pBuf;
	WL_STATUS  nStatus;


	nStatus = STATUS_SUCCESS;

	switch (CmdCode)
	{
		case APCMD_GET_SSID:
		case APCMD_GET_FIRMWARE_VERSION:
			pBuf = malloc(sizeof (APICMDBUF)+50);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 50;
			
			apctl(pBuf);

			if (pBuf->cmdStatus == APCTL_OK)
			{
				strcpy((char*)pResult, pBuf->cmdBody); 
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free(pBuf->cmdBody);
			free(pBuf);
			break;
		case APCMD_GET_OPEN_SSID_EN_STATE:
				(APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf = malloc(sizeof (APICMDBUF_GET_OPEN_SSID_EN_STATE));
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_OPEN_SSID_EN_STATE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus == APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf)->openSSIDEnabled;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free((APICMDBUF_GET_OPEN_SSID_EN_STATE*)pBuf);
				break;
		case APCMD_GET_RF_CHANNEL:
			(APICMDBUF_GET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_GET_RF_CHANNEL));

				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RF_CHANNEL)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RF_CHANNEL*)pBuf)->curChanNum;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RF_CHANNEL*)pBuf);
				break;	
		case APCMD_GET_TX_POWER_LEVEL:
				(APICMDBUF_GET_TX_POWER_LEVEL*)pBuf = malloc(sizeof (APICMDBUF_GET_TX_POWER_LEVEL));

				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_TX_POWER_LEVEL)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, &(((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf)->txPowerLevel), 9);  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_TX_POWER_LEVEL*)pBuf);
				break;
		case APCMD_GET_BEACON_PERIOD:
				(APICMDBUF_GET_BEACON_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_GET_BEACON_PERIOD));

				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BEACON_PERIOD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((ULONG*)pResult) =  ((APICMDBUF_GET_BEACON_PERIOD*)pBuf)->beaconPeriod;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf);
				break;
		case APCMD_GET_DTIM_PERIOD:
				(APICMDBUF_GET_DTIM_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_GET_DTIM_PERIOD));

				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DTIM_PERIOD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((ULONG*)pResult) =  ((APICMDBUF_GET_DTIM_PERIOD*)pBuf)->dtimPeriod;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DTIM_PERIOD*)pBuf);
				break;
		case APCMD_GET_FRAG_THRESHOLD:
				(APICMDBUF_GET_FRAG_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_GET_FRAG_THRESHOLD));

				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_FRAG_THRESHOLD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf)->fragThreshold;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_FRAG_THRESHOLD*)pBuf);
				break;
		case APCMD_GET_RTS_THRESHOLD:
				(APICMDBUF_GET_RTS_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_GET_RTS_THRESHOLD));

				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RTS_THRESHOLD)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RTS_THRESHOLD*)pBuf)->rtsThreshold;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RTS_THRESHOLD*)pBuf);
				break;
		case APCMD_GET_DATA_RETRY_LIMIT:
				(APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_GET_DATA_RETRY_LIMIT));

				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DATA_RETRY_LIMIT)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf)->dataRetryLimit;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DATA_RETRY_LIMIT*)pBuf);
				break;
		case APCMD_GET_RTS_RETRY_LIMIT:
				(APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_GET_RTS_RETRY_LIMIT));

				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RTS_RETRY_LIMIT)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf)->rtsRetryLimit;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_RTS_RETRY_LIMIT*)pBuf);
				break;
		case APCMD_GET_RF_PREAMBLE_OPTION:
				(APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf = malloc(sizeof (APICMBUF_GET_RF_PREAMBLE_OPTION));

				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->seqNum = 1;
				((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMBUF_GET_RF_PREAMBLE_OPTION)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((char*)pResult) =  ((APICMBUF_GET_RF_PREAMBLE_OPTION*)pBuf)->rfPreambleOption;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf);
				break;
		case APCMD_GET_ANTENNA_MODE:
				(APICMDBUF_GET_ANTENNA_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_ANTENNA_MODE));

				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ANTENNA_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->rxAntennaMode |
								(((APICMDBUF_GET_ANTENNA_MODE*)pBuf)->txAntennaMode << 4);
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_ANTENNA_MODE*)pBuf);
				break;
		case APCMD_GET_TX_DATA_RATE:
        case APCMD_GET_TX_DATA_RATE_G:
				(APICMDBUF_GET_TX_DATA_RATE*)pBuf = malloc(sizeof (APICMDBUF_GET_TX_DATA_RATE));
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->seqNum= 1;
				((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_TX_DATA_RATE)-BUF_HDR_LEN;
				
				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult =  ((APICMDBUF_GET_TX_DATA_RATE*)pBuf)->txDataRate;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_TX_DATA_RATE*)pBuf);
				break;
	/*	case APCMD_GET_SUP_DATA_RATES: */
		case APCMD_GET_BASIC_DATA_RATES:
				(APICMDBUF_GET_BASIC_DATA_RATES*)pBuf = malloc(sizeof (APICMDBUF_GET_BASIC_DATA_RATES));

				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BASIC_DATA_RATES)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf)->basicDataRates, 14);  
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free ((APICMDBUF_GET_BASIC_DATA_RATES*)pBuf);
			break;
	case APCMD_GET_AUTH_MODE:
				(APICMDBUF_GET_AUTH_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_AUTH_MODE));

				((APICMDBUF_GET_AUTH_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_AUTH_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_AUTH_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AUTH_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_AUTH_MODE*)pBuf)->authMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_AUTH_MODE*)pBuf);
				break;
		case APCMD_GET_PRIVACY_OPTION:
				(APICMDBUF_GET_PRIVACY_OPTION*)pBuf = malloc(sizeof (APICMDBUF_GET_PRIVACY_OPTION));

				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_PRIVACY_OPTION)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*pResult = ((APICMDBUF_GET_PRIVACY_OPTION*)pBuf)->dataEncrypt;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_PRIVACY_OPTION*)pBuf);
				break;
		case APCMD_GET_DEFAULT_WEP_KEYS:
				(APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf = malloc(sizeof (APICMDBUF_GET_DEFAULT_WEP_KEYS));

				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_DEFAULT_WEP_KEYS)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, &(((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf)->keyindex), sizeof (WEP_KEY));  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_DEFAULT_WEP_KEYS*)pBuf);
				break;
		case APCMD_GET_STA_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+ (*((USHORT*)pResult)));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = *((USHORT*)pResult);
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);;		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else if (pBuf->cmdStatus==APCTL_BUF_TOO_SMALL)
				{
					*((USHORT*)pResult) = pBuf->cmdBodyLen;
					nStatus = STATUS_BUFFER_TOO_SMALL;
				}else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_WLAN_FILTER_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+(*((USHORT*)pResult)));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = *((USHORT*)pResult);
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else if (pBuf->cmdStatus==APCTL_BUF_TOO_SMALL)
				{
					*((USHORT*)pResult) = pBuf->cmdBodyLen;
					nStatus = STATUS_BUFFER_TOO_SMALL;
				}else
				{
					nStatus = STATUS_FAIL;
				}
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
       case APCMD_GET_WLAN_FILTER_MODE:
            ((APICMDBUF_FILTER_MODE *)pBuf) = malloc(sizeof (APICMDBUF_FILTER_MODE));
            ((APICMDBUF_FILTER_MODE *)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_FILTER_MODE *)pBuf)->seqNum = 1;
            ((APICMDBUF_FILTER_MODE *)pBuf)->cmdBodyLen = 1;
			  	apctl(pBuf);
            if (((APICMDBUF_FILTER_MODE *)pBuf)->cmdStatus==APCTL_OK)
				{
                *pResult = ((APICMDBUF_FILTER_MODE *)pBuf)->mode;
            }else
				{
					nStatus = STATUS_FAIL;
				}
            free (((APICMDBUF_FILTER_MODE *)pBuf));
				break;
		case APCMD_GET_ETH_IP_CONFIG:
				(APICMDBUF_GET_ETH_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_GET_ETH_IP_CONFIG));

				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_ETH_IP_CONFIG)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, (UCHAR*)&(((APICMDBUF_GET_ETH_IP_CONFIG *)pBuf)->dhcpEnabled), 16);  
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_ETH_IP_CONFIG*)pBuf);
				break;
		case APCMD_GET_PRIVACY_TBL_RSN_ENABLED:
				(APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf = malloc(sizeof (APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED));
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((UCHAR*)pResult) = ((APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED*)pBuf)->Enabled;
				}
				else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_RSN_CFG_AUTH_SUITE:
				(APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG_AUTH_SUITE));
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_AUTH_SUITE)-BUF_HDR_LEN;
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((UCHAR*)pResult  ) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[0];
					*((UCHAR*)pResult+1) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[1];
					*((UCHAR*)pResult+2) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[2];
					*((UCHAR*)pResult+3) = ((APICMDBUF_GET_RSN_CFG_AUTH_SUITE*)pBuf)->AuthSuites[3];
				}
				else
				{
					*((USHORT*)pResult) = 0;
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_RSN_STATS:
				(APICMDBUF_GET_RSN_STATS*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_STATS));
				((APICMDBUF_GET_RSN_STATS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RSN_STATS*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RSN_STATS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_STATS)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_RSN_STATS));
				}
				else
				{
					memset(pResult, 0, sizeof(APICMDBUF_GET_RSN_STATS));
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
        case APCMD_GET_RSN_CFG:
				(APICMDBUF_GET_RSN_CFG*)pBuf = malloc(sizeof (APICMDBUF_GET_RSN_CFG));
				((APICMDBUF_GET_RSN_CFG*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_RSN_CFG*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_RSN_CFG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof(APICMDBUF_GET_RSN_CFG));
				}
				else
				{
					memset(pResult, 0, sizeof(APICMDBUF_GET_RSN_CFG));
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
		case APCMD_GET_AP_MODE:
				(APICMDBUF_GET_AP_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_AP_MODE));
				((APICMDBUF_GET_AP_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_AP_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_AP_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_AP_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_AP_MODE*)pBuf)->apMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_AP_MODE*)pBuf);
				break;	
#ifdef BURST_MODE
        case APCMD_GET_BURST_MODE:
				(APICMDBUF_GET_BURST_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_BURST_MODE));
				((APICMDBUF_GET_BURST_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_BURST_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_BURST_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_BURST_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					((BURST_INFO *)pResult)->BurstMode =  ((APICMDBUF_GET_BURST_MODE*)pBuf)->burstMode;
					((BURST_INFO *)pResult)->BurstRate =  ((APICMDBUF_GET_BURST_MODE*)pBuf)->burstRate;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_BURST_MODE*)pBuf);
				break;									
#endif		
		case APCMD_GET_FORCE_PROTECTION_MODE:
				(APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf = malloc(sizeof (APICMDBUF_GET_FORCE_PROTECTION_MODE));
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_FORCE_PROTECTION_MODE)-BUF_HDR_LEN;

				apctl(pBuf);

				if (pBuf->cmdStatus==APCTL_OK)
				{
					*((USHORT*)pResult) =  ((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf)->forceProtectMode;
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free ((APICMDBUF_GET_FORCE_PROTECTION_MODE*)pBuf);
				break;		

#if defined(WIPOD)
		case APCMD_GET_WIPOD_MODE:
			pBuf = malloc(sizeof(APICMDBUF_GET_WIPOD_MODE));
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = sizeof(APICMDBUF_GET_WIPOD_MODE) - 4*sizeof(unsigned short);
            				
			apctl(pBuf);

			if (pBuf->cmdStatus == APCTL_OK) 
			{
				*((UCHAR*)pResult) = ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode;

                /* Temp. If it's not AP/WB we need to copy more data.
                if( ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode != 0x01 
                    && ((APICMDBUF_GET_WIPOD_MODE *)pBuf)->mode != 0x82 ) 
                {
                    memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
                }*/
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			free (pBuf);
			break;
#endif /* WIPOD */

#ifdef WDS_FEATURE
		case APCMD_GET_WDS_MODE:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_GET_WDS_LIST:
				pBuf = malloc(sizeof (APICMDBUF)+6*MAX_WDS_AP_LIST+2);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = 6*MAX_WDS_AP_LIST+2;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
				apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf->cmdBody, pBuf->cmdBodyLen);
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
		case APCMD_GET_DISABLE_ASSOC:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_GET_WDS_OPTION:
			pBuf = malloc(sizeof (APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBody = (char *)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBodyLen = 2;			

			apctl(pBuf);

			if (pBuf->cmdStatus==APCTL_OK)
			{
				*((UCHAR*)pResult) =  pBuf->cmdBody[0];
			}
			else
			{
				nStatus = STATUS_FAIL;
			}
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
#endif 
#ifdef AP_SITE_SURVEY
        case APCMD_GET_SURVEY_INFO:
				(APICMDBUF_GET_SURVEY_INFO*)pBuf = malloc(sizeof (APICMDBUF_GET_SURVEY_INFO));
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->seqNum = 1;
				((APICMDBUF_GET_SURVEY_INFO*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_SURVEY_INFO)-BUF_HDR_LEN;
			  	apctl(pBuf);
				if (pBuf->cmdStatus==APCTL_OK)
				{
					memcpy(pResult, pBuf, sizeof (APICMDBUF_GET_SURVEY_INFO));
				}
				else
				{
					nStatus = STATUS_FAIL;
				}
				free (pBuf);
				break;
#endif /* AP_SITE_SURVEY */
#ifdef SELF_CTS
    case APCMD_GET_SELF_CTS:
            (APICMDBUF_GET_SELF_CTS*)pBuf = malloc(sizeof (APICMDBUF_GET_SELF_CTS));
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->seqNum = 1;
            ((APICMDBUF_GET_SELF_CTS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_GET_SELF_CTS)-BUF_HDR_LEN;

            apctl(pBuf);

            if (pBuf->cmdStatus==APCTL_OK)
            {
                *((UCHAR*)pResult) =  ((APICMDBUF_GET_SELF_CTS*)pBuf)->SelfCts;
            }
            else
            {
                nStatus = STATUS_FAIL;
            }
            free ((APICMDBUF_GET_SELF_CTS*)pBuf);
            break;		
#endif
        default: nStatus = STATUS_FAIL; 
				 break;
	}

	return nStatus;

}

extern void Reset(void);

WL_STATUS ApCmdSetProc(UINT16 CmdCode, char *pData)
{
	APICMDBUF *pBuf;
	WL_STATUS  nStatus;
	int i;
	
	switch (CmdCode)
	{
		APICMDBUF *pBuf; 
	
		case APCMD_BSS_START:
			
				pBuf = malloc(sizeof(APICMDBUF));
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = 0;
				apctl(pBuf);
				free(pBuf); 

        /* Reset AP if required */
#if 0
        if (*pData) {
          Reset();
        }
#endif
				break;
		case APCMD_SET_SSID:
				pBuf = malloc(sizeof (APICMDBUF)+32);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
				pBuf->cmdBodyLen = 32;
				/*strcpy(pBuf->cmdBody, (char*)pData); */
				memcpy(pBuf->cmdBody, pData, 32);
				apctl(pBuf);
				//free (pBuf->cmdBody);
				free (pBuf);
				break;
		case APCMD_SET_OPEN_SSID_EN_STATE:
				(APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf = malloc(sizeof (APICMDBUF_SET_OPEN_SSID_EN_STATE));
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_OPEN_SSID_EN_STATE)-BUF_HDR_LEN;
				((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf)->openSSIDEnabled = *pData;
				apctl(pBuf);
				free((APICMDBUF_SET_OPEN_SSID_EN_STATE*)pBuf); 
				break;
		case APCMD_SET_RF_CHANNEL:
				(APICMDBUF_SET_RF_CHANNEL*)pBuf = malloc(sizeof (APICMDBUF_SET_RF_CHANNEL));
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RF_CHANNEL)-BUF_HDR_LEN;
				((APICMDBUF_SET_RF_CHANNEL*)pBuf)->curChanNum = *((USHORT*)pData);
				apctl(pBuf);
 				free ((APICMDBUF_SET_RF_CHANNEL*)pBuf); 
				break;				
		case APCMD_SET_TX_POWER_LEVEL:
				(APICMDBUF_SET_TX_POWER_LEVEL*)pBuf = malloc(sizeof (APICMDBUF_SET_TX_POWER_LEVEL));
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_TX_POWER_LEVEL)-BUF_HDR_LEN;
				((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf)->txPowerLevel = *((UCHAR*)pData);
				apctl(pBuf);
 				free ((APICMDBUF_SET_TX_POWER_LEVEL*)pBuf); 
				break;				
		case APCMD_SET_BEACON_PERIOD:
				(APICMDBUF_SET_BEACON_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_SET_BEACON_PERIOD));

				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BEACON_PERIOD)-BUF_HDR_LEN;
				((APICMDBUF_SET_BEACON_PERIOD*)pBuf)->beaconPeriod = *((ULONG*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_BEACON_PERIOD*)pBuf); 
				break;	
		case APCMD_SET_DTIM_PERIOD:
				(APICMDBUF_SET_DTIM_PERIOD*)pBuf = malloc(sizeof (APICMDBUF_SET_DTIM_PERIOD));

				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DTIM_PERIOD)-BUF_HDR_LEN;
				((APICMDBUF_SET_DTIM_PERIOD*)pBuf)->dtimPeriod = *((ULONG*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_DTIM_PERIOD*)pBuf); 
				break;	
		case APCMD_SET_FRAG_THRESHOLD:
				(APICMDBUF_SET_FRAG_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_SET_FRAG_THRESHOLD));

				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_FRAG_THRESHOLD)-BUF_HDR_LEN;
				((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf)->fragThreshold = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_FRAG_THRESHOLD*)pBuf); 
				break;	
		case APCMD_SET_RTS_THRESHOLD:
				(APICMDBUF_SET_RTS_THRESHOLD*)pBuf = malloc(sizeof (APICMDBUF_SET_RTS_THRESHOLD));

				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RTS_THRESHOLD)-BUF_HDR_LEN;
				((APICMDBUF_SET_RTS_THRESHOLD*)pBuf)->rtsThreshold = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_RTS_THRESHOLD*)pBuf); 
				break;	
		case APCMD_SET_DATA_RETRY_LIMIT:
				(APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_SET_DATA_RETRY_LIMIT));

				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DATA_RETRY_LIMIT)-BUF_HDR_LEN;
				((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf)->dataRetryLimit = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_DATA_RETRY_LIMIT*)pBuf); 
				break;	
		case APCMD_SET_RTS_RETRY_LIMIT:
				(APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf = malloc(sizeof (APICMDBUF_SET_RTS_RETRY_LIMIT));

				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_RTS_RETRY_LIMIT)-BUF_HDR_LEN;
				((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf)->rtsRetryLimit = *((USHORT*)pData);
				
				apctl(pBuf);
				free ((APICMDBUF_SET_RTS_RETRY_LIMIT*)pBuf); 
				break;	
		case APCMD_SET_RF_PREAMBLE_OPTION:
				(APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf = malloc(sizeof (APICMBUF_SET_RF_PREAMBLE_OPTION));

				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->seqNum = 1;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMBUF_SET_RF_PREAMBLE_OPTION)-BUF_HDR_LEN;
				((APICMBUF_SET_RF_PREAMBLE_OPTION*)pBuf)->rfPreambleOption = *pData;
				apctl(pBuf);
				free ((APICMDBUF_GET_BEACON_PERIOD*)pBuf); 
				break;
		case APCMD_SET_ANTENNA_MODE:
			
				(APICMDBUF_SET_ANTENNA_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_ANTENNA_MODE));

				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ANTENNA_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->antennaMode = *pData;
				((APICMDBUF_SET_ANTENNA_MODE*)pBuf)->whichAnt = *(pData+1);
				apctl(pBuf);
				free ((APICMDBUF_GET_ANTENNA_MODE*)pBuf);
				break;
		case APCMD_SET_TX_DATA_RATE:
				(APICMDBUF_SET_TX_DATA_RATE*)pBuf = malloc(sizeof (APICMDBUF_SET_TX_DATA_RATE));
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->seqNum= 1;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_TX_DATA_RATE)-BUF_HDR_LEN;
				((APICMDBUF_SET_TX_DATA_RATE*)pBuf)->txDataRate = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_TX_DATA_RATE*)pBuf);
				break;
	/*	case APCMD_SET_SUP_DATA_RATES: */
		case APCMD_SET_BASIC_DATA_RATES:	
				(APICMDBUF_SET_BASIC_DATA_RATES*)pBuf = malloc(sizeof (APICMDBUF_SET_BASIC_DATA_RATES));

				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BASIC_DATA_RATES)-BUF_HDR_LEN;
				memcpy(((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf)->basicDataRates, pData, 14);  
				apctl(pBuf);
				free ((APICMDBUF_SET_BASIC_DATA_RATES*)pBuf); 
				break; 
		case APCMD_SET_AUTH_MODE:
			
				(APICMDBUF_SET_AUTH_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_AUTH_MODE));

				((APICMDBUF_SET_AUTH_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_AUTH_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_AUTH_MODE*)pBuf)->authMode = *pData;
				apctl(pBuf);
				free ((APICMDBUF_GET_AUTH_MODE*)pBuf);
				
				break;
		case APCMD_SET_PRIVACY_OPTION:
			
				(APICMDBUF_SET_PRIVACY_OPTION*)pBuf = malloc(sizeof (APICMDBUF_SET_PRIVACY_OPTION));

				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_PRIVACY_OPTION)-BUF_HDR_LEN;
				((APICMDBUF_SET_PRIVACY_OPTION*)pBuf)->dataEncrypt = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_PRIVACY_OPTION*)pBuf); 
				break;
        case APCMD_SET_PSK_PASSPHRASE:
			
				(APICMDBUF_SET_PSK_PASSPHRASE*)pBuf = malloc(sizeof (APICMDBUF_SET_PSK_PASSPHRASE));

				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE)-BUF_HDR_LEN;
				strcpy(((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf)->passphrase, pData);
				apctl(pBuf);
				free ((APICMDBUF_SET_PSK_PASSPHRASE*)pBuf); 
				break;
        case APCMD_SET_GRP_REKEY_TIME:
			
				(APICMDBUF_SET_GRP_REKEY_TIME*)pBuf = malloc(sizeof (APICMDBUF_SET_GRP_REKEY_TIME));

				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME)-BUF_HDR_LEN;
				((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf)->rekey_time = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_GRP_REKEY_TIME*)pBuf); 
				break;
		case APCMD_SET_DEFAULT_WEP_KEYS:
			
				(APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf = malloc(sizeof (APICMDBUF_SET_DEFAULT_WEP_KEYS));

				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_DEFAULT_WEP_KEYS)-BUF_HDR_LEN;;
		 		((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyindex = ((WEP_KEY*)pData)->TxKeyIndex;  
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType0 = ((WEP_KEY*)pData)->keyType0; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue0, ((WEP_KEY*)pData)->keyValue0, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType1 = ((WEP_KEY*)pData)->keyType1; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue1, ((WEP_KEY*)pData)->keyValue1, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType2 = ((WEP_KEY*)pData)->keyType2; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue2, ((WEP_KEY*)pData)->keyValue2, 13);
				((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyType3 = ((WEP_KEY*)pData)->keyType3; 
				memcpy(((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf)->keyValue3, ((WEP_KEY*)pData)->keyValue3, 13);
				apctl(pBuf);
				free((APICMDBUF_SET_DEFAULT_WEP_KEYS*)pBuf);
				break;
		case APCMD_SET_WLAN_FILTER_LIST:
				pBuf = malloc(sizeof (APICMDBUF) + pData[1] * 6 + 2);
				pBuf->cmdCode = CmdCode;
				pBuf->seqNum = 1;
				pBuf->cmdBodyLen = pData[1] * 6 + 2;
				pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF); 
				memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
				apctl(pBuf);
				/*free (pBuf->cmdBody); */
				free (pBuf);
				break;
    case APCMD_SET_WLAN_FILTER_MODE:
            (APICMDBUF_FILTER_MODE*)pBuf = malloc(sizeof (APICMDBUF_FILTER_MODE));
            pBuf->cmdCode = CmdCode;
            pBuf->seqNum = 1;
            pBuf->cmdBodyLen = 1;
            ((APICMDBUF_FILTER_MODE *)pBuf)->mode = *pData;
            apctl(pBuf);
            free (pBuf);
            break;
		case APCMD_SET_ETH_IP_CONFIG:
				(APICMDBUF_SET_ETH_IP_CONFIG*)pBuf = malloc(sizeof (APICMDBUF_SET_ETH_IP_CONFIG));
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_ETH_IP_CONFIG)-BUF_HDR_LEN;
				memcpy((UCHAR*)&(((APICMDBUF_SET_ETH_IP_CONFIG *)pBuf)->dhcpEnabled), pData, 16); 		
				apctl(pBuf);				
				free ((APICMDBUF_SET_ETH_IP_CONFIG*)pBuf);
				break;	
		case APCMD_SET_AP_MODE:
			
				(APICMDBUF_SET_AP_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_AP_MODE));

				((APICMDBUF_SET_AP_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_AP_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_AP_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_AP_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_AP_MODE*)pBuf)->apMode = *pData; 
				apctl(pBuf);
				free ((APICMDBUF_SET_AP_MODE*)pBuf);
				break;		
#ifdef BURST_MODE
		case APCMD_SET_BURST_MODE:
			
				(APICMDBUF_SET_BURST_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_BURST_MODE));

				((APICMDBUF_SET_BURST_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_BURST_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_BURST_MODE*)pBuf)->burstMode = ((BURST_INFO *)pData)->BurstMode; 
				((APICMDBUF_SET_BURST_MODE*)pBuf)->burstRate= ((BURST_INFO *)pData)->BurstRate;
				apctl(pBuf);
				free ((APICMDBUF_SET_BURST_MODE*)pBuf);
				break;								
#endif		
		case APCMD_SET_FORCE_PROTECTION_MODE:
			
				(APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf = malloc(sizeof (APICMDBUF_SET_FORCE_PROTECTION_MODE));

				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->seqNum = 1;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_FORCE_PROTECTION_MODE)-BUF_HDR_LEN;
				((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf)->forceProtectMode = *pData;
				apctl(pBuf);
				free ((APICMDBUF_SET_FORCE_PROTECTION_MODE*)pBuf);
				
				break;		

#if defined(WIPOD)
		case APCMD_SET_WIPOD_MODE:
			pBuf = malloc(sizeof(APICMDBUF_SET_WIPOD_MODE));
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = sizeof(APICMDBUF_SET_WIPOD_MODE) - 4*sizeof(unsigned short);
			((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode = *pData;

            /* Temp. If it's not AP/WB we need to copy more data. 
            if( ((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode != 0x01 
                && ((APICMDBUF_SET_WIPOD_MODE *)pBuf)->mode != 0x82 ) 
            {
                memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
            }*/

			apctl(pBuf);
			free (pBuf);
			break;	
#endif /* WIPOD */
		
#ifdef WDS_FEATURE
		case APCMD_SET_WDS_MODE:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
		case APCMD_SET_WDS_LIST:
			pBuf = malloc(sizeof (APICMDBUF)+6*MAX_WDS_AP_LIST+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 6*MAX_WDS_AP_LIST+2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);		
			memcpy(pBuf->cmdBody, pData, pBuf->cmdBodyLen);
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;
		case APCMD_SET_DISABLE_ASSOC:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
		case APCMD_SET_WDS_OPTION:
			pBuf = malloc(sizeof(APICMDBUF)+2);
			pBuf->cmdCode = CmdCode;
			pBuf->seqNum = 1;
			pBuf->cmdBodyLen = 2;
			pBuf->cmdBody = (char*)pBuf+sizeof(APICMDBUF);
			pBuf->cmdBody[0] = pData[0];
			apctl(pBuf);
			//free (pBuf->cmdBody);
			free (pBuf);
			break;	
#endif 
#ifdef AP_SITE_SURVEY
        case APCMD_SET_SURVEY_SCAN:
				(APICMDBUF*)pBuf = malloc(sizeof (APICMDBUF));
				((APICMDBUF*)pBuf)->cmdCode = CmdCode;
				((APICMDBUF*)pBuf)->seqNum = 1;
				((APICMDBUF*)pBuf)->cmdBodyLen = sizeof(APICMDBUF)-BUF_HDR_LEN;
				apctl(pBuf);
				free ((APICMDBUF*)pBuf);
				break;
#endif /* AP_SITE_SURVEY */
#ifdef SELF_CTS
    case APCMD_SET_SELF_CTS:

            (APICMDBUF_SET_SELF_CTS*)pBuf = malloc(sizeof (APICMDBUF_SET_SELF_CTS));

            ((APICMDBUF_SET_SELF_CTS*)pBuf)->cmdCode = CmdCode;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->seqNum = 1;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->cmdBodyLen = sizeof(APICMDBUF_SET_SELF_CTS)-BUF_HDR_LEN;
            ((APICMDBUF_SET_SELF_CTS*)pBuf)->SelfCts = *pData;
            apctl(pBuf);
            free ((APICMDBUF_SET_SELF_CTS*)pBuf);

            break;
#endif
		default: nStatus = STATUS_FAIL; 
				 break;
	}

	return nStatus;

}



