/*
 * Mrvap.c -- Page handler for AP configuration 
 *
 */
/*********************************** Includes *********************************/
#include  "wltypes.h"
#include	"wsIntrn.h"
#ifdef UEMF
    #include	"uemf.h"
#else
    #include	"../basic/basicInternal.h"
#endif

#include "IEEE_types.h"
#include "wl_mib.h"
#include  "wl_hal.h"
#include  "Mrvap.h"
#include  "ap_api.h" 
#include  "webs.h"
#include  "buildModes.h"
#include  "api.h"

#define websErrorMsg(x) "Error"

#define TEST_REG_RW

#ifdef TEST_REG_RW
unsigned char curReg = 0;
#endif /* TEST_REG_RW */

UINT8 GUI_mib_ApMode;
BOOLEAN AP_Mode_Updated =FALSE;
extern int SetWpa(webs_t wp, char_t* query);
extern int ProcessUserData(char * DataFromUser, char * DataToWladrv, char * pTemp); 
/************************************ Locals **********************************/
typedef struct
{                /* Struct for CGI tasks which have completed */
    webs_t  wp;                 /* pointer to session websRec */
    char_t  *stdIn;             /* file desc. for task's temp input fd */
    char_t  *stdOut;            /* file desc. for task's temp output fd */
    char_t  *cgiPath;           /* path to executable process file */
    char_t  **argp;             /* pointer to buf containing argv tokens */
    char_t  **envp;             /* pointer to array of environment strings */
    int     handle;             /* process handle of the task */
    long    fplacemark;         /* seek location for CGI output file */
} cgiRec;
static cgiRec   **cgiList;      /* hAlloc chain list of wp's to be closed */
static int      cgiMax;         /* Size of hAlloc list */

static UINT8 wpaMode=0;
static char DataToWlandrv[DATA_SIZE_TO_WLADRV];
static char DataFromUser[DATA_SIZE_FROM_USER];
/*
typedef unsigned  char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
*/
/************************************* Code ***********************************/
#ifdef TEST_PAGE
DWORD Reg1A, Reg1B, Reg19, Reg21=0x12, Reg22=0x05, Reg26=0x33, Reg23=0x2D, Reg24=0x08;
#endif

/*
 *	Process a form request. Returns 1 always to indicate it handled the URL
 */

void dummy_Mrvap(void) {
}

int websMrvHandler(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
                   char_t *url, char_t *path, char_t* query)
{
    int errorNum;

    if (websValidateUrl(wp, path)<0)
    {
        websError(wp, 500, T("Invalid URL %s"), url);
        return 1;
    }

    if (strstr(path, ".gif") || strstr(path, ".asp") || strstr(path, ".js"))
    {
        websDefaultHandler(wp, urlPrefix, webDir, arg, url, path, query);
    }
#ifndef MAIN_PAGE_EVALTOOL
    else if (!strcmp(path, "/index.htm"))
    {
        websRedirect(wp, T("radio.asp"));
    }
#endif
    else if (!strcmp(path, "/SetRadio.htm"))
    {
        errorNum = SetRadio(wp, query);
        Radio(wp, errorNum);
        //websRedirect(wp, T("radio.asp")); 
    }
    else if (!strcmp(path, "/SetWep.htm"))
    {
        //errorNum = SetWep(wp, query);
        errorNum = SetSecurity(wp, query);
        //Wep(wp, errorNum);
        securityConfig(wp, errorNum);

    }
    else if (!strcmp(path, "/wpa.htm"))
    {
        //wpaConfig(wp, 0);
        websRedirect(wp, T("wpa.asp"));
    }
    else if (!strcmp(path, "/SetWpa.htm"))
    {
        errorNum = SetWpa(wp, query); 
        wpaConfig(wp, errorNum);
    }
    else if (!strcmp(path, "/SetBridge.htm"))
    {
        SetBridge(wp, query);
        websRedirect(wp, T("bridge.asp")); 
    }
    else if (!strcmp(path, "/SetIpConfig.htm"))
    {
        errorNum = webSetIpConfig(wp, query);
        if (errorNum == 0)
        {
            asp_show_error_message(wp, "You Have Entered Invalid Data!", "IpConfig.asp");
        }
        else
        {
            UCHAR tmpBuf[16];
            char tmpStrBuf[50];
            //websRedirect(wp, T("IpConfig.asp"));
            {
                if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char *)tmpBuf) != STATUS_FAIL )
                {
                    sprintf(tmpStrBuf,"http://%d.%d.%d.%d/reboot.asp\0",
                        tmpBuf[4],tmpBuf[5],tmpBuf[6],tmpBuf[7]);
                    websRedirect(wp, T(tmpStrBuf));
                }
            }
            //websRedirect(wp, T("reboot.asp"));
        }
    }
    else if (!strcmp(path, "/SetFilterList.htm"))
    {
        webSetFilterTable(wp, query);
        websRedirect(wp, T("filter_list.asp")); 
    }
#ifdef WDS_FEATURE
    else if (!strcmp(path, "/wds.htm"))
    {
        webSetWds(wp, query);
        /*websRedirect(wp, T("reboot.asp"));*/
        apRebooting(wp, "/wds.asp");
    }
#endif
#if 0 //bt_test:: upload
    else if (!strcmp(path, "/fw_upgrade.htm"))
    {
        fwUpload(wp);
    }
#endif	
    else if (!strcmp(path, "/Reboot.htm"))
    {
        apRebooting(wp, "/index.htm");
    }

#ifdef TEST_REG_RW
    else if (!strcmp(path, "/SetReg.htm"))
    {
        SetReg(wp, query);
        regSetting(wp);
    }
    else if (!strcmp(path, "/RegSetting.htm"))
    {
        regSetting(wp);
    }
#endif /* TEST_REG_RW */
#ifdef AP_SITE_SURVEY
    else if (!strcmp(path, "/SetSurvey.htm"))
    {
        if (SetSurvey(wp, query))
        {
            SetUserConfig();
            websRedirect(wp, T("reboot.asp"));
        }
        else
        {
            websRedirect(wp, T("sys_survey.asp")); 
        }
    }
#endif /* AP_SITE_SURVEY */
    else
    {
        /*websRfTestHandler(wp, urlPrefix, webDir, arg, url, path, query); */
    }

    return 1;
} 

void getMacFromString(unsigned char *macAddr, const char *pStr) {
    int nAddr = 0;

    memset(macAddr, 0, 6);

    if (strlen(pStr) > 0)
    {
        while (nAddr < 6)
        {
            if (*pStr=='%' && *(pStr+1)=='3' && (*(pStr+2)=='A' || *(pStr+2)=='a'))
            {
                pStr = pStr+3;
                continue;
            }

            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = *pStr - 'A' + 10;
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = *pStr - 'a' + 10;
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = *pStr - '0';
            }
            else
            {
                continue;
            }

            pStr++;

            if (*pStr>='A' && *pStr<='F')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'A' + 10);
            }
            else if (*pStr>='a' && *pStr<='f')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - 'a' + 10);
            }
            else if (*pStr>='0' && *pStr<='9')
            {
                macAddr[nAddr] = (macAddr[nAddr] << 4) | (*pStr - '0');
            }

            pStr++;
            nAddr++;
        }
    }
}

int SetRadio(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur, *tmp; 
    int     i;
    char    chData;
    char    bufData[600];
    BOOLEAN SSID_Updated_WPA_Enable;
    USHORT nData;
    ULONG lData;
    UCHAR BurstRate;
    UCHAR   AP_Mode, ucData;
    BURST_INFO BurstInfo;
    UCHAR bRate;
    UCHAR gRate;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }
    SSID_Updated_WPA_Enable=FALSE; 

    tmp = malloc(512);

    pCur = strstr(query, "SSID");

    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        /* Set SSID */
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) >32) )
                return SSID_SIZE_ERROR;
            memset(bufData, 0, 50);
            ApCmdGetProc(APCMD_GET_SSID, bufData);      
            if (strcmp(bufData, DataToWlandrv) != 0)
            {
                //
                //SSID updated
                //				
                if (ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, &chData) == STATUS_FAIL)
                {
                    //
                    //If failed, just assume WPA is enabled
                    //
                    SSID_Updated_WPA_Enable=TRUE;
                }
                else
                {
                    if (chData ==1)
                        SSID_Updated_WPA_Enable=TRUE;
                    else
                        SSID_Updated_WPA_Enable=FALSE;                                              
                }


            }
            ApCmdSetProc(APCMD_SET_SSID, DataToWlandrv); 
        }
    }

#if defined(WIPOD)
    /* Set WiPod Mode */
    pCur = strstr(query, "wipod_mode");
	if (pCur != NULL)
	{
		strcpy(tmp, pCur);  	
		if ((pTemp = strchr(tmp, '&'))!=NULL) {
			*pTemp = '\0';
		}
		if ( (pTemp = strchr(tmp, '='))!=NULL) {
			pTemp++; 
			memset(bufData, 0, 50);
			strcpy(bufData, pTemp);
	
		  	for (i=0; i<(int)strlen(bufData);i++) {
				if (bufData[i]=='+') {
					bufData[i] = ' ';
				}
			}
            nData = atoi(bufData)? WIPOD_MODE_CLIENT_BRIDGE:WIPOD_MODE_AP;
            ApCmdSetProc(APCMD_SET_WIPOD_MODE, &nData);
		}
	}
#endif /* WIPOD */

    /* Set Broadcast SSID option */
    pCur = strstr(query, "BroadcastSSID");

    chData = (pCur!=NULL)?TRUE:FALSE;

    ApCmdSetProc(APCMD_SET_OPEN_SSID_EN_STATE, &chData);  


#if 1 //Set rate for b

    // Set B Rates
    pCur = strstr(query, "rate_b");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;
            while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if (i > 4)
            {
                nData = 0;
            }
            else if (nData == 5)
            {
                nData = 11;
            }
            else
            {
                nData = nData * 2;
            }

            //eprintf("set rate_b = %d \n", nData);   
            {
                APICMDBUF_SET_TX_DATA_RATE apicmdbuf_get_tx_data_rate;

                apicmdbuf_get_tx_data_rate.cmdCode = APCMD_SET_TX_DATA_RATE;
                apicmdbuf_get_tx_data_rate.seqNum = 1;
                apicmdbuf_get_tx_data_rate.cmdBodyLen = 1;
                apicmdbuf_get_tx_data_rate.txDataRate = nData;
                apctl(&apicmdbuf_get_tx_data_rate);

            }

        }
    }

    // Set G Rates
    pCur = strstr(query, "rate_g");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }
        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;
            while (*(pTemp+i)!='+' && *(pTemp+i)!='.')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if (i > 4)
            {
                nData = 0;
            }
            else if (nData == 5)
            {
                nData = 11;
            }
            else
            {
                nData = nData * 2;
            }
            //eprintf("set rate_g = %d \n", nData);
            {
                APICMDBUF_SET_TX_DATA_RATE_G apicmdbuf_get_tx_data_rate_g;

                apicmdbuf_get_tx_data_rate_g.cmdCode = APCMD_SET_TX_DATA_RATE_G;
                apicmdbuf_get_tx_data_rate_g.seqNum = 1;
                apicmdbuf_get_tx_data_rate_g.cmdBodyLen = 1;
                apicmdbuf_get_tx_data_rate_g.txDataRate = nData;
                apctl(&apicmdbuf_get_tx_data_rate_g);

            }
        }
    }
#endif//Set B G Rates


    /* Set Channel */
    pCur = strstr(query, "Channel");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        //sscanf(tmp, "Channel=Channel+%d", &i);

        if ((pTemp = strchr(tmp, '+'))!=NULL)
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_RF_CHANNEL, &nData); /*SetChannel(i); */

        }
    }

    /* Set Tx Power Level */
    pCur = strstr(query, "TxPower");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        /*sscanf(tmp, "TxPower=%d+mW", &i); */

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='+')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_TX_POWER_LEVEL, &nData); 

        }
    }


    /* Set Tx Antenna */
    pCur = strstr(query, "TxAntenna");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        nData = AP_TX_ANTENNA;

        if (strstr(tmp, "Antenna+0")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_A;
        }
        else if (strstr(tmp, "Antenna+1")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_B;
        }
        else /*if (strstr(tmp, "Both")!=NULL) */
        {
            nData = (nData<<8) | AP_ANT_DIVERSITY;
        }

        ApCmdSetProc(APCMD_SET_ANTENNA_MODE, &nData);  
    }

    /* Set Rx Antenna */
    pCur = strstr(query, "RxAntenna");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        nData = AP_RX_ANTENNA;

        if (strstr(tmp, "Antenna+0")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_A;
        }
        else if (strstr(tmp, "Antenna+1")!=NULL)
        {
            nData = (nData<<8) | AP_ANT_B;
        }
        else /*	if (strstr(tmp, "Both")!=NULL) */
        {
            nData = (nData<<8) | AP_ANT_DIVERSITY;
        }

        ApCmdSetProc(APCMD_SET_ANTENNA_MODE, &nData);  
    }

#ifdef BURST_MODE
    //set burst rate
    pCur = strstr(query, "burst_rate"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)
        {
            i = 1;
            BurstRate = 0;

            while (*(pTemp+i)!='\0')
            {
                BurstRate = BurstRate*10 + *(pTemp+i) - '0';
                i++;
            }

        }
        if ( ( BurstRate < 8) || (BurstRate > 16) )
        {
            return BURST_RATE_RANGE_ERROR;
        }
        BurstInfo.BurstRate=BurstRate;
    }

    //set burst mode
    pCur = strstr(query, "burst_mode"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Disable")!=NULL)
        {
            BurstInfo.BurstMode= 0;
        }
        else if (strstr(tmp, "Enable")!=NULL)
        {
            BurstInfo.BurstMode = 1;
        }
        ApCmdSetProc(APCMD_SET_BURST_MODE, &BurstInfo);  
    }
#endif
    // Set AP Mode
    pCur = strstr(query, "AP_mode"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "B+only")!=NULL)
        {
            nData = AP_MODE_B_ONLY;
        }
        else if (strstr(tmp, "G+only")!=NULL)
        {
            nData = AP_MODE_G_ONLY;
        }
        else if (strstr(tmp, "mixed")!=NULL)
        {
            nData = AP_MODE_MIXED;
        }


        if (ApCmdSetProc(APCMD_SET_AP_MODE, (char *)&nData) == STATUS_FAIL)
        {
            //
            //If failed, just assume AP_Mode_Updated=TRUE;
            //
            AP_Mode_Updated=TRUE;
            GUI_mib_ApMode = (UINT8)nData;
        }
        else
        {
            if (AP_Mode != (UINT8)nData)
            {
                AP_Mode_Updated=TRUE;
                GUI_mib_ApMode = (UINT8)nData;
            }

        }

    }

    //set G mode protection
    pCur = strstr(query, "G_mode_protection"); 

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "CTS+ONLY")!=NULL)
        {
#ifdef SELF_CTS
            nData = 1;
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
            nData = 0;
        }
        else if (strstr(tmp, "RTS-CTS")!=NULL)
        {
            nData = 0;
#ifdef SELF_CTS
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
        }
        else if (strstr(tmp, "Off")!=NULL)
        {
#ifdef SELF_CTS
            nData = 0;
            ApCmdSetProc(APCMD_SET_SELF_CTS, &nData); 
#endif
            nData = 1;
        }

        ApCmdSetProc(APCMD_SET_FORCE_PROTECTION_MODE, &nData);  
    }
    // Set Beacon Period
    pCur = strstr(query, "Beacon");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. Beacon=1024
        {
            i = 1;
            lData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return BEACON_RANGE_ERROR;
                }

                lData = lData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (lData <BEACON_THRESHOLD_MIN) || (lData > BEACON_THRESHOLD_MAX) )
            {
                return BEACON_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_BEACON_PERIOD, &lData);  

            }


        }
    }

    // Set DTIM Period
    pCur = strstr(query, "DTIM");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. DTIM=1024
        {
            i = 1;
            lData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return DTIM_RANGE_ERROR;
                }

                lData = lData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (lData < DTIM_THRESHOLD_MIN) || (lData > DTIM_THRESHOLD_MAX) )
            {
                return DTIM_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_DTIM_PERIOD, &lData); 
            }                
        }
    }

    // Set Preamble option
    pCur = strstr(query, "Preamble");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Auto")!=NULL)
        {
            chData = PREAMBLE_AUTO_SELECT;
        }
        else if (strstr(tmp, "Short")!=NULL)
        {
            chData = PREAMBLE_SHORT;
        }
        else if (strstr(tmp, "Long")!=NULL)
        {
            chData = PREAMBLE_LONG;
        }

        ApCmdSetProc(APCMD_SET_RF_PREAMBLE_OPTION, &chData);  
    }


    // Set Fragmentation Threshold 
    pCur = strstr(query, "FragThreshold");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. FragThreshold=1024
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (nData < FRAG_THRESHOLD_MIN) || (nData > FRAG_THRESHOLD_MAX) )
            {
                return FRAG_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_FRAG_THRESHOLD, &nData);  
            }               
        }
    }

    // Set RTS Threshold 
    pCur = strstr(query, "RTSThreshold");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. RTSThreshold=1024
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                if ( *(pTemp+i) < '0' || *(pTemp+i) > '9')
                {
                    return RTS_RANGE_ERROR;
                }

                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }
            if ( (nData < RTS_THRESHOLD_MIN) || (nData > RTS_THRESHOLD_MAX) )
            {
                return RTS_RANGE_ERROR;
            }
            else
            {
                ApCmdSetProc(APCMD_SET_RTS_THRESHOLD, &nData);  
            }               
        }
    }


    // Set Data Retry Limit
    pCur = strstr(query, "DataRetryLimit");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. DataRetryLimit=7
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_DATA_RETRY_LIMIT, &nData);  
        }
    }

    // Set RTS Retry Limit
    pCur = strstr(query, "RTSRetryLimit");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ((pTemp = strchr(tmp, '='))!=NULL)  // e.g. RTSRetryLimit=7
        {
            i = 1;
            nData = 0;

            while (*(pTemp+i)!='\0')
            {
                nData = nData*10 + *(pTemp+i) - '0';
                i++;
            }

            ApCmdSetProc(APCMD_SET_RTS_RETRY_LIMIT, &nData);  
        }
    }


/*	
    // Set basic data rates
    pCur = strstr(query, "TXRATE");
    i = 0;

    bufData[ 0] =   2; //  1   Mbps
    bufData[ 1] =   4; //  2   Mbps
    bufData[ 2] =  11; //  5.5 Mbps
    bufData[ 3] =  22; // 11   Mbps
    bufData[ 4] =  12; //  6   Mbps
    bufData[ 5] =  18; //  9   Mbps
    bufData[ 6] =  24; // 12   Mbps
    bufData[ 7] =  36; // 18   Mbps
    bufData[ 8] =  48; // 24   Mbps
    bufData[ 9] =  72; // 36   Mbps
    bufData[10] =  96; // 48   Mbps
    bufData[11] = 108; // 54   Mbps
    bufData[12] =   0;
    bufData[13] =   0;
    bufData[14] =   0;
    bufData[15] =   0;
     
    while (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';	
        }
        
        pCur = pTemp+1;
        pTemp = tmp+6;
        nData = 0;

        while (*pTemp >='0' && *pTemp<='9')	// e.g. TXRATE11=ON
        {
            nData = nData*10 + *pTemp - '0';
            pTemp++;	
        }

        if (nData!=0) 
        {
            for (i=0; bufData[i]!=0 && i<16; i++)
            {
                if (bufData[i]== nData)
                {
                    bufData[i] |= 0x80;
                    break;
                }
            }
        }
        
        pCur = strstr(pCur, "TXRATE");
    }
        
    if (i!=0)
    {
        ApCmdSetProc(APCMD_SET_BASIC_DATA_RATES_G, bufData);  
    }
*/
    chData = 1;
    ApCmdSetProc(APCMD_BSS_START, &chData); 
    free(tmp);
    return AP_NEEDS_REBOOT;

}
int checkEmptyKey(WEP_KEY *pWep)
{
    /*UINT8 NullWepKey[13] = {0,0,0,0,0,0,0,0,0,0,0,0,0};*/
    switch (pWep->TxKeyIndex)
    {
    case 0:
        /*if ( memcmp(pWep->keyValue0, NullWepKey, 13)== 0 )*/
        if (pWep->keyType0 == WEP_NOT_SET)
            return(1);
        break;
    case 1:
        /*if ( memcmp(pWep->keyValue1, NullWepKey, 13)== 0 )*/
        if (pWep->keyType1 == WEP_NOT_SET)
            return(1);
        break;
    case 2:
        /*if ( memcmp(pWep->keyValue2, NullWepKey, 13)== 0 )*/
        if (pWep->keyType2 == WEP_NOT_SET)
            return(1);
        break;
    case 3:
        /*if ( memcmp(pWep->keyValue3, NullWepKey, 13)== 0 )*/
        if (pWep->keyType3 == WEP_NOT_SET)
            return(1);
        break;
    }
    return 0;
}

int SetWep(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData;
    unsigned char    bufData[100], key40[4][5], key128[16];
    USHORT nData, *pType, keysize;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption, keysetbypassphrase = 0;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    /* Auth Mode */
    pCur = strstr(query, "AuthMode");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Open")!=NULL)
        {
            chData = OPEN_SYSTEM_ONLY;
        }
        else if ( strstr(tmp, "Shared")!=NULL )
        {
            chData = SHARED_KEY_ONLY;
        }
        else /*if (strstr(tmp, "Both")!=NULL) */
        {
            chData = OPEN_SYSTEM_AND_SHARED_KEY;
        }

        ApCmdSetProc(APCMD_SET_AUTH_MODE, &chData);  
    }
    /* Privacy Option */
    pCur = strstr(query, "PrivacyOption");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Not")!=NULL)
        {
            chData = DATA_ENCRYPT_NOT_REQUIRED;
#ifdef TURBO_SETUP
            ResetToFactorySettings();
#endif
        }
        else
        {
            chData = FULL_DATA_ENCRYPT_REQUIRED;
#ifdef TURBO_SETUP
            TsModeChangeTo(4);
#endif
        }
        PrivacyOption = chData;
    }

    /* Set Wep Key */
    pWep = malloc(2*sizeof(WEP_KEY));
    memset(pWep, 0 , 2*sizeof(WEP_KEY));

    ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, pWep);

/*	nSetWepKey = 0; */

    /* Tx Key */
    pCur = strstr(query, "TxKey");

    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if ( (pTemp=strchr(tmp, '+'))!=NULL )         /* TxKey=Key+X */
        {
            nData = (USHORT)(*(pTemp+1)-'1'); 

            pWep->TxKeyIndex = nData;
        }
    }

    pCur = strstr(query, "KeySize");

    if ( pCur!=NULL )
    {
        strcpy(tmp, pCur);

        if ( (pTemp = strchr(tmp, '&'))!=NULL )
        {
            *pTemp = '\0';  
        }

        if ( strstr(tmp, "Not")!=NULL )
        {
            keysize = WEP_NOT_SET;
        }
        else if ( strstr(tmp, "40")!=NULL )
        {
            keysize = WEP_40_BIT;
        }
        else
        {
            keysize = WEP_104_BIT;
        }
    }
#ifdef PASSPHRASE_ENABLE
    pCur = strstr(query, "PASSPHRASE");

    if ( pCur != NULL )
    {
        strcpy(tmp, pCur);

        if ( (pTemp = strchr(tmp, '&'))!=NULL )
        {
            *pTemp = '\0';  
        }
        if ( (pTemp = strchr(tmp, '='))!=NULL )
        {
            pTemp++;
            if (*pTemp)
            {
                keysetbypassphrase = 1;
                if (keysize == WEP_40_BIT)
                    gen40bitkeys(pTemp, key40);
                if (keysize == WEP_104_BIT)
                    gen128bitkeys(pTemp,key128);
            }

        }
    }
    if (keysetbypassphrase)
    {
        for ( i= 0; i <4; i++)
        {
            pType = (USHORT*)(&pWep->keyType0 + i*9); /* offset by 18 bytes */
            pVal = (UCHAR*)(pWep->keyValue0 + i*18);
            if (keysize == WEP_40_BIT)
            {
                *pType = WEP_40_BIT;
                memcpy(pVal, key40[i], 5);
            }
            else
            {
                *pType = WEP_104_BIT;
                memcpy(pVal, key128, 16);
            }
        }
    }
    else
#endif

        /* Key value */
        for (i=0; i<4; i++)
        {
            strcpy(bufData, "KeyVal ");
            bufData[6] = (char)('0' + i +1);
            pType = (USHORT*)(&pWep->keyType0 + i*9); /* offset by 18 bytes */
            pVal = (UCHAR*)(pWep->keyValue0 + i*18);

            pCur = strstr(query, bufData);

            if (pCur!=NULL)
            {
                strcpy(tmp, pCur);

                if ((pTemp = strchr(tmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }

                if ((pTemp=strchr(tmp, '='))!=NULL)
                {
                    pTemp++;
                    /*strcpy(pVal, pTemp); */
                    j = 0;
                    while (*pTemp != '\0')
                    {
                        if (*pTemp>='0' && *pTemp<='9')
                        {
                            chData = *pTemp - '0';
                        }
                        else if ( *pTemp>='A' && *pTemp <= 'F' )
                        {
                            chData = *pTemp - 'A' + 10;
                        }
                        else if ( *pTemp>='a' && *pTemp <= 'f' )
                        {
                            chData = *pTemp - 'a' + 10;
                        }
                        else if ( *pTemp == '*' && (strcmp(pTemp,"**********") == 0))
                        {
                            j=0;
                            break;
                        }
                        else
                        {
                            return 11;  // wrong info
                        }

                        chData = chData<<4;

                        pTemp++;

                        if (*pTemp>='0' && *pTemp<='9')
                        {
                            chData += *pTemp - '0';
                        }
                        else if ( *pTemp>='A' && *pTemp <= 'F' )
                        {
                            chData += *pTemp - 'A' + 10;
                        }
                        else if ( *pTemp>='a' && *pTemp <= 'f' )
                        {
                            chData += *pTemp - 'a' + 10;
                        }
                        else
                        {
                            return 11;// wrong info
                        }
                        bufData[j++] = chData; 

                        pTemp++;
                    } 

                    bufData[j] = '\0'; 
                }

                switch (j)
                {
                case 5:
                    *pType = WEP_40_BIT;
                    if (keysize != WEP_40_BIT)
                        return(12);
                    memcpy(pVal, bufData, 5);
                    break;
                case 13:
                    *pType = WEP_104_BIT;
                    if (keysize != WEP_104_BIT)
                        return(12);
                    memcpy(pVal, bufData, 13);
                    break;
                case 0:
                    /**pType = WEP_NOT_SET;
                    memset(pVal, 0, 16);*/
                    if (keysize != pWep->keyType0)
                    {
                        return(12);
                    }
                    break;
                default:    
                    if ( PrivacyOption == FULL_DATA_ENCRYPT_REQUIRED )
                        return(11);
                    *pType = WEP_NOT_SET;
                    memset(pVal, 0, 16);
                    break;
                }


            }

        }

    if ( PrivacyOption == FULL_DATA_ENCRYPT_REQUIRED )
        if ( checkEmptyKey(pWep) )
        {
            return(2);
        }
    ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &chData);  
    ApCmdSetProc(APCMD_SET_DEFAULT_WEP_KEYS, (char*)pWep);  

    free (pWep);

    chData = 1;
    ApCmdSetProc(APCMD_BSS_START, &chData); 


    return AP_NEEDS_REBOOT;
}

int Radio(webs_t wp, int Error)
{

    if (Error == BEACON_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Beacon range must be between 20 to 1000 !", "radio.asp");
    }
    else if (Error == DTIM_RANGE_ERROR)
    {
        asp_show_error_message(wp, "DTIM range must be between 1 to 255 !", "radio.asp");
    }
    else if (Error == RTS_RANGE_ERROR)
    {
        asp_show_error_message(wp, "RTS range must be between 256 to 2432 !", "radio.asp");
    }
    else if (Error == FRAG_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Fragmentation range must be between 256 to 2346 !", "radio.asp");
    }
    else if (Error == SSID_SIZE_ERROR)
    {
        asp_show_error_message(wp, "SSID size cannot be more than 32 characters !", "radio.asp");
    }
    else if (Error == BURST_RATE_RANGE_ERROR)
    {
        asp_show_error_message(wp, "Burst Rate range must be between 8 to 16 !", "radio.asp");
    }
    else if (Error == AP_NEEDS_REBOOT)
    {
        websRedirect(wp, T("reboot.asp"));  
        return 0;    
    }
    else
    {
        websRedirect(wp, T("radio.asp"));
    }
    return 0;

}
int Wep(webs_t wp, int Error)
{

    if (Error == 1)
    {
        asp_show_error_message(wp, "You Have Entered Invalid WEP Key Value!", "wep.asp");
    }
    else if (Error == 2)
    {
        asp_show_error_message(wp, "You Must Enter WEP Key!", "wep.asp");
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WEP while WPA is enabling!", "wep.asp");
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "Data Encription is required for Shared Key Authentication!", "wep.asp");
    }
    else if (Error == AP_NEEDS_REBOOT)
    {
        websRedirect(wp, T("reboot.asp"));  
        return 0;    
    }
    else
    {
        websRedirect(wp, T("wep.asp"));
    }
    return 0;

}
#if 1 //bt_test:: upload
void apRebooting(webs_t wp, char_t *path)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

#ifdef BRIDGE_POLLING_1
    setBridgeTaskToIntDriven();
#endif

#if 1
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    websWrite(wp, T("<html><head>\n"));
    websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=%s\">\n"), path);
//	websWrite(wp, T("</head><body>You have successfully flashed the new firmware.\n"));
//	websWrite(wp, T("Please click the Reboot button and then close your browser."));	
//	websWrite(wp, T("You will need to refresh the page manually after the AP rebooted itself.")); 
    websWrite(wp, T("</body>\n"));

    websFooter(wp);

    websDone(wp, 200);
#endif

    if (wpaMode==1)
    {

        APICMDBUF_DEAUTH_STA cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_DEAUTH_STA;
        cmdBuf.cmdBodyLen = 6; 
        cmdBuf.staMACAddress[0]=0xff;
        cmdBuf.staMACAddress[1]=0xff;
        cmdBuf.staMACAddress[2]=0xff;
        cmdBuf.staMACAddress[3]=0xff;
        cmdBuf.staMACAddress[4]=0xff;
        cmdBuf.staMACAddress[5]=0xff;
        apctl(&cmdBuf);


    }
#if 1

    pCmdbuf = malloc(sizeof(APICMDBUF));
    pCmdbuf->cmdStatus = APCTL_CMD_FAILED;
    while (pCmdbuf->cmdStatus != APCTL_OK)
    {
        pCmdbuf->cmdCode = APCMD_FW_SOFT_RESET;
        pCmdbuf->seqNum = 1;
        apctl(pCmdbuf);
    }
    free(pCmdbuf);  
#endif
}


/**************************************************************************
*
*
*
*
**************************************************************************/
void apRequestReboot(webs_t wp, char_t *msq)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }



    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    // end of WriteHtmlHeader
    CreateHeader("AP Needs to Reboot");

    websWrite(wp, T("<head>\n"));
//	websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=/index.htm\">\n"));
    websWrite(wp, T("</head><body>%s\n"), msq);
    websWrite(wp, T("<P>Please click the Reboot button and then close your browser."));    
    websWrite(wp, T("You will need to refresh the page manually after the AP rebooted itself.")); 

    websWrite(wp, T("<form method=\"Post\" action=\"Reboot.htm\">"));    
    websWrite(wp, T("<p><input type=\"submit\" value=\"Reboot\" name=\"Submit\">"));
    websWrite(wp, T("</form>"));

    // add GoAhead logo
    websWrite(wp, T("<br><br><br><img border=\"0\" src=\"../Image/GoAhead_Logo.gif\"></font>\r\n"));


    websWrite(wp, T("</body>\n"));

    websFooter(wp);

    websDone(wp, 200);
}


/**************************************************************************
*
*
*
*
**************************************************************************/
void apUpgradeFail(webs_t wp, char_t *path, UINT8 reason)
{
    char_t *date;
    APICMDBUF *pCmdbuf;

#ifdef BRIDGE_POLLING_1
    setBridgeTaskToIntDriven();
#endif
    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }



    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));

    // end of WriteHtmlHeader
    //CreateHeader("Firmware Upgrade");

    websWrite(wp, T("<head>\n"));
	websWrite(wp, T("<meta HTTP-EQUIV=\"refresh\" content=\"10;url=/fw_upgrade.asp\">\n"));
    switch (reason)
    {
    case 0:
        websWrite(wp, T("</head><body>Failed to upload file to device.\n"));
        break;

    case 1:
        websWrite(wp, T("</head><body>Failed to flash the new firmware.\n"));
        websWrite(wp, T("Check to make sure you have a valid image to do the upgrade.\n"));
        break;

    default:
        websWrite(wp, T("</head><body>Unexpected Error\n"));
        break;
    }
    websWrite(wp, T("Please try again.")); 



    // add GoAhead logo
    //websWrite(wp, T("<br><br><br><img border=\"0\" src=\"../Image/GoAhead_Logo.gif\"></font>\r\n"));


    websWrite(wp, T("</body>\n"));

    //websFooter(wp);

    websDone(wp, 200);
#if 1

    pCmdbuf = malloc(sizeof(APICMDBUF));
    pCmdbuf->cmdStatus = APCTL_CMD_FAILED;
    while (pCmdbuf->cmdStatus != APCTL_OK)
    {
        pCmdbuf->cmdCode = APCMD_FW_SOFT_RESET;
        pCmdbuf->seqNum = 1;
        apctl(pCmdbuf);
    }
    free(pCmdbuf);  
#endif
}





int fwUpload(webs_t wp)
{
    char buf[50];
    char_t *date;
    USHORT  nBufSize, nCount;
    char    *pBuf, *pChar;

    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));
#if 1 //bt_test::upload

    // end of WriteHtmlHeader
    CreateHeader("Firmware Upgrade");

    // Get Filter Station List 
#endif //bt_test_end

#if 1 //bt_test:: upload

//    websWrite(wp, T("<html>\r\n"));
//    websWrite(wp, T("<head>\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate\">\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\r\n"));
//    websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"0\">\r\n"));
//    websWrite(wp, T("<title>File Upload Demo</title>\r\n"));
//    websWrite(wp, T("<!-- Written by: Loh Chee Tim,  5-Mar-2001 -->\r\n"));
//    websWrite(wp, T("</head>\r\n"));
    websWrite(wp, T("<body>\r\n"));
    websWrite(wp, T("<form method=\"post\" action=\"/cgi-bin/upgrade\" enctype=\"multipart/form-data\">\r\n"));
    websWrite(wp, T("Select file: <input type=\"file\" name=\"binary\"><br>\r\n"));
    websWrite(wp, T("<input type=\"submit\" value=\"Upgrade\">\r\n"));
    websWrite(wp, T("<input type=\"reset\" value=\"cancel\">\r\n"));
    websWrite(wp, T("</form>\r\n"));
    websWrite(wp, T("</form>\r\n"));
    websWrite(wp, T("</body>\r\n"));
    websWrite(wp, T("</html>\r\n"));

#endif //bt_test_end


    websDone(wp, STATUS_OK);

    return 1;

}
#endif //bt_test_end
#ifdef WDS_FEATURE
int webSetWds(webs_t wp, char_t* query)
{
    UCHAR *pTmp, *pBuf, *pData;
    UCHAR szTarget[10];
    UCHAR MacAddr[6], voidAddr[6];
    USHORT nIndex, nAddr;
    UCHAR chCnt;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    pData = malloc(200); // for max 32 MAC address
    pBuf = malloc(50);

    // set wds mode
    memset(pData, 0, 200);
    pTmp = strstr(query, "WdsMode");
    if (pTmp!=NULL)
    {
        strncpy(pData, pTmp, 80);
        pData[80-1] = '\0';

        if ((pTmp = strchr(pData, '&'))!=NULL)
        {
            *pTmp = '\0';   
        }

        if (strstr(pData, "Disable")!=NULL)
        {
            chCnt = WDS_MODE_DISABLE;
        }
        else if (strstr(pData, "Static")!=NULL)
        {
            chCnt = WDS_MODE_STATIC;
        }
        else if (strstr(pData, "Dynamic")!=NULL)
        {
            chCnt = WDS_MODE_DYNAMIC;
        }

        ApCmdSetProc(APCMD_SET_WDS_MODE, &chCnt);
    }

    pTmp = strstr(query, "DisableAssoc");
    chCnt = (pTmp != NULL)? TRUE:FALSE;

    ApCmdSetProc(APCMD_SET_DISABLE_ASSOC, &chCnt);

    pTmp = strstr(query, "WdsOption");
    chCnt = (pTmp != NULL)? TRUE:FALSE;
    ApCmdSetProc(APCMD_SET_WDS_OPTION, &chCnt);

    // set wds ap address list
    memset(voidAddr, 0, 6);
    memset(pData, 0, 200);
    pTmp = query;
    chCnt = 0;
    for (nIndex=0; nIndex<MAX_WDS_AP_LIST; nIndex++)
    {
		sprintf(szTarget, "WdsAp%d", nIndex); 
        if ((pTmp=strstr(query, szTarget)) != NULL)
        {
            memset(MacAddr, 0, 6);
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                nAddr = 0;

                while (nAddr < 6)
                {
                    pTmp++;

                    if (*pTmp=='%' && *(pTmp+1)=='3' && (*(pTmp+2)=='A' || *(pTmp+2)=='a'))
                    {
                        pTmp = pTmp+2;
                        continue;
                    }

                    if (*pTmp>='A' && *pTmp<='F')
                    {
                        MacAddr[nAddr] = *pTmp - 'A' + 10;
                    }
                    else if (*pTmp>='a' && *pTmp<='f')
                    {
                        MacAddr[nAddr] = *pTmp - 'a' + 10;
                    }
                    else if (*pTmp>='0' && *pTmp<='9')
                    {
                        MacAddr[nAddr] = *pTmp - '0';
                    }
                    else
                    {
                        continue;
                    }

                    pTmp++;

                    if (*pTmp>='A' && *pTmp<='F')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - 'A' + 10);
                    }
                    else if (*pTmp>='a' && *pTmp<='f')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - 'a' + 10);
                    }
                    else if (*pTmp>='0' && *pTmp<='9')
                    {
                        MacAddr[nAddr] = (MacAddr[nAddr] << 4) | (*pTmp - '0');
                    }

                    nAddr++;
                }

                // Get MacAddr, put into list if a valid one
                if (memcmp(MacAddr, voidAddr, 6)==0)
                {
					continue;
                }
                else
                {
					memcpy((UCHAR*)(pData+chCnt*6+2), MacAddr, 6);
                    chCnt ++;
                }
            }
        }
    }

    pData[0] = chCnt;
    pData[1] = 0;
    ApCmdSetProc(APCMD_SET_WDS_LIST, pData);

    free (pBuf);
    free (pData);
    return 1;

}
#endif
int webSetFilterTable(webs_t wp, char_t* query)
{
    UCHAR *pTmp, *pEnd, *pBuf, *pData;
    UCHAR szTarget[10];
    UCHAR MacAddr[6], voidAddr[6];
    USHORT nIndex, nAddr, j;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    pData = malloc(200);
    pBuf = malloc(50);

    memset(voidAddr, 0, 6);
    memset(pData, 0, 200);
    pTmp = query;

    for (nIndex=0; nIndex<MAX_STA_IN_FILTER_LIST; nIndex++)
    {
        sprintf(szTarget, "Sta%d", nIndex+1); 
        if ((pTmp=strstr(query, szTarget)) != NULL)
        {
            memset(MacAddr, 0, 6);
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                pTmp++;

                if ((pEnd=strchr(pTmp, '&')) != NULL)
                {
                    *pEnd = '\0';
                }

                getMacFromString(MacAddr, pTmp);

                if (memcmp(MacAddr, voidAddr, 6)==0)
                {
                    break;
                }
                else
                {
                    memcpy((UCHAR*)(pData+nIndex*6+2), MacAddr, 6);
                }
            }
        }
    }

//	memcpy((USHORT*)pData, &nIndex, 2);
    *pData = 0;
    *(pData+1) = nIndex & 0xFF;
    ApCmdSetProc(APCMD_SET_WLAN_FILTER_LIST, pData);

    free (pBuf);
    free (pData);
    {
        char chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }

    return 1;

}

int webSetIpConfig(webs_t wp, char_t* query)
{
    char    *pTmp, Buf[20], target[10];
    char    *pTemp, *pCur, chData; 
    int     i, j;
    USHORT nData;

    if (query == NULL || strlen(query)==0)
    {
        return 1;
    }

    pTmp = malloc(200);

    memset(pTmp, 0, 200);
    memset(Buf, 0, 20);


    // DHCP option
    pCur = strstr(query, "DHCP");

    if (pCur!=NULL)
    {
        strcpy(pTmp, pCur);

        if ((pTemp = strchr(pTmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strchr(pTmp, '1')!=NULL) // DHCP enabled
        {
            *((ULONG*)Buf) = 1;
        }
        else
        {
            *((ULONG*)Buf) = 0;
        }
        // get ip address
        strcpy(target, "IPAddr ");

        for (i=1; i<=4; i++)
        {
            target[6] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }


                nData = 0;

                pTemp = pTmp+8;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+3+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }

        // get subnet mask
        strcpy(target, "Subnet ");

        for (i=1; i<=4; i++)
        {
            target[6] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }


                nData = 0;

                pTemp = pTmp+8;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+7+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }

        // get gateway
        strcpy(target, "Gateway ");

        for (i=1; i<=4; i++)
        {
            target[7] = '0'+i;

            pCur = strstr(query, target);

            if (pCur!=NULL)
            {
                strcpy(pTmp, pCur);

                if ((pTemp = strchr(pTmp, '&'))!=NULL)
                {
                    *pTemp = '\0';  
                }
                else
                {
                    free (pTmp);
                    return 0;
                }

                j = 1;
                nData = 0;

                pTemp = pTmp + 9;

                while (*pTemp!='\0')
                {
                    if (*pTemp>='0' && *pTemp<='9')
                    {
                        nData = nData*10 + *pTemp - '0';
                        pTemp++;
                    }
                    else
                    {
                        free (pTmp);
                        return 0;
                    }
                }

                if (nData>255)
                {
                    free(pTmp);
                    return 0;
                }

                *(Buf+11+i)=(UCHAR)nData;
            }
            else
            {
                free (pTmp);
                return 0;
            }

        }




        ApCmdSetProc(APCMD_SET_ETH_IP_CONFIG, Buf);  
    }

    free (pTmp);

    {
        char chData = 1;
        ApCmdSetProc(APCMD_BSS_START, &chData); 
    }

    return 1;

}

#ifdef TEST_REG_RW
/**************************************************************************
*
*
*
*
**************************************************************************/
int SetReg(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur, *tmp; 
    int     i;
    char    chData;
    char    bufData[50];
    USHORT setFlag = 0;
    int z;


    APICMDBUF_SET_BB_REG regCmdBuf;

    regCmdBuf.cmdCode = APCMD_SET_BB_REG;
    regCmdBuf.seqNum = 1;
    regCmdBuf.cmdBodyLen = 3;

    tmp = malloc(250);


    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }



    // Set baseband register
    pCur = strstr(query, "reg_num");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }

            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (i == 0)
                {
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData = bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData = bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData = bufData[i] - '0';
                    }
                }
                else if ( i ==1)
                {
                    chData = chData << 4;
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData += bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData += bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData += bufData[i] - '0';
                    }

                }

            }
            regCmdBuf.regNum = chData;
            curReg = regCmdBuf.regNum;
        }

    }

    pCur = strstr(query, "reg_val");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }

            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (i == 0)
                {
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData = bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData = bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData = bufData[i] - '0';
                    }
                }
                else if ( i ==1)
                {
                    chData= chData << 4;
                    if ( (bufData[i] > 0x40) && (bufData[i] < 0x47))
                    {
                        chData += bufData[i] - 'A' + 10;
                    }
                    else if ( (bufData[i] > 0x60) && (bufData[i] < 0x67))
                    {
                        chData += bufData[i] - 'a' + 10;
                    }
                    else
                    {
                        chData += bufData[i] - '0';
                    }

                }

            }
            regCmdBuf.regVal = chData;

        }

    }

    pCur = strstr(query, "reg_set");    
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        // Set SSID
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }
            setFlag = atoi(bufData);
        }
    }


    if (setFlag)
    {
        apctl(&regCmdBuf);
    }


    free(tmp);

    return 1;

}

/**************************************************************************
*
*
*
*
**************************************************************************/
int regSetting(webs_t wp)
{
    char_t  *date;
    char    buf[50];
    char    *ptr;
    char    chData = TRUE;
    USHORT  nData, i;
    ULONG   lData;
    unsigned char addr[4];



    //WriteHTMLHeader();
    websWrite(wp, T("HTTP/1.1 %d %s\r\n"), STATUS_OK, websErrorMsg(STATUS_OK));
    websWrite(wp, T("Server: %s\r\n"), WEBS_NAME);

    if ((date = websGetDateString(NULL)) != NULL)
    {
        websWrite(wp, T("Date: %s\r\n"), date);
        bfree(B_L, date);
    }

    websWrite(wp, T("Pragma: no-cache\r\nCache-Control: no-cache\r\n"));
    websWrite(wp, T("Content-Type: text/html\r\n"));
    websWrite(wp, T("\r\n"));
    // end of WriteHtmlHeader

    CreateHeader("Baseband Reg Setting");

    websWrite(wp, T("<form method=\"Post\" action=\"SetReg.htm\">"));    
    websWrite(wp, T("<table border=\"0\" width=\"550\">\r\n"));

    //Baseband Register setting
    {
        APICMDBUF_GET_BB_REG regCmdbuf;

        regCmdbuf.cmdCode = APCMD_GET_BB_REG;
        regCmdbuf.seqNum = 1;
        regCmdbuf.cmdBodyLen = 3;
        regCmdbuf.regNum = curReg;
        apctl(&regCmdbuf);

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Operation</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"radio\" name=\"reg_set\" value=\"0\" size=\"20\" checked>Read     "));
        websWrite(wp, T("<input type=\"radio\" name=\"reg_set\" value=\"1\" size=\"20\">Write"));
        websWrite(wp, T("</td></tr>\r\n"));

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Register Offset</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"text\" name=\"reg_num\" value=\"%02x\" size=\"2\"> (Hex)"), regCmdbuf.regNum);
        websWrite(wp, T("</td></tr>\r\n"));

        websWrite(wp, T("<tr>"));
        websWrite(wp, T("<td width=\"35%%\">Register Value</td>"));
        websWrite(wp, T("<td width=\"65%%\"><input type=\"text\" name=\"reg_val\" value=\"%02x\" size=\"2\">(Hex)"), regCmdbuf.regVal);
        websWrite(wp, T("</td></tr>\r\n"));
    }


    //End of table
    websWrite(wp, T("</table>"));

    // Apply, Reset, Cancel button
    websWrite(wp, T("<p><input type=\"submit\" value=\"Apply\" name=\"Submit\">"));
    websWrite(wp, T("<input type=\"reset\" value=\"Reset\" name=\"Reset\">"));
    websWrite(wp, T("<input type=\"button\" value=\"Cancel\" name=\"Cancel\"></p>"));
    websWrite(wp, T("</form>"));


    // add GoAhead logo
    websWrite(wp, T("<br><br><br><img border=\"0\" src=\"Image/GoAhead_Logo.gif\"></font>\r\n"));


    //websResponse(wp, STATUS_OK, buf, NULL);
    websDone(wp, STATUS_OK);


    return 1;
}

#endif /* TEST_REG_RW */


int wpaConfig(webs_t wp, int Error)
{
    char_t *date;
    char    chData;
    char    passPhrase[30];
    char    buf[100];
    UINT32  icvErr;
    UINT32  locMicFail;
    UINT32  rmotMicFail;
    UINT32  cntMeasInvk;



    if (Error == 0)
    {
        websRedirect(wp, T("wpa.asp")); 
        return 0;   

    }
    else if (Error == 1)
    {
        asp_show_error_message(wp, "You Have Entered Invalid Pass Phase!", "wpa.asp");
        return 0;    
    }
    else if (Error == 2)
    {
        websRedirect(wp, T("reboot.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;       
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WPA while WEP is enabling!", "wpa.asp"); 
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "passwords must contain more than 7 and less than 64 characters", "wpa.asp");  
        return 0;   
    }


    if (Error == 2)
    {
        websRedirect(wp, T("reboot.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;
    }

/*
    // Get WPA mode
    {
        APICMDBUF_GET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_PRIVACY_TBL_RSN_ENABLED;
        cmdBuf.cmdBodyLen = 1;
        apctl(&cmdBuf);
        chData = cmdBuf.Enabled;
    }
    if(chData==1)
        WpaEnabled=TRUE;
    else
        WpaEnabled=FALSE;		   

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"40%c\">WPA Mode</td>"),0x25);
    websWrite(wp, T("<td width=\"60%c\"><select size=\"1\" name=\"wpaMode\">"), 0x25);
    websWrite(wp, T("<option%s>Disabled</option>"), chData==0?" selected":"");
    websWrite(wp, T("<option%s>Enabled</option>"), chData==1?" selected":"");
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));

    // Get Auth Method
    {
        APICMDBUF_GET_RSN_CFG_AUTH_SUITE cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_RSN_CFG_AUTH_SUITE;
        cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
        apctl(&cmdBuf);
        chData = cmdBuf.AuthSuites[3];
    }

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"40%c\">Authentication Method</td>"),0x25);
    websWrite(wp, T("<td width=\"60%c\"><select size=\"1\" name=\"wpaAuthMethod\">"), 0x25);
    websWrite(wp, T("<option%s>Pre-Shared Keys</option>"), (chData==2)?" selected":"");
    websWrite(wp, T("<option%s>802.1x</option>"), (chData==1)?" selected":"");
    websWrite(wp, T("</select></td>"));
    websWrite(wp, T("</tr>"));
    
    // Get Auth Pass Phrase
    //can't read it from API since it's Write only
    strcpy(passPhrase, "**********");
    
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"35%c\">Pass Phrase </td>"),0x25);
    websWrite(wp, T("<td width=\"65%c\"><input type=\"text\" name=\"wpaPhrase\" value=\"%s\" size=\"30\"></td>"),\
                        0x25, passPhrase);

    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"100%c\" colspan=\"2\"><font size=\"1\">_________________________________________________________________________________________</font></td>"),0x25);
    websWrite(wp, T("</tr></table>\r\n")); 

    //Get WPA Counter status
    {
        APICMDBUF_GET_RSN_STATS cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_GET_RSN_STATS;
        cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_STATS) - 4*sizeof(unsigned short);;
        apctl(&cmdBuf);

        icvErr = cmdBuf.TKIPICVErrors;
        locMicFail = cmdBuf.TKIPLocalMICFailures;
        rmotMicFail = cmdBuf.TKIPRemoteMICFailures;
        cntMeasInvk = cmdBuf.TKIPCounterMeasuresInvoked;
    }

    websWrite(wp, T("<table border=\"0\" width=\"300\">\r\n"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">ICV Errors:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, icvErr);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">Local MIC Failures:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, locMicFail);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\">Remote MIC Failures:</td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, rmotMicFail);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("<tr>"));
    websWrite(wp, T("<td width=\"70%c\"><nobr>Counter Measures Invoked:</nobr></td>"),0x25);
    websWrite(wp, T("<td width=\"30%c\"> 0x%x"), 0x25, cntMeasInvk);
    websWrite(wp, T("</tr>"));
    websWrite(wp, T("</table>\r\n")); 
    
    websWrite(wp, T("<br>"));
    websWrite(wp, T("<p><input type=\"submit\" value=\"Apply\" name=\"Submit\">"));
    websWrite(wp, T("<input type=\"reset\" value=\"Reset\" name=\"Reset\">"));
    websWrite(wp, T("<input type=\"button\" value=\"Cancel\" name=\"Cancel\"></p></form>")); 

    websDone(wp, STATUS_OK);

    return 1;
*/
}


int SetWpa(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData;
    unsigned char    bufData[200];
    unsigned char    PasswordData[100];
    USHORT nData, *pType;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption;

    //UINT8 wpaMode;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    // WPA Mode
    pCur = strstr(query, "wpaMode");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "Enabled")!=NULL)
        {

            if (WepEnabled==TRUE)
                return 3;
            wpaMode = 1;
        }
        else
        {
            wpaMode = 0;
        }

        if (wpaMode==1)
            WpaEnabled=TRUE;
        else
            WpaEnabled=FALSE;       

        //set Wpa Mode
        {
            APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_PRIVACY_TBL_RSN_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }

    // WPA Auth Method
    pCur = strstr(query, "wpaAuthMethod");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "802.1x")!=NULL)
        {
            chData = 1;
        }
        else
        {
            chData = 2;
        }

        //set Wpa Auth Meth
        {
            APICMDBUF_SET_RSN_CFG_AUTH_SUITE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_AUTH_SUITE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
            cmdBuf.AuthSuites[0] = 0x0;
            cmdBuf.AuthSuites[1] = 0x50;
            cmdBuf.AuthSuites[2] = 0xf2;
            cmdBuf.AuthSuites[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }


    //WPA Pass Phrase
    pCur = strstr(query, "wpaPhrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 200);
            memset(PasswordData, 0, 100);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }                        

            for (i=0,j=0; i<(int)strlen(bufData);i++,j++)
            {

                if (bufData[i]=='%')
                {
                    if (bufData[i+1]== '2')
                    {

                        switch (bufData[i+2])
                        {
                        case '0':
                            PasswordData[j]=' ';
                            break;                                  

                        case '1':
                            PasswordData[j]='!';
                            break;      

                        case '2':
                            PasswordData[j]='"';
                            break;  

                        case '3':
                            PasswordData[j]='#';
                            break;  

                        case '4':
                            PasswordData[j]='$';
                            break;  

                        case '5':
                            PasswordData[j]='%';
                            break;  

                        case '6':
                            PasswordData[j]='&';
                            break;  

                        case '7':
                            PasswordData[j]='\'';
                            break;  

                        case '8':
                            PasswordData[j]='(';
                            break;  

                        case '9':
                            PasswordData[j]=')';
                            break;  

                        case 'A':
                            PasswordData[j]='*';
                            break;  

                        case 'B':
                            PasswordData[j]='+';
                            break;  

                        case 'C':
                            PasswordData[j]=',';
                            break;

                        case 'D':
                            PasswordData[j]='-';
                            break;  

                        case 'E':
                            PasswordData[j]='.';
                            break;  

                        case 'F':
                            PasswordData[j]='/';
                            break;                                                                          

                        default:
                            break;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
                        }
                        i +=2;                                                                                              
                    }
                    else if (bufData[i+1]== '3')
                    {
                        switch (bufData[i+2])
                        {
                        case 'A':
                            PasswordData[j]=':';
                            break;  

                        case 'B':
                            PasswordData[j]=';';
                            break;  

                        case 'C':
                            PasswordData[j]='<';
                            break;

                        case 'D':
                            PasswordData[j]='=';
                            break;  

                        case 'E':
                            PasswordData[j]='>';
                            break;  

                        case 'F':
                            PasswordData[j]='?';
                            break;                                                                          

                        default:
                            break;  
                        }
                        i +=2;                                                                      
                    }
                    //no need to detect '@'
                    else if (bufData[i+1]== '5')
                    {

                        switch (bufData[i+2])
                        {
                        
                        case 'B':
                            PasswordData[j]='[';
                            break;  

                        case 'C':
                            PasswordData[j]='\\';
                            break;

                        case 'D':
                            PasswordData[j]=']';
                            break;  

                        case 'E':
                            PasswordData[j]='^';
                            break;  

                        case 'F':
                            PasswordData[j]='_';
                            break;                                                                          

                        default:
                            break;      
                        }
                        i +=2;                                                      
                    }
                    else if (bufData[i+1]== '6')
                    {
                        switch (bufData[i+2])
                        {
                        
                        case '0':
                            PasswordData[j]='`';
                            break;                                                                          

                        default:
                            break;                              
                        }
                        i +=2;
                    }
                    else if (bufData[i+1]== '7')
                    {
                        switch (bufData[i+2])
                        {
                        case 'B':
                            PasswordData[j]='{';
                            break;  

                        case 'C':
                            PasswordData[j]='|';
                            break;

                        case 'D':
                            PasswordData[j]='}';
                            break;  

                        case 'E':
                            PasswordData[j]='~';
                            break;                                                                                                          

                        default:
                            break;      
                        }
                        i +=2;                                                      
                    }
                }
                else
                {
                    PasswordData[j]=bufData[i];
                }

            }   

            if ( (strlen(PasswordData) <=7) || (strlen(PasswordData) >= 64) )
                return 4;
            // if(strcmp(bufData, "**********") != 0)
            if (strcmp(PasswordData, "**********") != 0)
            {
                //Set Pass Phrase
                {
                    APICMDBUF_SET_PSK_PASSPHRASE cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_PSK_PASSPHRASE;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.passphrase, PasswordData);
                    apctl(&cmdBuf);
                }
            }

        }
    }

    pCur = strstr(query, "wpaGrpReKeyTime");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 200);
            memset(PasswordData, 0, 100);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = 0;/*null terminator*/
                }
            }
            //Set Grp Rekey Timeout time
            {
                APICMDBUF_SET_GRP_REKEY_TIME cmdBuf;

                cmdBuf.seqNum = 1;
                cmdBuf.cmdCode = APCMD_SET_GRP_REKEY_TIME;
                cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME) - 4*sizeof(unsigned short);;
                cmdBuf.rekey_time = atol(bufData);
                apctl(&cmdBuf);
            }
        }
    }

    SetUserConfig();  
    if (wpaMode == 1)
    {
        return 2;           
    }
    else
    {
        {
            APICMDBUF_DEAUTH_STA cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_DEAUTH_STA;
            cmdBuf.cmdBodyLen = 6; 
            cmdBuf.staMACAddress[0]=0xff;
            cmdBuf.staMACAddress[1]=0xff;
            cmdBuf.staMACAddress[2]=0xff;
            cmdBuf.staMACAddress[3]=0xff;
            cmdBuf.staMACAddress[4]=0xff;
            cmdBuf.staMACAddress[5]=0xff;
            apctl(&cmdBuf);

        }               
        //chData = 1;
        //ApCmdSetProc(APCMD_BSS_START, &chData); 			
        return 0;
    }
}

/* String Names of Bridge MAC Address in Web Pages */
static char bridgeMacNames[][16] ={
    "WanMac",
    "LanMac",
    "GwWanMac",
    "GwLanMac",
    "WlanMac"
};
static int bridgeMacNum = sizeof(bridgeMacNames) / sizeof(bridgeMacNames[0]);

/* Function Pointer Array to Set Bridge MAC Address */
typedef void (*mac_set_function)(const unsigned char*);
#if 0
static mac_set_function macSetFunctions[] = {
    &SetWanMac,
    &SetLanMac,
    &SetGwWanMac,
    &SetGwLanMac,
    &SetWlanMac
};
#endif
int SetBridge(webs_t wp, char_t* query) {
    UCHAR *pTmp, *pEnd, *pBuf;
    UCHAR MacAddr[6];
    USHORT nIndex;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }
#if 0
    pBuf = malloc(50);
    pTmp = query;

    for (nIndex=0; nIndex<bridgeMacNum; nIndex++)
    {
        if ((pTmp=strstr(query, bridgeMacNames[nIndex])) != NULL)
        {
            memset(pBuf, 0, 50);
            memcpy(pBuf, pTmp, 50);

            if ((pTmp=strchr(pBuf, '='))!=NULL)
            {
                pTmp++;

                if ((pEnd=strchr(pTmp, '&')) != NULL)
                {
                    *pEnd = '\0';
                }

                getMacFromString(MacAddr, pTmp);
                macSetFunctions[nIndex](MacAddr);
            }
        }
    }

    free (pBuf);

    UserConfigModified();
    SaveUserConfig();
#endif
    return 1;   
}

int securityConfig(webs_t wp, int Error)
{
    char_t *date;
    char    chData;
    char    passPhrase[30];
    char    buf[100];
    UINT32  icvErr;
    UINT32  locMicFail;
    UINT32  rmotMicFail;
    UINT32  cntMeasInvk;



    if (Error == 0)
    {
        websRedirect(wp, T("wep.asp")); 
        return 0;   

    }
    else if (Error == 1)
    {
        asp_show_error_message(wp, "You have entered invalid Passphrase!", "wep.asp");
        return 0;    
    }
    else if (Error == AP_NEEDS_REBOOT)//error number=8
    {
        websRedirect(wp, T("reboot.asp")); 
        //apRequestReboot(wp, "WPA updated Successful. ");
        return 0;       
    }
    else if (Error == 3)
    {
        asp_show_error_message(wp, "Cannot enable WPA while WEP is enabled!", "wep.asp"); 
    }
    else if (Error == 4)
    {
        asp_show_error_message(wp, "Passwords must contain more than 8 and less than 64 characters!", "wep.asp");  
        return 0;   
    }

    else if (Error == 11)
    {
        asp_show_error_message(wp, "You have entered invalid WEP Key Value!", "wep.asp");
    }
    else if (Error == 12)
    {
        asp_show_error_message(wp, "WEP Key Size selected does not match the Key Value length!", "wep.asp");
    }
}


int SetSecurity(webs_t wp, char_t* query)
{
    char    tmp[400];
    char    *pTemp, *pCur, *pVal; 
    int     i, j;
    unsigned char    chData;
    unsigned char    bufData[200];
    unsigned char    PasswordData[100];
    unsigned char DataToWlandrv[100];
    unsigned char DataFromUser[200];        
    USHORT nData, *pType;
    WEP_KEY  *pWep;
    unsigned char PrivacyOption;
    char setResult = 0;

    //UINT8 wpaMode;

    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    // WPA Mode
    pCur = strstr(query, "wpaMode");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "WPA-PSK")!=NULL)
        {
            chData =  2;
            wpaMode = 1;
        }
        else if (strstr(tmp, "WPA-802.1x")!=NULL)
        {
            chData =  1;
            wpaMode = 1;
        }
        else
        {
            wpaMode = 0;
        }

        if (wpaMode==1)
            WpaEnabled=TRUE;
        else
            WpaEnabled=FALSE;       

        //set Wpa Mode
        {
            APICMDBUF_SET_PRIVACY_TBL_RSN_ENABLED cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_PRIVACY_TBL_RSN_ENABLED;
            cmdBuf.cmdBodyLen = 1;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);


        }
        //set Wpa Auth Meth
        if (WpaEnabled==TRUE)
        {
            APICMDBUF_SET_RSN_CFG_AUTH_SUITE cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_AUTH_SUITE;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_AUTH_SUITE) - 4*sizeof(unsigned short);
            cmdBuf.AuthSuites[0] = 0x0;
            cmdBuf.AuthSuites[1] = 0x50;
            cmdBuf.AuthSuites[2] = 0xf2;
            cmdBuf.AuthSuites[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
    }

    // WPA Auth Method
    pCur = strstr(query, "wpaDataEncryption");
    if (pCur!=NULL)
    {
        strcpy(tmp, pCur);

        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';  
        }

        if (strstr(tmp, "TKIP")!=NULL)
        {
            chData = 2;
        }
        else if (strstr(tmp, "CCMP")!=NULL)
        {
            chData = 4;
        }
        else
        {
            chData = 0;
        }

        //set Wpa Unicast Cipher
        {
            APICMDBUF_SET_RSN_CFG_UNICAST_CIPHERS cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_UNICAST_CIPHERS;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_UNICAST_CIPHERS) - 4*sizeof(unsigned short);
            cmdBuf.UnicastCipher[0] = 0x0;
            cmdBuf.UnicastCipher[1] = 0x50;
            cmdBuf.UnicastCipher[2] = 0xf2;
            cmdBuf.UnicastCipher[3] = chData;
            cmdBuf.Enabled = wpaMode;
            apctl(&cmdBuf);
        }
        //set Wpa Multicast Cipher
        {
            APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_SET_RSN_CFG_MULTICAST_CIPHERS;
            cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_RSN_CFG_MULTICAST_CIPHERS) - 4*sizeof(unsigned short);
            cmdBuf.MulticastCipher[0] = 0x0;
            cmdBuf.MulticastCipher[1] = 0x50;
            cmdBuf.MulticastCipher[2] = 0xf2;
            cmdBuf.MulticastCipher[3] = chData;
            apctl(&cmdBuf);
        }
    }
    if (WpaEnabled==TRUE)
    {
        chData = DATA_ENCRYPT_NOT_REQUIRED;
        ApCmdSetProc(APCMD_SET_PRIVACY_OPTION, &chData);
#ifdef TURBO_SETUP
        TsModeChangeTo(4);
#endif
    }

    //WPA Pass Phrase
    pCur = strstr(query, "wpaPhrase");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
            if ( (strlen(DataToWlandrv) <=7) || (strlen(DataToWlandrv) >= 64) )
                return 4;

            if (strcmp(DataToWlandrv, "**********") != 0)
            {
                //Set Pass Phrase
                {
                    APICMDBUF_SET_PSK_PASSPHRASE cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_PSK_PASSPHRASE;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_PSK_PASSPHRASE) - 4*sizeof(unsigned short);;
                    strcpy(cmdBuf.passphrase, DataToWlandrv);
                    apctl(&cmdBuf);
                }            
            }

        }
    }
    pCur = strstr(query, "wpaGrpReKeyTime");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         

            if (atol(DataToWlandrv) != 0)
            {
                //Set Grp Rekey Timeout time
                {
                    APICMDBUF_SET_GRP_REKEY_TIME cmdBuf;

                    cmdBuf.seqNum = 1;
                    cmdBuf.cmdCode = APCMD_SET_GRP_REKEY_TIME;
                    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_SET_GRP_REKEY_TIME) - 4*sizeof(unsigned short);;
                    cmdBuf.rekey_time = atol(DataToWlandrv);
                    apctl(&cmdBuf);
                }            
            }

        }
    }

/* Add WEP Setting */
    if (!wpaMode)
    {
        setResult = SetWep(wp, query);
        if (setResult != 0)
        {
            return setResult;
        }
    }
/* Add WEP Setting end */

    SetUserConfig();  
    {
        APICMDBUF_DEAUTH_STA cmdBuf;

        cmdBuf.seqNum = 1;
        cmdBuf.cmdCode = APCMD_DEAUTH_STA;
        cmdBuf.cmdBodyLen = 6; 
        cmdBuf.staMACAddress[0]=0xff;
        cmdBuf.staMACAddress[1]=0xff;
        cmdBuf.staMACAddress[2]=0xff;
        cmdBuf.staMACAddress[3]=0xff;
        cmdBuf.staMACAddress[4]=0xff;
        cmdBuf.staMACAddress[5]=0xff;
        apctl(&cmdBuf);

    }           
    return AP_NEEDS_REBOOT; 
/*	
    if(wpaMode == 1)
    {
        return 2;			
    }
    else
    {
       {
            APICMDBUF_DEAUTH_STA cmdBuf;

            cmdBuf.seqNum = 1;
            cmdBuf.cmdCode = APCMD_DEAUTH_STA;
            cmdBuf.cmdBodyLen = 6; 
            cmdBuf.staMACAddress[0]=0xff;
            cmdBuf.staMACAddress[1]=0xff;
            cmdBuf.staMACAddress[2]=0xff;
            cmdBuf.staMACAddress[3]=0xff;
            cmdBuf.staMACAddress[4]=0xff;
            cmdBuf.staMACAddress[5]=0xff;
            apctl(&cmdBuf);
           
        }    			
        //chData = 1;
        //ApCmdSetProc(APCMD_BSS_START, &chData); 			
        return 0;
    }		 
*/  
}

int ProcessUserData(char * DataFromUser, char * DataToWlandrv, char * pTemp)
{
    unsigned short i,j;

    memset(DataFromUser, 0, DATA_SIZE_FROM_USER);
    memset(DataToWlandrv, 0, DATA_SIZE_TO_WLADRV);
    strcpy(DataFromUser, pTemp);    

    for (i=0; i<(int)strlen(DataFromUser);i++)
    {
        if (DataFromUser[i]=='+')
        {
            DataFromUser[i] = ' ';
        }
    }                        

    for (i=0,j=0; i<(int)strlen(DataFromUser);i++,j++)
    {

        if (DataFromUser[i]=='%')
        {
            if (DataFromUser[i+1]== '2')
            {

                switch (DataFromUser[i+2])
                {
                case '0':
                    DataToWlandrv[j]=' ';
                    break;                                  

                case '1':
                    DataToWlandrv[j]='!';
                    break;      

                case '2':
                    DataToWlandrv[j]='"';
                    break;  

                case '3':
                    DataToWlandrv[j]='#';
                    break;  

                case '4':
                    DataToWlandrv[j]='$';
                    break;  

                case '5':
                    DataToWlandrv[j]='%';
                    break;  

                case '6':
                    DataToWlandrv[j]='&';
                    break;  

                case '7':
                    DataToWlandrv[j]='\'';
                    break;  

                case '8':
                    DataToWlandrv[j]='(';
                    break;  

                case '9':
                    DataToWlandrv[j]=')';
                    break;  

                case 'A':
                    DataToWlandrv[j]='*';
                    break;  

                case 'B':
                    DataToWlandrv[j]='+';
                    break;  

                case 'C':
                    DataToWlandrv[j]=',';
                    break;

                case 'D':
                    DataToWlandrv[j]='-';
                    break;  

                case 'E':
                    DataToWlandrv[j]='.';
                    break;  

                case 'F':
                    DataToWlandrv[j]='/';
                    break;                                                                          

                default:
                    break;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
                }
                i +=2;                                                                                              
            }
            else if (DataFromUser[i+1]== '3')
            {
                switch (DataFromUser[i+2])
                {
                case 'A':
                    DataToWlandrv[j]=':';
                    break;  

                case 'B':
                    DataToWlandrv[j]=';';
                    break;  

                case 'C':
                    DataToWlandrv[j]='<';
                    break;

                case 'D':
                    DataToWlandrv[j]='=';
                    break;  

                case 'E':
                    DataToWlandrv[j]='>';
                    break;  

                case 'F':
                    DataToWlandrv[j]='?';
                    break;                                                                          

                default:
                    break;  
                }
                i +=2;                                                                      
            }
            //no need to detect '@'
            else if (DataFromUser[i+1]== '5')
            {

                switch (DataFromUser[i+2])
                {
                
                case 'B':
                    DataToWlandrv[j]='[';
                    break;  

                case 'C':
                    DataToWlandrv[j]='\\';
                    break;

                case 'D':
                    DataToWlandrv[j]=']';
                    break;  

                case 'E':
                    DataToWlandrv[j]='^';
                    break;  

                case 'F':
                    DataToWlandrv[j]='_';
                    break;                                                                          

                default:
                    break;      
                }
                i +=2;                                                      
            }
            else if (DataFromUser[i+1]== '6')
            {
                switch (DataFromUser[i+2])
                {
                
                case '0':
                    DataToWlandrv[j]='`';
                    break;                                                                          

                default:
                    break;                              
                }
                i +=2;
            }
            else if (DataFromUser[i+1]== '7')
            {
                switch (DataFromUser[i+2])
                {
                case 'B':
                    DataToWlandrv[j]='{';
                    break;  

                case 'C':
                    DataToWlandrv[j]='|';
                    break;

                case 'D':
                    DataToWlandrv[j]='}';
                    break;  

                case 'E':
                    DataToWlandrv[j]='~';
                    break;                                                                                                          

                default:
                    break;      
                }
                i +=2;                                                      
            }
        }
        else
        {
            DataToWlandrv[j]=DataFromUser[i];
        }

    }               
    return 0;
}

#ifdef AP_SITE_SURVEY
/**************************************************************************
*
*
*
*
**************************************************************************/
int SetSurvey(webs_t wp, char_t* query)
{

    char    *pTemp, *pCur;
    unsigned char *tmp; 
    int     i;
    char    chData;
    char    joinAction = 0;
    char    bufData[50];
    unsigned char bssidAddr[6];


    if (query == NULL || strlen(query)==0)
    {
        return 0;
    }

    if ((tmp = malloc(250)) == NULL)
    {
        return 0;
    }

    pCur = strstr(query, "action");
    if (pCur != NULL)
    {
        strcpy(tmp, pCur);

        // Set SSID
        if ((pTemp = strchr(tmp, '&'))!=NULL)
        {
            *pTemp = '\0';
        }

        if ( (pTemp = strchr(tmp, '='))!=NULL)
        {
            pTemp++; 

            memset(bufData, 0, 50);
            strcpy(bufData, pTemp);


            for (i=0; i<(int)strlen(bufData);i++)
            {
                if (bufData[i]=='+')
                {
                    bufData[i] = ' ';
                }
            }
            if (memcmp(bufData, "Join", 4) == 0)
            {
                joinAction = 1;
            }
        }
    }
    if (joinAction)
    {

        pCur = strstr(query, "peer");
        if (pCur != NULL)
        {
            strcpy(tmp, pCur);

            /* Set SSID */
            if ((pTemp = strchr(tmp, '&'))!=NULL)
            {
                *pTemp = '\0';
            }

            if ( (pTemp = strchr(tmp, '='))!=NULL)
            {
                pTemp++; 

                ProcessUserData(DataFromUser, DataToWlandrv, pTemp);         
                if ( (strlen(DataToWlandrv) >32) )
                {
                    free(tmp);
                    return 0;
                }
            }
        }
    }

    free(tmp);

    if (joinAction)
    {
        ApCmdSetProc(APCMD_SET_SSID, DataToWlandrv);
    }
    else
    {
        ApCmdSetProc(APCMD_SET_SURVEY_SCAN, &chData);
    }

    return joinAction;

}
#endif /* AP_SITE_SURVEY */
