#include "basic_types.h"
#include "IEEE_types.h"
#include "oem.h"
#include "api.h"
#include "nv.h"
#include "pcmcia_p.h"

unsigned char LocalMacAddress[6];
//extern void etherSwitch_Init( void );
extern void os_TaskDelay(long long);
extern unsigned char ReadRfReg(unsigned char offset);
extern void WriteRfReg(unsigned char offset,unsigned char value);

#define CALIBRATION_20	0xFFFFFF7D
#define CALIBRATION_26	0xFFFFFF7A

#define LAN_INIT
//#define WAN_INIT
//#define TX_POWER_LEVEL
#define NEW_TX_POWER_LEVEL
#define DTIM_OPTION
#define PREAMBLE_OPTION
#define BEACON_SETTING
#define RTS_SETTING
#define FRAGMENTATION

#define	DISABLE_RTSCTS

//#define DISABLE_ALL_API

#define BASIC_DATA_RATE
#define AP_MODE


char LAN_MAC[6]={0x00,0xc0,0x02,0x0b,0x6a,0x11};
//char WAN_MAC[6]={0x00,0xc0,0x02,0x0b,0x6a,0x12};



static char Lantemp[6];
static int dbStartLanFlag = 0;


void   isg_Init(void);
void    isg_Start(void);
int Lan_Initialize(char *MacAddr);
int PCMCIA_init(char *MacAddr);
//int Lan_Initialize2(char *MacAddr);
static PCMCIA_PARAMETERS pcmcia;


void WLAN_Load_Parameters(PCMCIA_PARAMETERS *p);

extern int PacketInit();
void GPIO_Init(void);
void Assign_MAC();

//extern void etherSwitch_Init( void );
extern int AP_Init(void);


#define READ_FLASH_MAC
 
void Assign_MAC()
{
#ifdef READ_FLASH_MAC
#define Flash_Mac_Addr	0xFFFFFFB0
{
	unsigned char * ptr;
	int i;
	
	ptr = (unsigned char *)(Flash_Mac_Addr);
	
	for(i=0;i<6;i++)
		LocalMacAddress[i]=ptr[i];//get MAC address from FLASH
}
#else

   LocalMacAddress[0] = 0x34;
   LocalMacAddress[1] = 0x12;
   LocalMacAddress[2] = 0x78;
   LocalMacAddress[3] = 0x56;
   LocalMacAddress[4] = 0x11;
   LocalMacAddress[5] = 0x22;

#endif
} 
 
 
void root( void )
{

   Assign_MAC();
  	
   AP_Init();
   
    //wuming for led 
    apctlGPIOInit(0xfb20);
    GPIO_Init();	
     
//    PacketInit();//initial  three Queue of three interface
    isg_Init();
    isg_Start();

}


void GPIO_Init()
{
	//apctlGPIOWrite(4, 1); //power led
	apctlGPIOWrite(6, 0);
	apctlGPIOWrite(7, 0);
}

//wuming bug
#if 0
uint32 status_LED;
void status_led(void);
void RedLed();
void GPIO_Init()
{
	
   apctlGPIOWrite(0, 0);
   //apctlGPIOWrite(11, 1);
   apctlGPIOWrite(11, 0);
   apctlGPIOWrite(12, 1);
   
   if(apctlGPIORead(5) == 0)
   {
   	status_LED = apctlTimerCreate(10,RedLed);
   	apctlGPIOWrite(12, 1);
   	}
   else{
   status_LED = apctlTimerCreate(100,status_led);
   }
}
static int orange_led = 0;
void status_led()
{
     if(orange_led == 0)
     {	
	apctlGPIOWrite(12, 1);
	orange_led =1;
     }
     else
     {
   apctlGPIOWrite(12, 0);
     	orange_led =0;
     }
}
void RedLed()
{
	apctlGPIOWrite(12, 1);
}
#endif
/****************************************************************************** 
 * 
 * 
 *****************************************************************************/ 
 
#if 0  
extern void
cyg_user_start( void )
{ 
    
    root();
}
#endif
void perror(const char * str)
{
}
/* EOF aproot.c */


void WLAN_Load_Parameters(PCMCIA_PARAMETERS *p)
{
	//memset(&pcmcia,0,sizeof(PCMCIA_PARAMETERS));
	memcpy(&pcmcia,p,sizeof(PCMCIA_PARAMETERS));
	
}


extern void timerCb(void);
//char temp[5]={'r','i','c','k','y'};
extern void apiSetHiPower(void);
//#include "../http_asp/incl/Mrvap.h"

typedef struct _APICMDBUF_SET_FORCE_PROTECTION_MODE
{
    unsigned short cmdCode;
    unsigned short seqNum;
    unsigned short cmdStatus;
    unsigned short cmdBodyLen;
    unsigned short forceProtectMode;
}
APICMDBUF_SET_FORCE_PROTECTION_MODE;

int PCMCIA_init(char *MAC)
{
	APICMDBUF wlan;
	APICMDBUF *pwlan;
	int result;
	unsigned char r20,r26;
	result = FALSE;//FALSE=0,TRUE=1
	
	//1.Set BSSID
	{
		char RfBssid[32];
		memset(RfBssid,0,32);
		wlan.cmdCode = APCMD_SET_SSID;
		wlan.seqNum = 1;
		wlan.cmdBodyLen =32; 
		memcpy(RfBssid,pcmcia.BSSID,32);
		//memcpy(RfBssid,temp,5);
		wlan.cmdBody = RfBssid;
		
		pwlan = &wlan;
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}

	//2.Set WLAN RF Channel
	{
		APICMDBUF_SET_RF_CHANNEL	RfChannel;
				
		RfChannel.cmdCode	= APCMD_SET_RF_CHANNEL;
		RfChannel.seqNum	= 1;
		RfChannel.cmdBodyLen = sizeof (APICMDBUF_SET_RF_CHANNEL);
		RfChannel.curChanNum = (unsigned char)pcmcia.Channel;
		//RfChannel.curChanNum = (unsigned char)1;
		
		(APICMDBUF_SET_RF_CHANNEL *)pwlan = &RfChannel;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}

	//11g Tx data rate	
	{
		APICMDBUF_SET_TX_DATA_RATE_G	RfTxDataG;
				
		RfTxDataG.cmdCode	= APCMD_SET_TX_DATA_RATE_G;
		RfTxDataG.seqNum	= 1;
		RfTxDataG.cmdBodyLen = sizeof (APICMDBUF_SET_TX_DATA_RATE_G);
#if 1		
		switch(pcmcia.TxDataRate)
		{
			case TX_RATE_AUTO:
				RfTxDataG.txDataRate = (unsigned char)0x00;
				break;
				
			case TX_RATE_1M:
				RfTxDataG.txDataRate = (unsigned char)0x02;
				break;
				
			case TX_RATE_2M:
				RfTxDataG.txDataRate = (unsigned char)0x04;
				break;
				
			case TX_RATE_5_5M:
				RfTxDataG.txDataRate = (unsigned char)0x0b;
				break;
				
			case TX_RATE_11M:
				RfTxDataG.txDataRate = (unsigned char)0x16;
				break;
				
			case TX_RATE_6M:
				RfTxDataG.txDataRate = (unsigned char)0x0c;
				break;
				
			case TX_RATE_9M:
				RfTxDataG.txDataRate = (unsigned char)0x12;
				break;
				
			case TX_RATE_12M:
				RfTxDataG.txDataRate = (unsigned char)0x18;
				break;
				
			case TX_RATE_18M:
				RfTxDataG.txDataRate = (unsigned char)0x24;
				break;
				
			case TX_RATE_24M:
				RfTxDataG.txDataRate = (unsigned char)0x30;
				break;
				
			case TX_RATE_36M:
				RfTxDataG.txDataRate = (unsigned char)0x48;
				break;
				
			case TX_RATE_48M:
				RfTxDataG.txDataRate = (unsigned char)0x60;
				break;
				
			case TX_RATE_54M:
				RfTxDataG.txDataRate = (unsigned char)0x6c;
				break;
				
			default:	
				RfTxDataG.txDataRate = (unsigned char)0x00;
				break;
		}
#else
		RfTxDataG.txDataRate = (unsigned char)0x00;
#endif		
		(APICMDBUF_SET_TX_DATA_RATE_G *)pwlan = &RfTxDataG;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#ifdef AP_MODE	
	{
		APICMDBUF_SET_AP_MODE	RfApMode;
		unsigned short	mode;
				
		RfApMode.cmdCode	= APCMD_SET_AP_MODE;
		RfApMode.seqNum	= 1;
		RfApMode.cmdBodyLen = sizeof (APICMDBUF_SET_AP_MODE);
		
		mode = pcmcia.Mode & 0x7000;
		
		if(mode == 0x0000)
			{RfApMode.apMode = AP_MODE_MIXED;}
		else if(mode == 0x1000)
			{RfApMode.apMode = AP_MODE_G_ONLY;}
		else if(mode == 0x2000)
			{RfApMode.apMode = AP_MODE_B_ONLY;}

		//RfApMode.apMode = AP_MODE_G_ONLY;AP_MODE_MIXED
		
		
		(APICMDBUF_SET_AP_MODE *)pwlan = &RfApMode;;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif


#ifdef DISABLE_RTSCTS
	{
		//if(RTSCTSmode==1)
		{
		APICMDBUF_SET_FORCE_PROTECTION_MODE	RfSelfCTS;
				
		RfSelfCTS.cmdCode	= APCMD_SET_FORCE_PROTECTION_MODE;
		RfSelfCTS.seqNum	= 1;
		RfSelfCTS.cmdBodyLen = sizeof (APICMDBUF_SET_FORCE_PROTECTION_MODE);
		//RfSelfCTS.forceProtectMode =1;
		RfSelfCTS.forceProtectMode =0;
		
		(APICMDBUF_SET_FORCE_PROTECTION_MODE *)pwlan = &RfSelfCTS;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
		}
	}
#endif

#ifdef PREAMBLE_OPTION
	//3.Set Preamble Option
	{
		APICMBUF_SET_RF_PREAMBLE_OPTION	RfPreamble;
				
		RfPreamble.cmdCode	= APCMD_SET_RF_PREAMBLE_OPTION;
		RfPreamble.seqNum	= 1;
		RfPreamble.cmdBodyLen = sizeof (APICMBUF_SET_RF_PREAMBLE_OPTION);
		
#if 0		
		if(pcmcia.Preamble == 0x01)
		{RfPreamble.rfPreambleOption =PREAMBLE_SHORT;}
		else if(pcmcia.Preamble == 0x00)
		{RfPreamble.rfPreambleOption =PREAMBLE_LONG;}
		else if(pcmcia.Preamble == 0x02)
		{RfPreamble.rfPreambleOption =PREAMBLE_AUTO_SELECT;}
#else
	  RfPreamble.rfPreambleOption =PREAMBLE_LONG;
#endif
		
		(APICMBUF_SET_RF_PREAMBLE_OPTION *)pwlan = &RfPreamble;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif	
#ifdef	DTIM_OPTION	
	//4.Set DTIM Option
	{
		APICMDBUF_SET_DTIM_PERIOD	RfDTIM;
				
		RfDTIM.cmdCode	= APCMD_SET_DTIM_PERIOD;
		RfDTIM.seqNum	= 1;
		RfDTIM.cmdBodyLen = sizeof (APICMDBUF_SET_DTIM_PERIOD);
		RfDTIM.dtimPeriod = (unsigned long)pcmcia.DTIMPeriod;
		
		(APICMDBUF_SET_DTIM_PERIOD *)pwlan = &RfDTIM;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif	
#ifdef FRAGMENTATION
	//5.Set FRAGMENTATION
	{
		APICMDBUF_SET_FRAG_THRESHOLD	RfFragment;
				
		RfFragment.cmdCode	= APCMD_SET_FRAG_THRESHOLD;
		RfFragment.seqNum	= 1;
		RfFragment.cmdBodyLen = sizeof (APICMDBUF_SET_FRAG_THRESHOLD);
		RfFragment.fragThreshold = (unsigned short)pcmcia.Fragmentation;
		
		(APICMDBUF_SET_FRAG_THRESHOLD *)pwlan = &RfFragment;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif	
#ifdef RTS_SETTING	
	//6.Set RTS
	{
		APICMDBUF_SET_RTS_THRESHOLD	RfRts;
				
		RfRts.cmdCode	= APCMD_SET_RTS_THRESHOLD;
		RfRts.seqNum	= 1;
		RfRts.cmdBodyLen = sizeof (APICMDBUF_SET_RTS_THRESHOLD);
		RfRts.rtsThreshold = (unsigned short)pcmcia.RTS;
		
		(APICMDBUF_SET_RTS_THRESHOLD *)pwlan = &RfRts;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif	
#ifdef BEACON_SETTING	
	//7.Set BeaconInterval
	{
		APICMDBUF_SET_BEACON_PERIOD	RfBeacon;
				
		RfBeacon.cmdCode	= APCMD_SET_BEACON_PERIOD;
		RfBeacon.seqNum	= 1;
		RfBeacon.cmdBodyLen = sizeof (APICMDBUF_SET_BEACON_PERIOD);
		RfBeacon.beaconPeriod = (unsigned long)pcmcia.BeaconInterval;
		
		(APICMDBUF_SET_BEACON_PERIOD *)pwlan = &RfBeacon;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
#endif	
	//8.Set Data encrytion
	{
		APICMDBUF_SET_PRIVACY_OPTION	RfEncrypt;
				
		RfEncrypt.cmdCode	= APCMD_SET_PRIVACY_OPTION;
		RfEncrypt.seqNum	= 1;
		RfEncrypt.cmdBodyLen = sizeof (APICMDBUF_SET_PRIVACY_OPTION);
		if(pcmcia.Encryption == 0x00)
			RfEncrypt.dataEncrypt = DATA_ENCRYPT_NOT_REQUIRED;
		else if(pcmcia.Encryption == 0x01)
			RfEncrypt.dataEncrypt = FULL_DATA_ENCRYPT_REQUIRED;
				
		(APICMDBUF_SET_PRIVACY_OPTION *)pwlan = &RfEncrypt;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
	
	//7.Set Authentication
	{
		APICMDBUF_SET_AUTH_MODE		RfAuth;
				
		RfAuth.cmdCode	= APCMD_SET_AUTH_MODE;
		RfAuth.seqNum	= 1;
		RfAuth.cmdBodyLen = sizeof (APICMDBUF_SET_AUTH_MODE);
		

#if 1		
		if(pcmcia.Encryption == 0x00)
			RfAuth.authMode = NO_WEP;
		else if(pcmcia.Encryption == 0x01)
		{
			if(pcmcia.Authentication == 0x01)
				RfAuth.authMode = OPEN_SYSTEM_ONLY;
			else if(pcmcia.Authentication == 0x02)
				RfAuth.authMode = SHARED_KEY_ONLY;
			else if(pcmcia.Authentication == 0x03)
				RfAuth.authMode = OPEN_SYSTEM_AND_SHARED_KEY;
		}
#else	
		if(pcmcia.Encryption == 0x00)
			RfAuth.authMode = OPEN_SYSTEM_ONLY;
		else if(pcmcia.Encryption == 0x01)
			RfAuth.authMode = OPEN_SYSTEM_AND_SHARED_KEY;
#endif	
		(APICMDBUF_SET_AUTH_MODE *)pwlan = &RfAuth;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}

	
	//8.Set EnhanceSecurity
	{
		APICMDBUF_SET_OPEN_SSID_EN_STATE	RfBcastSSID;
				
		RfBcastSSID.cmdCode	= APCMD_SET_OPEN_SSID_EN_STATE;
		RfBcastSSID.seqNum	= 1;
		RfBcastSSID.cmdBodyLen = 2;
		if(pcmcia.EnhanceSecurity == 0x00)
			RfBcastSSID.openSSIDEnabled = TRUE;
		else if(pcmcia.EnhanceSecurity == 0x03)
			RfBcastSSID.openSSIDEnabled = FALSE;
		
		(APICMDBUF_SET_OPEN_SSID_EN_STATE *)pwlan = &RfBcastSSID;	
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}

	
	//10.Set WEP's Key length and default keyId
	{
		APICMDBUF_SET_DEFAULT_WEP_KEYS	RfWep;
		
		memset(&RfWep,0,sizeof(APICMDBUF_SET_DEFAULT_WEP_KEYS));
				
		RfWep.cmdCode	= APCMD_SET_DEFAULT_WEP_KEYS;
		RfWep.seqNum	= 1;
		RfWep.cmdBodyLen = sizeof (APICMDBUF_SET_DEFAULT_WEP_KEYS);
		RfWep.keyindex	=(unsigned short)pcmcia.defaultKeyID;
		
		if(pcmcia.key_length == 5)
			RfWep.keyType0	= WEP_40_BIT;
		else if(pcmcia.key_length ==13)
			RfWep.keyType0	= WEP_104_BIT;
		else
			RfWep.keyType0 =WEP_NOT_SET;
		
		memcpy(RfWep.keyValue0,pcmcia.Keys[0],13);
		RfWep.keyValue0[13]=0;
		//RfWep.keyType1	=(unsigned short)pcmcia.key_length;
		memcpy(RfWep.keyValue1,pcmcia.Keys[1],13);
		RfWep.keyValue1[13]=0;
		//RfWep.keyType2	=(unsigned short)pcmcia.key_length;
		memcpy(RfWep.keyValue2,pcmcia.Keys[2],13);
		RfWep.keyValue2[13]=0;
		//RfWep.keyType3	=(unsigned short)pcmcia.key_length;
		memcpy(RfWep.keyValue3,pcmcia.Keys[3],13);
		RfWep.keyValue3[13]=0;
		
				
		(APICMDBUF_SET_DEFAULT_WEP_KEYS *)pwlan = &RfWep;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
	}
	
#ifdef BASIC_DATA_RATE	
	//11.set BasicDataRate & Support Data Rate
	{
		APICMDBUF_GET_BASIC_DATA_RATES_G	RfBasicRate;
		unsigned short mode;
		memset(&RfBasicRate,0,sizeof(APICMDBUF_GET_BASIC_DATA_RATES_G));
		
		RfBasicRate.cmdCode	= APCMD_SET_BASIC_DATA_RATES_G;
		RfBasicRate.seqNum	= 1;
		RfBasicRate.cmdBodyLen = sizeof (APICMDBUF_GET_BASIC_DATA_RATES_G);

		mode=pcmcia.Mode & 0x7000;
		
#if 1		
		if(pcmcia.BasicDataRate& 0x00000001)
			RfBasicRate.basicDataRates[0]	= 0x82;
		else
			RfBasicRate.basicDataRates[0]	= 0x82;
			
		if(pcmcia.BasicDataRate& 0x00000002)
			RfBasicRate.basicDataRates[1]	= 0x84;
		else
			RfBasicRate.basicDataRates[1]	= 0x84;
			
		if(pcmcia.BasicDataRate& 0x00000004)
			RfBasicRate.basicDataRates[2]	= 0x8B;
		else
			RfBasicRate.basicDataRates[2]	= 0x8B; //0x0B
			
		if(pcmcia.BasicDataRate& 0x00000008)
			RfBasicRate.basicDataRates[3]	= 0x96;
		else
			RfBasicRate.basicDataRates[3]	= 0x96; //0x16
		
		// 6Mbps
		if( (pcmcia.BasicDataRate& 0x00000010) || (mode == 0x1000))
			RfBasicRate.basicDataRates[4]	= 0x8C;
		else
			RfBasicRate.basicDataRates[4]	= 0x0C; //0x0C
			
		// 9Mbps	
		if(pcmcia.BasicDataRate& 0x00000020)
			RfBasicRate.basicDataRates[5]	= 0x92;
		else
			RfBasicRate.basicDataRates[5]	= 0x12; //0x12
			
		//12 Mpbs	
		if((pcmcia.BasicDataRate& 0x00000040)|| (mode == 0x1000))
			RfBasicRate.basicDataRates[6]	= 0x98;
		else
			RfBasicRate.basicDataRates[6]	= 0x18; //0x18
			
		// 18 Mbps	
		if(pcmcia.BasicDataRate& 0x00000080)
			RfBasicRate.basicDataRates[7]	= 0xA4;
		else
			RfBasicRate.basicDataRates[7]	= 0x24;
			
		//24 Mbps	
		if((pcmcia.BasicDataRate& 0x00000100)|| (mode == 0x1000))
			RfBasicRate.basicDataRates[8]	= 0xB0;
		else
			RfBasicRate.basicDataRates[8]	= 0x30; //0x30
			
		if(pcmcia.BasicDataRate& 0x00000200)
			RfBasicRate.basicDataRates[9]	= 0xC8;
		else
			RfBasicRate.basicDataRates[9]	= 0x48;
			
		if(pcmcia.BasicDataRate& 0x00000400)
			RfBasicRate.basicDataRates[10]	= 0xE0;
		else
			RfBasicRate.basicDataRates[10]	= 0x60;
		
		if(pcmcia.BasicDataRate& 0x00000800)
			RfBasicRate.basicDataRates[11]	= 0xEC;
		else
			RfBasicRate.basicDataRates[11]	= 0x6C;
			
			
#else
		
		
		
		
#endif		
		RfBasicRate.basicDataRates[12] = 0x00;
		RfBasicRate.basicDataRates[13] = 0x00;	
		RfBasicRate.basicDataRates[14] = 0x00;
		RfBasicRate.basicDataRates[15] = 0x00;
		
		
		(APICMDBUF_GET_BASIC_DATA_RATES_G *)pwlan = &RfBasicRate;
	
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
			result=TRUE;
		}
		else
		{
			result = FALSE;
			goto error;
		}
		
	}
#endif



/******************************************************************************
        Since Marvell's new BSS_START will set power reg, so need prepare the
    value before call BSS_START.
                                                            Raining Tsao
                                                            2003/Sep/24
                                                            @ Austin,TX,USA
*******************************************************************************/
    {
		unsigned char reg26, data26,data20;
		unsigned char tp=0,tempValue;
		unsigned short country;
		
		if(*(unsigned char *)(0xFFFFFF81) == 0xff)
			tp =1;
		
		if(tp == 0)
		{	
    		data26 = *(unsigned char *)(CALIBRATION_26);
    		
    		if((data26 & 0xF0)==0xF0)
    		{
        		data20 = *(unsigned char *)(CALIBRATION_20+(pcmcia.Channel-1)*2);
    		}
    		else
    		{
        		data20 = *(unsigned char *)(CALIBRATION_20+(pcmcia.Channel-1)*2);
        		data20 = (data20>>2)+0x40;	
    		}
    		reg26=0x46; //ReadRfReg(0x26);
    		
    		data26 &= 0x07;
    		reg26 &= 0x8F;
    		reg26 = (reg26 | (data26<<4));	
    
    		if(pcmcia.Mode & 0x0010)//Europe
    		{tempValue = 4;}
    		else
    		{ tempValue = 6;}
    		
    		//WriteRfReg(0x20,data20);
    		//WriteRfReg(0x26,reg26);
    		//wuming temp
    		SetPowerRegValue(data20, reg26,tempValue);
        }
    }

		wlan.cmdCode = APCMD_BSS_START;
		wlan.seqNum = 1;
		wlan.cmdBodyLen =0; 
		
		pwlan = &wlan;
		apctl(pwlan);
		
		if(pwlan->cmdStatus==APCTL_OK)	
		{
  		//apctlGPIOWrite(0, 1);
			apctlGPIOWrite(11, 1);
#if 0
//Rangle, 2004.4.13 this variable has been removed by Wuming
			apctlTimerDelete(status_LED);
#endif
			apctlTimerCreate(1,timerCb);
			apctlGPIOWrite(12, 0);			
			//wlanfilter();
			result=TRUE;

			os_TaskDelay((long long)200);
		}
		else
		{
			result = FALSE;
			goto error;
		}
		
/******************************************************************************
        Since Marvell's new BSS_START will set power reg, and sethipower, so
    here need not set it.
                                                            Raining Tsao
                                                            2003/Sep/24
                                                            @ Austin,TX,USA
*******************************************************************************/


error:

	if(result == TRUE)//13 item config
		{
                 //wuming for led
		 apctlGPIOWrite(6, 1);	
		//apctlGPIOWrite(0, 0);
		return 0;//Successful
		}
	else
        {
                 //wuming for led
		 apctlGPIOWrite(6, 0);	 
		return 1;//Fail
         }
}


#if 0
extern int AP_Set_Wlan_Filter(unsigned char *filterlist,char StaNo,char mode);

void wlanfilter()
{
	unsigned char mac[6]={0x00,0x00,0x00,0x00,0x00,0x00};
	unsigned char mac1[6]={0x00,0x90,0xd1,0x07,0x8b,0x7e};
	unsigned char mac2[12]={0x00,0x90,0xd1,0x07,0x8b,0x7e,0x00,0x09,0x5b,0x25,0x66,0x08};
	int k;
	
	k=AP_Set_Wlan_Filter(mac,0xff,0);
}

void testfilter()
{
	unsigned char mac2[12]={0x00,0x90,0xd1,0x07,0x8b,0x7e,0x00,0x09,0x5b,0x25,0x66,0x08};
	unsigned char mac1[6]={0x00,0x90,0xd1,0x07,0x8b,0x7e};
	int k;
	
	k=AP_Set_Wlan_Filter(mac1,1,0);
}
#endif
#ifdef LAN_INIT
int Lan_Initialize(char *MacAddr)
{
	APICMDBUF_SET_ETH_MAC_ADDRESS	lan;
	APICMDBUF *plan;
	
	//Set LAN MAC address
	lan.cmdCode	= APCMD_SET_ETH_MAC_ADDRESS;
	lan.seqNum	= 1;
	lan.cmdBodyLen = 6;
	
#ifdef READ_FLASH_MAC
	memcpy(Lantemp,MacAddr,6);
	memcpy(lan.phyAddress,MacAddr,6);
#else
	memcpy(lan.phyAddress,LAN_MAC,6);
	memcpy(Lantemp,LAN_MAC,6);
#endif
		
	(APICMDBUF_SET_ETH_MAC_ADDRESS *)plan = &lan;		

	apctl(plan);
		
	if(plan->cmdStatus==APCTL_OK)	
	{
		dbStartLanFlag = 1;
		return 0;//ok
	}
	else
		return 1;//false
	
}
#endif
int Lan_GetAddr (unsigned char * dbData)
{
   memcpy(dbData,Lantemp,6);
   return 0;
}

int Lan_Status(void)
{
   return dbStartLanFlag;
}
/************************************
    Raining add follow two function follow Marvell 1.37 library request
*************************************/
/* Dummy function needed to link with latest libwlandrv.a */
int inet_address(int addr)
{
	
}

void initiate_dhcp(int flag)
{
}
