#ifndef _BASIC_TYPES_H_
#define _BASIC_TYPES_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */

/*!
 * \file    basic_types.h
 * \brief   This file contains definitions of basic types
 */

//=============================================================================
//                            PUBLIC DEFINITIONS
//=============================================================================
#define PACK   __attribute__ ((packed))

#define NULL ((void *)0) 
/* Minimum and maximum values a `signed long int' can hold. */
//#define LONG_MAX 2147483647L
#define LONG_MIN (-LONG_MAX-1) 
/* Maximum value an `unsigned long int' can hold.  (Minimum is 0).  */
#undef ULONG_MAX
#define ULONG_MAX (LONG_MAX * 2UL + 1)

//=============================================================================
//                          PUBLIC TYPE DEFINITIONS
//=============================================================================

/*---------------------------------------------------------------------------*/
/*                             Standard "C" Types                            */
/*---------------------------------------------------------------------------*/
typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned int uint32;
typedef signed int int32;
typedef unsigned long long uint64;
typedef signed long long int64;

/*---------------------------------------------------------------------------*/
/*                            Commonly Used Types                            */
/*---------------------------------------------------------------------------*/
typedef void Void;

typedef	enum
{
    FALSE = 0,
    TRUE
} Boolean;

typedef	enum
{
    SUCCESS,
    FAIL
} Status_e;

typedef enum
{
    ENABLED,
    DISABLED
} Enable_e;

typedef	enum
{
    WEP,
    TKIP
} EncrType_e;

//=============================================================================
//                                PUBLIC MACROS
//=============================================================================
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#define MIN(a, b) (((a) < (b)) ? (a) : (b))


#endif /* _BASIC_TYPES_H_ */
