//=============================================================================
//                               INCLUDE FILES
//=============================================================================
#include <cyg/kernel/kapi.h>
#include <cyg/io/io.h>                  /* I/O functions */
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */
#include "basic_types.h"
#include "IEEE_types.h"
#include "oem.h"
#include "api.h"
#include "s_packet.h"


#ifndef _WPA_CODE_
#define  _WPA_CODE_
#endif

apio_handle_t LanHandle __attribute__ ((section (".itcmbuf")));
apio_handle_t WlanHandle1 __attribute__ ((section (".itcmbuf")));

extern int mac_recv_iob(short no, void * iob);
extern int bridge_recv_iob(short i, void * pTmp);

extern void C_Entry(void);

#define sysinfo_TASK_NAME1  "ISG"
//wuming temp
//#define sysinfo_TASK_STACK_SIZE    4096*6//8192////8192//4096
#define sysinfo_TASK_STACK_SIZE1    4096*2//8192////8192//4096
//wuming temp
//#define sysinfo_TASK_PRI         16//8
#define sysinfo_TASK_PRI1	 30
static cyg_thread       Task1 __attribute__ ((section (".itcmbuf")));
static cyg_handle_t     TaskHdl1 __attribute__ ((section (".itcmbuf")));
static uint8            Stack1[sysinfo_TASK_STACK_SIZE1]__attribute__ ((section (".itcmbuf")));//((aligned(sysinfo_TASK_STACK_SIZE)));

#define W81_REGS32(x)    (*(volatile unsigned long *)(x))

extern void Fsh_Wireless(int ctrl);

void isg(cyg_addrword_t  Data);
//=============================================================================
//                         CODED PUBLIC PROCEDURES
//=============================================================================
void ethTxDoneCb(apio_bufdescr_t *pBufDesc1);  //Todo; Need to define this
extern void mac_daemon(void);

//#define ShortCut_Way

extern int isg_Init( void ) 
{ 
	apio_ErrCode_t errCode;
	
	errCode = apio_open("eth0",&LanHandle,NULL);
	errCode = apio_open("wl0",&WlanHandle1,NULL);
	
      cyg_thread_create(sysinfo_TASK_PRI1,
                     isg,
                     0,
                     sysinfo_TASK_NAME1,
                     (void *)(Stack1),
                     sysinfo_TASK_STACK_SIZE1,
                     &TaskHdl1,
                     &Task1);
 
   return (0); 
} 

extern void isg_Start( void ) 
{ 
      cyg_thread_resume(TaskHdl1);
}

#ifdef _WPA_CODE_
int WirelessRecvPacket(apio_bufdescr_t * pBufDesc1);
#endif /* _WPA_CODE_ */

extern void isg_init(void);
extern uint8 RfResetflag;
//extern void eaglehw_CheckRx(void);
extern uint8	RadioStatus;

static unsigned char wlanMacCache[6]__attribute__ ((section (".itcmbuf")))={0, 0, 0, 0, 0, 0};
static unsigned char lanMacCache[6]__attribute__ ((section (".itcmbuf")))={0, 0, 0, 0, 0, 0};
static apio_ErrCode_t errCode1 __attribute__ ((section (".itcmbuf")));
static apio_bufdescr_t pBufDesc1 __attribute__ ((section (".itcmbuf")));
static iobs *pIOB __attribute__ ((section (".itcmbuf")));


extern void WLAN_POLLING_MESSAGE(void);

int pollPacket(void){}

void report_error(unsigned char *str, int len)
{
	apio_bufdescr_t	pBufsend;
	apio_ErrCode_t errcode;
	
	errcode=apio_ethAlloc(LanHandle, &pBufsend);
	
	if(errcode == APCTL_OK)
	{
		MemDma1( (uint32)pBufsend.framePtr, "\xFF\xFF\xFF\xFF\xFF\xFF",6);
		MemDma1( (uint32)(pBufsend.framePtr+6), "\x34\x12\x78\x56\x12\x12",6);
		
		pBufsend.framePtr[12]=pBufsend.framePtr[13]=0x44;
		pBufsend.framePtr[14]=pBufsend.framePtr[15]=0x55;
		
		MemDma1( (uint32)(pBufsend.framePtr+16), (uint32)str, (uint32)len);   
		pBufsend.frameLen = len+16; 
		apio_etherWrite(&pBufsend);
	}
}
void report_error1(unsigned char *str, int len)
{
	apio_bufdescr_t	pBufsend;
	apio_ErrCode_t errcode;
	
	errcode=apio_ethAlloc(LanHandle, &pBufsend);
	
	if(errcode == APCTL_OK)
	{
		MemDma1( (uint32)pBufsend.framePtr, "\xFF\xFF\xFF\xFF\xFF\xFF",6);
		MemDma1( (uint32)(pBufsend.framePtr+6), "\x34\x12\x78\x56\x12\x12",6);
		
		pBufsend.framePtr[12]=pBufsend.framePtr[13]=0x66;
		pBufsend.framePtr[14]=pBufsend.framePtr[15]=0x77;
		
		MemDma1( (uint32)(pBufsend.framePtr+16), (uint32)str, (uint32)len);   
		pBufsend.frameLen = len+16; 
		apio_etherWrite(&pBufsend);
	}
}
			

//ricky added to tune performance
#define WLAN_MAC_FILTER

extern int AP_Set_Wlan_Filter(unsigned char *filterlist,char StaNo,char mode);
extern int Switch_Mode();

/* This API is provided by AP team.
   0: for single user mode, (NETGEAR)
   1: for multi user mode , (Neutral)
*/   
extern unsigned short getAPonly1user(VOID);

#ifdef	WLAN_MAC_FILTER
static 	int onlyOneMAC=0;
int SwitchConfigMode=0;
unsigned short MacFilterFunction=0;
unsigned char	OnlyMac[6] __attribute__ ((section (".itcmbuf")))={0, 0, 0, 0, 0, 0};
#endif		

int pollPacket_Lan(int pkts)
{
	//IEEEtypes_8023_Frame_t  * DataEtherFrame_p; 
   
	int noPkts;
	//int Len;
	
	noPkts = 0;
    	/* retrieve the frame */
    	while ( apio_etherRead(&pBufDesc1) )
    	{
            if(SwitchConfigMode==0 && MacFilterFunction == 0 )  //AP mode && single user mode
	    {
	    	Fsh_Ether(1);
	        apio_write(WlanHandle1, &pBufDesc1);
	    }
            else
            {
    		pIOB = BufftoIOB(&pBufDesc1,ID_LAN);
    		if(pIOB ==NULL)
    		{
    			   				
    		}
    		else
    		{
    			//bridge_recv_iob1(0, pIOB);
    			Fsh_Ether(1);
    			bridge_recv_iob(0, pIOB);
    		}
            }
            break;
    		//if ( ++noPkts >= pkts )  break;
    		
        }
         return(noPkts);
}


	
int pollPacket_wLan(int pkts)
{
	int noPkts;
	//apio_bufdescr_t BufDescr;

    	noPkts = 0;
    	
    	while ( apio_wlanRead(&pBufDesc1) )
    	{
#ifdef	WLAN_MAC_FILTER
    	if(onlyOneMAC==0)
    	{
    		memcpy(OnlyMac,pBufDesc1.framePtr+6,6);
    		if(MacFilterFunction==0 && SwitchConfigMode==0 )
    		{
    			AP_Set_Wlan_Filter(OnlyMac,1,0);
    		}
    		
    		onlyOneMAC=1;	
    	}
#endif	
    		
#ifdef _WPA_CODE_
		    if(WirelessRecvPacket(&pBufDesc1)==0)
		    {
		        return;
		    }
#endif /* _WPA_CODE_ */
    		if(SwitchConfigMode==0 && MacFilterFunction == 0 )  //AP mode && single user mode
	        {
	        	Fsh_Wireless(1);	
			apio_write(LanHandle, &pBufDesc1);
    	        }
    	        else
    	        {
                	pIOB = BufftoIOB(&pBufDesc1,ID_WIRELESS);
    			if(pIOB ==NULL)
    			{
    			
    			
    			}
    			else
    			{	//report_error1( pbIOBData(pIOB), dwIOBDataLength(pIOB));
    			
    				//bridge_recv_iob1(1, pIOB);
    				Fsh_Wireless(1);
    				bridge_recv_iob(1, pIOB);
    			}
    	
    		} 		
    		break;            	
            	//if ( ++noPkts >= pkts )  break;
        }
        
        return(noPkts);
}
#define NO_PKTS 1//10
#define initIOB initQ
void isg(cyg_addrword_t  Data)
{
    int i;

	isg_init();
       	SwitchConfigMode=Switch_Mode();
	MacFilterFunction=getAPonly1user();	
    	while(1)
		{
			
			for(i=0;i<100;i++)
			{
			pollPacket_wLan(NO_PKTS);
			pollPacket_Lan(NO_PKTS);
			}
#ifdef _WPA_CODE_

		
                WLAN_POLLING_MESSAGE();
#endif /* _WPA_CODE_ */
			//Free_In_Bridge();
			C_Entry();
					
		}
}

void	ethTxDoneCb(apio_bufdescr_t	*pBuf)
{
	apio_ErrCode_t	errCode;
	
	//errCode=apio_free(LanHandle,pBuf);
}

