#include <stdio.h>
#include "basic_types.h"
#include "IEEE_types.h"
#include "oem.h"
#include "api.h"
#include "nv.h"

#define         NVRAMSIZE         64*1024

static unsigned char NVRamBuff[NVRAMSIZE];
static unsigned char NVRamBuff1[NVRAMSIZE];
int FlashDriver(int dlAddress,unsigned char *dbData,int dlLength,unsigned long dlFlag);

void DirectAssign();
void DirectDownload();

void SetWanPortSpeed(unsigned char speed);

void nv_read(unsigned short pos,unsigned short *pdata)
{
   unsigned short *ptr;

   if (pos*2 >= NVRAMSIZE ) {
      return;
   } /* endif */
   ptr = (unsigned short *) &NVRamBuff[ pos * 2];
   *pdata = *ptr;
}


void nv_read1(unsigned short pos,unsigned short *pdata)
{
   unsigned short *ptr;

   if (pos*2 >= NVRAMSIZE ) {
      return;
   } /* endif */
   ptr = (unsigned short *) &NVRamBuff1[ pos * 2];
   *pdata = *ptr;
}


void nv_write(unsigned short pos,unsigned short data)
{
   unsigned short *ptr;

   if (pos*2 >= NVRAMSIZE ) {
           return;
   } /* endif */
   ptr = (unsigned short *) (&NVRamBuff[ pos * 2]);
   *ptr = data;
   return;
}


void nv_write1(unsigned short pos,unsigned short data)
{
   unsigned short *ptr;

   if (pos*2 >= NVRAMSIZE ) {
           return;
   } /* endif */
   ptr = (unsigned short *) (&NVRamBuff1[ pos * 2]);
   *ptr = data;
   return;
}

int GetNVFromFlash(void)
{
    unsigned char * ptr;
    unsigned char * ptr1;
    unsigned long i;
   ptr = (unsigned char *)(NV_CONFIG_OFFSET+NV_ADDRESS);
   ptr1 = (unsigned char *)(NODE_ADDRESS_OFFSET+NV_ADDRESS);
    for (i=0;i<NVRAMSIZE ; i++) {
       NVRamBuff[i] = ptr[i];
    } /* endfor */
    memcpy(NVRamBuff,ptr1,6);
    return 0;
}


int GetNVFromFlash1(void)
{
    unsigned char * ptr;
    unsigned char * ptr1;
    unsigned long i;
   ptr = (unsigned char *)(NV_CONFIG_OFFSET1+NV_ADDRESS);
   ptr1 = (unsigned char *)(NODE_ADDRESS_OFFSET+NV_ADDRESS);
    for (i=0;i<NVRAMSIZE ; i++) {
       NVRamBuff1[i] = ptr[i];
    } /* endfor */
    memcpy(NVRamBuff1,ptr1,6);
    return 0;
}


extern int intLock();
extern void intUnlock(int);

int PutNVToFlash(void)
{
   int mask;
   unsigned long i;
   uint16 nvword;
   uint8 *nvdata;

   int dwReturnCode=0;

   mask=intLock();

   dwReturnCode = FlashEraseSector(14);//erase config Sector

  
   nvdata = NVRamBuff;
 
   for(i=0;i*2 < NVRAMSIZE;i++)
   {
	nvword = *(unsigned short *)nvdata;
	dwReturnCode = FlashWriteWord((NV_CONFIG_OFFSET+(i*2)),nvword);

	nvdata = nvdata + 0x2;
   }
   
   intUnlock(mask);

   return 0;
}


int PutNVToFlash1(void)
{
   int mask;
   unsigned long i;
   uint16 nvword;
   uint8 *nvdata;

   int dwReturnCode=0;

   mask=intLock();

   dwReturnCode = FlashEraseSector(13);//erase config Sector

  
   nvdata = NVRamBuff1;
 
   for(i=0;i*2 < NVRAMSIZE;i++)
   {
	nvword = *(unsigned short *)nvdata;
	dwReturnCode = FlashWriteWord((NV_CONFIG_OFFSET1+(i*2)),nvword);

	nvdata = nvdata + 0x2;
   }
   
   intUnlock(mask);

   return 0;
}





int ProgramChip(int dlAddress,unsigned char *dbData,int dlLength);
int eall_flag;


int FlashDriver(
int dlAddress,
unsigned char *dbData,
int dlLength,
unsigned long dlFlag
)
{
   int dwReturnCode=0;
   unsigned long i;
   //ULONG mask;

   switch (dlFlag) {
   case 0:
        if (eall_flag == 0) {//boot config  none write
           if ((dlAddress >=  0x0000)&&(dlAddress < (0x100000 - 0x030000))) {
              dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
                   //sysFlashWrite(dbData, dlLength, dlAddress);
           } else {
              dwReturnCode = 0;
           } /* endif */
        } else {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        }
        break;
   case 1:
        break;
   case 2:
        break;
   case 3: //erase all
   	dwReturnCode = FlashEraseSector(12);	//Clean Download Check point first
        for (i=0;i< 16 ;i ++ ) {
           dwReturnCode = FlashEraseSector(i);
           //ResetChip(0);
        }
        if ((dlAddress >=  0x00000)&&(dlAddress < 0x100000)) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        eall_flag = 1;
        break;
   case 4://normal erase
   	dwReturnCode = FlashEraseSector(12);	//Clean Download Check point first
        //for (i=0;i< 14 ;i ++ ) {
        for (i=0;i< 12 ;i ++ ) {
           dwReturnCode = FlashEraseSector(i);
           //ResetChip(0);
        } /* endfor */
        if ((dlAddress >=  0x0000)&&(dlAddress < (0x100000-0x30000))) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        break;
   case 5:
        if ((dlAddress >= 0x00000)&&(dlAddress < 0x100000)) {
           dwReturnCode = ProgramChip(dlAddress,dbData, dlLength);
        } else {
           dwReturnCode = 0;
        } /* endif */
        break;
   } /* endswitch */
   return dwReturnCode;
}



int ProgramChip(int dlAddress,unsigned char *dbData,int dlLength)
{
	int mask;
	int i=0;
	uint16 nvword;
	int dwReturnCode=0;
	
	mask = intLock();
	
	for(i=0;i*2 < dlLength;i++)
 	{
   		nvword = *(unsigned short *)dbData;
   		dwReturnCode = FlashWriteWord((dlAddress + (i*0x02)),nvword);

   		dbData=dbData+2;
	}
		
	intUnlock(mask);
	
	return 0;
	
}



void DirectDownload()
{
	int mask;
	int dwReturnCode=0;
	unsigned char *ptr;
	unsigned char PIDdata[16];
	int i;
	uint16 nvword;
   	uint8 *nvdata;
	
	ptr = (unsigned char *)0xFFFCFFF0;
	
	memcpy(PIDdata,ptr,16);
	
	nvdata = PIDdata;
	
	mask=intLock();
	
	dwReturnCode = FlashEraseSector(12);
	
	for(i=0;i*2 < 16;i++)
   	{
	nvword = *(unsigned short *)nvdata;
	dwReturnCode = FlashWriteWord((0x0CFFE0+(i*2)),nvword);

	nvdata = nvdata + 0x2;
   	}
	
	intUnlock(mask);
	
	apctlGPIOWrite(11, 0);
	apctlGPIOWrite(12, 1);
	//u.hackfest=0xffff0000;
    	//u.branch();
}


void SetWanPortSpeed(unsigned char speed)
{
	unsigned char Sd;
	
	GetNVFromFlash();
	
	switch(speed)
	{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
			Sd = speed;
			break;
		default:
			Sd = 0;
			break;
	}
	NVRamBuff[NVRAMSIZE-1]=Sd;
	PutNVToFlash();
}




//////////////////////////////////////////////////////////////////////////
//			Flash Driver					//
//////////////////////////////////////////////////////////////////////////

unsigned FlashSize=1*1024*1024;
unsigned FlashBase=0xfff00000;

#define _REG(x) (*(volatile unsigned long *)(x))
#define _REG16(x) (*(volatile unsigned short *)(x))


int Split_Sector = -1;
int Split_Sector_Data[]={
    0,
    0x8000,
    0xa000,
    0xc000,
};
int Split[2][4]={
    { 16, 8, 8, 32 }, 
    { 32, 8, 8, 16 }
};

void MakeSplit(unsigned ss)
{
    int top = 0;
    int start = 0;
    int i;
    Split_Sector = ss;
    if(ss) {
	top = 1;
    }
    for(i=0;i < 4;i++) {
	Split_Sector_Data[i] = start;
	start += Split[top][i] * 1024;
    }
}

Boolean FlashEraseSector(int sectorNum)
{
    MakeSplit(15);

    AMDEraseChip(sectorNum,1);

    return TRUE;
}

Boolean FlashWriteWord( int offset, unsigned short dat)
{
    unsigned addr = FlashBase+offset;

    
   _REG16(FlashBase | 0xAAA) = 0x00AA;  // word address 555
   _REG16(FlashBase | 0x555) = 0x0055;  // word address 2AA
   _REG16(FlashBase | 0xAAA) = 0x00A0;  // word address 555

   _REG16(addr) = dat;  // word address 0xFC000000
   
   while(_REG16(addr) != dat);
   
   return TRUE;
}


void AMDEraseChip(int sblk, int nblks)
{
    unsigned addr;
    int i;
    int j;
    for(i=sblk;i < (sblk+nblks);i++) {
	if(i == Split_Sector) {
	    unsigned start = (i << (16));
	    for(j=0;j < sizeof(Split_Sector_Data)/sizeof(int);j++) {
		addr= FlashBase + start + Split_Sector_Data[j];
		AMDPreamble();
		_REG16(addr) = 0x0030;
		
		while(!(_REG(0x80006000)&0x1));
	    }
	} else {
	    addr= FlashBase + (i << (16));
	   AMDPreamble();
	    _REG16(addr) = 0x0030;
	    
	    while(!(_REG(0x80006000)&0x1));
	}
   }
    
}

void AMDPreamble()
{
   _REG16(FlashBase | 0xAAA) = 0x00AA;
   _REG16(FlashBase | 0x555) = 0x0055;
   _REG16(FlashBase | 0xAAA) = 0x0080;
   _REG16(FlashBase | 0xAAA) = 0x00AA;
   _REG16(FlashBase | 0x555) = 0x0055;
}



