#include "basic_types.h"
#include "IEEE_types.h"
#include "oem.h"
#include "api.h"
#include "s_packet.h"
extern void Memcpy(uint32 x, uint32 y, uint32 z);
 void MemDma1(uint32 x, uint32 y, uint32 z);


extern apio_handle_t LanHandle, WlanHandle1;
//static CBQ dsRecvQLan __attribute__ ((section (".itcmbuf"))) ;
//static CBQ dsRecvQWan __attribute__ ((section (".itcmbuf"))) ;
//static CBQ dsRecvQWLan __attribute__ ((section (".itcmbuf"))) ;

//static void initMyIOBQ(CBQ *iobq);
static int TransmitPacket(iobs*, eISGIfaceID);
iobs * BufftoIOB(apio_bufdescr_t *buf,eISGIfaceID);

extern iobs * getCBFromQ(CBQ *psCBQ,unsigned int zeroSize);
extern void putCBToQ(CBQ *psCBQ,void * psCB,unsigned char dbOrder);

#define getIOB DriverGetIOB
extern iobs * getIOB(unsigned short len);
#define IOBOFF(x) ((x)->dwOffset)
#define IOBLEN(x) ((x)->dwLength)
#define IOBDATA(x) (&((x)->dbData[(x)->dwOffset]))

extern int mac_recv_iob(short no, void * iob);
extern int bridge_recv_iob(short i, void * pTmp);

        
/*
changed:
Buffer to IOB should do copy in the original way, not changed to add an iob header.
*/
/*****************************************************************************/
/*      Fake Buffer is use Marvell's buffer cast to Sercomm's IOB, and pass  */
/*  to uplayer directly, since some case uplayer will queue the IOB, that    */
/*  will cause Marvell's buffer be eat-up, so here must control the Max.     */
/*  number of Marvell buffer be used by uplayer.                             */
/*      Now Marvell's Max. buffer number for uplayer is 16, so here i define */
/*  10 for save. If it's impact performance, then we can enlarge it to 15 at */
/*  most.                                                                    */
/*                                                          Raining Tsao     */
/*                                                          2003/Sep/12      */
/*                                                          @ Fremont,CA,USA */
/*****************************************************************************/
int buff_faked __attribute__ ((section (".itcmbuf"))) =0;
#define BUFF_FAKED_MAX  40//10 //100
#define RESERVED_SIZE 2
#define MAX_RESERVED_LEN 192

iobs * BufftoIOB(apio_bufdescr_t *pBuf,eISGIfaceID from)
{
    apio_handle_t temphandle;
    iobs * psIOB;

    unsigned char * tmp1,*tmp2;
   

  	if(from==ID_LAN)
  		temphandle=LanHandle;
	//else
	//if(from==ID_WAN)
	//	temphandle=WanHandle;
	else
	if(from==ID_WIRELESS)
	{
		
		temphandle=WlanHandle1;
	}
		
/*
 Buffer Structure
                        FramePtr(FrameDescription)
                     |---------
                     V   
|-|-|...  .....|(n+1)|-|-|-|.... ...      ........|-|-|
<--- n -------->     |<-- PAYLOAD,FrameLen ----------->
*/
    if(buff_faked < BUFF_FAKED_MAX)
    {
    	
        psIOB = (iobs *)(pBuf->framePtr - *((unsigned char *)pBuf->framePtr-1) + (sizeof(apio_handle_t))/*reserver for handle*/ + RESERVED_SIZE);  //Point to the pre-allocated buffer header.
        IOBLEN(psIOB) = pBuf->frameLen;
        IOBOFF(psIOB) = 0;  //for IOBDATA(p) to get the psIOB->dataArea.
        tmp1 = (unsigned char *)IOBDATA(psIOB);
        tmp2 = (unsigned char *)pBuf->framePtr;
        IOBOFF(psIOB) = (unsigned int)(tmp2 - tmp1);

        *(apio_handle_t *)((unsigned char *)psIOB - sizeof(apio_handle_t) - RESERVED_SIZE) = temphandle;
        buff_faked ++;

//sprintf(outbuff+12," in BUFF to IOB , buf_faked = %d,  ***",buff_faked);
//tLan_Transmit(outbuff,sizeof(outbuff));
	//report_error(pbIOBData(psIOB), dwIOBDataLength(psIOB));


    }
    else
    {
    //the following /*---*/ part is the original copy Buffer to IOB work.
	
    //psIOB = getIOB(pBuf->frameLen+IOBOFFSET);
        psIOB = getIOB(pBuf->frameLen);
    
        if(psIOB==NULL) //can't get IOB, release it
        {
        	
            report_error1("wuming getIOB fail ", 100);
            //apio_free(temphandle,pBuf);
            if(from==ID_LAN)
            {
            	apio_FreeEtherRxBuf(pBuf);
            
            }
            else if (from==ID_WIRELESS)
            {
            	apio_FreeWlanRxBuf(pBuf);
            	
            }
        
        
        
            return NULL;
        }
    
        //IOBOFF(psIOB) = IOBOFFSET;
        IOBOFF(psIOB) = 0;
        //dwIOBDataOffset(psIOB) = 0;
        IOBLEN(psIOB) = pBuf->frameLen;
    //dwIOBDataLength(psIOB) = pBuf->frameLen;
    
        MemDma1((uint32)(IOBDATA(psIOB)),(uint32)(pBuf->framePtr),(uint32)(pBuf->frameLen));
    //memcpy(pbIOBData(psIOB),pBuf->framePtr,pBuf->frameLen);
    
        //apio_free(temphandle,pBuf);
         if(from==ID_LAN)
            {
            	apio_FreeEtherRxBuf(pBuf);
            
            }
            else if (from==ID_WIRELESS)
            {
            	apio_FreeWlanRxBuf(pBuf);
            	
            }
    }

//strcpy(outbuff+12," in BufftoIOB-ReturnOK***");
//tLan_Transmit(outbuff,sizeof(outbuff));


    return psIOB;
}


/*
nonow--changed:
Receive Point Should convert the Received-PayLoad to IOBs, not using the copy-way but Add-An-IOB-Header way
*/

iobs * Lan_Receive (void)
{
#if 0
	iobs *pIOB;
	apio_ErrCode_t errCode;
	apio_bufdescr_t pBufDesc;

	pIOB=(iobs *)getCBFromQ(&dsRecvQLan,1);
	return pIOB;
#endif
	return NULL;
}

/*
changelist:
Insert an Function for free an iob Faked from Marvel memory
*/

void free_faked_iob(iobs * psIOB)
{
    apio_handle_t temphandle;
    apio_bufdescr_t pBuf;
    unsigned int rsvd_len;
    unsigned char * header;
    
    if(!psIOB)
        return;
    //to get handle.
    temphandle = *(apio_handle_t *)((unsigned char *)psIOB - sizeof(apio_handle_t) - RESERVED_SIZE);
    //to set the Frame buffer para.
    pBuf.framePtr = IOBDATA(psIOB);
    pBuf.frameLen = IOBLEN(psIOB);
    
    rsvd_len = (unsigned int)((unsigned char *)IOBDATA(psIOB) - (unsigned char *)(psIOB));
    rsvd_len += sizeof(apio_handle_t) + RESERVED_SIZE;
    
    //*(pBuf.framePtr - 1) =  (unsigned int)((unsigned char *)IOBDATA(psIOB) - (unsigned char *)(psIOB));
    //*(pBuf.framePtr - 1) += sizeof(apio_handle_t);

    if(rsvd_len > MAX_RESERVED_LEN)
    {    
        pBuf.framePtr -= (rsvd_len - MAX_RESERVED_LEN);
        pBuf.frameLen += (rsvd_len - MAX_RESERVED_LEN);
        *(pBuf.framePtr - 1) = MAX_RESERVED_LEN;
    }
    else
    {
        *(pBuf.framePtr - 1) = rsvd_len;
    }

    apio_FreeEtherRxBuf(&pBuf);
    buff_faked--;
}

#define MARVEL_MEM_IDX  (0xA)
#define UNKNOWN_MEM     (-1)
extern signed short getIOBsQNumber(IOB * );
extern void freeIOB(iobs *);
void free_uplayer_iob(iobs *psIOB) 
/*if psIOB is from Uplayer Memory, free it, otherwise, just pass it.*/
{
    int idx = getIOBsQNumber(psIOB);


    if ((UNKNOWN_MEM !=idx)&&(MARVEL_MEM_IDX!=idx))
    {
	//report_error1("wuming free free_uplayer_iob", 100);
        freeIOB(psIOB);
    }
}

extern void Fsh_Wireless(int ctrl);

iobs *WLAN_RECV (void)
{
#if 0
	iobs *pIOB;
	apio_ErrCode_t errCode;
	apio_bufdescr_t pBufDesc;
	
	pIOB=(iobs *)getCBFromQ(&dsRecvQWLan,1);
	
	return pIOB;
#endif
	return NULL;
}

/*add for test*******************/
//static int tTransmitPacket(unsigned char *buff, int count, eISGIfaceID direct)
int tTransmitPacket(unsigned char *buff, int count, eISGIfaceID direct)

{
	apio_handle_t temphandle;
	apio_bufdescr_t	pBufsend;
	apio_ErrCode_t errcode;
		
		
	if(count<=0||buff==0)return 0;
	
	if(direct<=ID_ISGSELF||direct>=ID_ISG_NUMBER) return 0;
	
//	if(count <64)
//		count =64;

	if(direct==ID_LAN)
		temphandle=LanHandle;
	//else
	//if(direct==ID_WAN)
	//	temphandle=WanHandle;
	else
	if(direct==ID_WIRELESS)
	{
		temphandle=WlanHandle1;
		//Fsh_Wireless(1);
	}

//	if(temphandle==NULL)
//	{
//		return 0;
//	}
	
	//errcode = apio_alloc(temphandle,&pBufsend);
	if(direct==ID_LAN)
	{
		errcode=apio_ethAlloc(temphandle, &pBufsend);
	}
	else if(direct==ID_WIRELESS)
	{	
		errcode=apio_wlanAlloc(temphandle, &pBufsend);
	}	
		
#if 0   	
	if((errcode != APCTL_OK) && (direct==ID_WIRELESS))
		wlanBufError++;
	else if((errcode == APCTL_OK) && (direct==ID_WIRELESS))
		wlanBufError=0;
#endif	
    	
	
	if(errcode == APCTL_OK)
	{
			 /* Buffer data *//* Text to send *//* Limit to buffer length */
		/**/
			 MemDma1( (uint32)(pBufsend.framePtr), (uint32)buff, (uint32)count);    
			// memcpy( pBufsend.framePtr,buff,count);    
            	        
		///**/pBufsend.framePtr [count] = 0; /* Ensure zero terminator - strncpy() doesn't guarantee this! */
		
		pBufsend.frameLen = count;
		
		//errcode = apio_write(temphandle,&pBufsend);
		if(direct==ID_LAN)
		{
			apio_etherWrite(&pBufsend);
		}
		else if(direct==ID_WIRELESS)
		{
			apio_wlanWrite(&pBufsend);
		}
		
		
		
	}	        
    
 
	return 0;
}


int tLan_Transmit(uint8 *buff, int count)
{
	return tTransmitPacket(buff, count, ID_LAN);
}

int Lan_Transmit(iobs *psIOB)
{
	return TransmitPacket(psIOB, ID_LAN);
}

extern uint8	RadioStatus;


int WLAN_TX(iobs *psIOB)
{
	
	if(RadioStatus == 1)
		return TransmitPacket(psIOB, ID_WIRELESS);
	else
	{
        freeIOB(psIOB);
		return 0;
	}
}

static int TransmitPacket(iobs *psIOB, eISGIfaceID direct)
{
	apio_handle_t temphandle;
	apio_bufdescr_t	pBufsend, Buff;
	apio_ErrCode_t errcode;

    unsigned char * buff;
    
    unsigned int checkPtr;
    
      
    int count;
    int idx;
    
    if(!psIOB)
        return 0;

//strcpy(outbuff+12," in TrasnmitPacket ***");
//tLan_Transmit(outbuff,sizeof(outbuff));

    idx = getIOBsQNumber(psIOB);

	if(direct==ID_LAN)
		temphandle=LanHandle;
	else if(direct==ID_WIRELESS)
	{
		temphandle=WlanHandle1;
		Fsh_Wireless(1);
	}

    if(MARVEL_MEM_IDX == idx) //if it is from marvell memory iob
    {
        unsigned int rsvd_len;
        int k;
        //write it in marvel way.
        //set faked iob--marvel memory parameters.
        
        rsvd_len = (unsigned int) ((unsigned char *)IOBDATA(psIOB) - (unsigned char *)(psIOB));
        rsvd_len += sizeof(apio_handle_t) + RESERVED_SIZE;
        
        if(rsvd_len > MAX_RESERVED_LEN)
        {
            rsvd_len -= MAX_RESERVED_LEN;
            pBufsend.framePtr = IOBDATA(psIOB) - rsvd_len;
            pBufsend.frameLen = IOBLEN(psIOB);
            *(pBufsend.framePtr - 1) = MAX_RESERVED_LEN;
            memmove(pBufsend.framePtr, IOBDATA(psIOB), IOBLEN(psIOB));
            
            if(direct==ID_LAN)
	    {
			apio_etherWrite(&pBufsend);
	    }	
	    else if(direct==ID_WIRELESS)
	    {
			apio_wlanWrite(&pBufsend);
	    }
        }
        else
        {
            pBufsend.framePtr = IOBDATA(psIOB);
            pBufsend.frameLen = IOBLEN(psIOB);
            *(pBufsend.framePtr - 1) =  (unsigned char *)IOBDATA(psIOB) - (unsigned char *)(psIOB);
            *(pBufsend.framePtr - 1) += sizeof(apio_handle_t) + RESERVED_SIZE;
            //apio_write(temphandle,&pBufsend);
            if(direct==ID_LAN)
	    {
			apio_etherWrite(&pBufsend);
	    }	
	    else if(direct==ID_WIRELESS)
	    {
		apio_wlanWrite(&pBufsend);
	    }
            
        }

        buff_faked --;
        return 0;
    }
    else if( UNKNOWN_MEM != idx/*not unknown memory*/)  //if it is from uplayer mem
    {
        buff = IOBDATA(psIOB);
        count= IOBLEN(psIOB);    
    }
		
	if(count<=0||buff==0)
	{
	    freeIOB(psIOB);
	    return 0;
	}
	
	if(direct<=ID_ISGSELF||direct>=ID_ISG_NUMBER)
	{
	    freeIOB(psIOB);
	    return 0;
	}
	

	if(direct==ID_LAN)
	{
		errcode=apio_ethAlloc(temphandle, &pBufsend);
	}
	else if(direct==ID_WIRELESS)
	{	
		errcode=apio_wlanAlloc(temphandle, &pBufsend);
	}	
    	
	
	
	if(errcode == APCTL_OK)
	{
			 MemDma1( (uint32)pBufsend.framePtr, (uint32)buff, (uint32)count);    

		     free_uplayer_iob(psIOB); //to free uplayer mem iob

		pBufsend.frameLen = count;
		
	
		 if(direct==ID_LAN)
	    	{
			apio_etherWrite(&pBufsend);
	    	}	
	    	else if(direct==ID_WIRELESS)
	    	{
			apio_wlanWrite(&pBufsend);
	    	}
	}else
    {
        freeIOB(psIOB);
    }

	return 0;
}


