#ifndef _PACKET_H_
#define _PACKET_H_ 
/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */ 
/*!
 * \file    packet.h
 * \brief   Definition for packet processing module
 */

typedef enum{
    ID_ISGSELF = 0,
    ID_LAN,
    ID_WAN,
    ID_WIRELESS,
    ID_ISG_NUMBER
}eISGIfaceID;
/*
 *	Access Functions for Bridge MAC address
 */

extern void GetWanMac(unsigned char *mac);
extern void GetLanMac(unsigned char *mac);
extern void GetGwLanMac(unsigned char *mac);
extern void GetGwWanMac(unsigned char *mac);
extern void GetWlanMac(unsigned char *mac);
extern void SetWanMac(const unsigned char *mac);
extern void SetLanMac(const unsigned char *mac);
extern void SetGwLanMac(const unsigned char *mac);
extern void SetGwWanMac(const unsigned char *mac);
extern void SetWlanMac(const unsigned char *mac);

#endif  /* _PACKET_H_ */

