#include "basic_types.h"
#include "IEEE_types.h"
#include "oem.h"
#include "api.h"
#include "nv.h"
typedef unsigned char BYTE;
typedef unsigned long ULONG;

void InitInterrupt(void);
void Reset_SuperIO(BYTE ctrl);
void Reset_LAN(BYTE ctrl);
void Reset_WAN(BYTE ctrl);
void Fsh_Wan(BYTE ctrl);
int WLAN_GET_PCCARD_ZONE_LIST(char * list, int * list_len);
char get_domain_setting();
int ResetChip(ULONG ulRomDstAddr);
int WLAN_CLOSE();
void ClrIntStatus(void);
void StartDownPgm(ULONG);
int Lan_ioctl (unsigned int flag,void * data);
int WLAN_GET_PCCARD_ALLOW_CHANNELS(unsigned short * channel);
int intLock();
void intUnlock(int);
void AP_Get_Sta_List(unsigned char **ptr);
int AP_Set_Wlan_Filter(unsigned char *filterlist,char StaNo,char mode);
void Set_Radio(unsigned char mode);
void Get_Wan_Speed(BYTE *speed,BYTE *duplex);

void InitInterrupt(void)
{}
void Reset_SuperIO(BYTE ctrl)
{}
void Reset_WAN(BYTE ctrl)
{}
void Reset_LAN(BYTE ctrl)
{}
int WLAN_GET_PCCARD_ZONE_LIST(char * list, int * list_len)
{return 1;}

int ResetChip(ULONG ulRomDstAddr)
{return 0;}
void Fsh_Wan(BYTE ctrl)
{}
int WLAN_CLOSE()
{
return 1;	
}
void ClrIntStatus(void)
{}


//0x10:USA(1-11) 0x30:Europe(1-13) 0x31:Spain(10-11) 0x32:France(10-13) 0x40:Japan(10-11,&14)
char get_domain_setting()
{
     char * domain_ptr = (char *)(NV_ADDRESS+WIRELESS_DOMAIN);
     
     switch(*domain_ptr)
     {
     	case 0x10:
     	case 0x30:
     	case 0x31:
     	case 0x32:
     	case 0x40: break;
     	
     	default:
     		*domain_ptr = 0x10;
     		break;
     }
         
     return (*domain_ptr);
}

int WLAN_GET_PCCARD_ALLOW_CHANNELS(unsigned short * channel)
{
    switch (get_domain_setting()) {
      case 0x10:
      case 0x20:
           *channel = 0x07FF;
           break;
      case 0x30:
           *channel = 0x1FFF;
           break;
      case 0x31:
           *channel = 0x0600;
           break;
      case 0x32:
           *channel = 0x1E00;
           break;
      case 0x40:
      case 0x41:
      default:
           *channel = 0x3FFF;
           break;
    }
    return 1;   
}
extern unsigned char ether_port_down_tmp;
extern unsigned char etherLed;
void StartDownPgm(ULONG xx)
{
	int result;
	
	APICMDBUF reset;
	APICMDBUF *preset;
	
	reset.cmdCode	= APCMD_FW_SOFT_RESET;
	reset.seqNum	= 1;
	reset.cmdBodyLen = 2;
	
	preset = &reset;
	//wuming for led
	apctlGPIOWrite(4, 0);
   	apctlGPIOWrite(6, 0);
   	apctlGPIOWrite(7, 0);
	
	ether_port_down_tmp=1;
	etherLed=0;
	
	apctl(preset);
	
	if(preset->cmdStatus==APCTL_OK)	
	{
		result=TRUE;
	}
	else
	{
		result = FALSE;
	}
}

int Wan_Port_Status();

int Lan_ioctl (unsigned int flag,void * data)
{
   int returncode = 1;
   switch (flag) {
   case 0x00:
        {
           *(int *)data = Wan_Port_Status();
           returncode = 0;
        }
        break;
   case 0x40:
//        ProgramMacAddressWithAge(7, data);
        break;
   case 0x42:
//        ClearMacAddress(7, data);
        break;
   } /* endswitch */
   return returncode;

}


int Wan_Port_Status()
{
	APICMDBUF_GET_ETH_PORT_STATUS WanStatus;
	APICMDBUF *pwan;
	
	WanStatus.cmdCode = APCMD_GET_ETH_PORT_STATUS;
	WanStatus.seqNum  = 1;
	WanStatus.cmdBodyLen = sizeof(APICMDBUF_GET_ETH_PORT_STATUS);
	WanStatus.portnumber = 4;	//4:wan 0,1,2,3:lan
	//WanStatus.portnumber = 0;
	
	(APICMDBUF_GET_ETH_PORT_STATUS *)pwan = &WanStatus;
	
	apctl(pwan);
		
	if(pwan->cmdStatus==APCTL_OK)	
	{
		if(WanStatus.ethOperStatus == ETH_OPER_STATUS_UP)
			return 1;
		else
			return 0;
	}
	else
	{
		return 0;
	}
	//return 0;
}


int PushButtom(void)
{
	int status;
	
	status = apctlGPIORead(5);
	
	if(status == 0)
		return 1;
	else
		return 0;
}


int stricmp(char *dst, char *src)
{
    for(;(*dst|0x20)==(*src|0x20);dst++,src++) {
       if(*dst==0)
          return 0;
    }
    return 1;
}

int _memicmp(unsigned char *dst, unsigned char *src, int len)
{
    int count=0;
    if (len==0) {
       return 0;
    }
    for(;((*dst|0x20)==(*src|0x20)) && (count<len) ;dst++,src++,count++)
    if(count==(len-1) )
       return 0;
    return 1;
}


int intLock()//disable
{
	int status;
	
	status = apctlGetIntStatus();//0:ISR Enable  -1:ISR Disable
	
	if(status == 0)
		{
			apctlIntDisable();
			return 1;
		}
	else
		return 0;
	
}

void intUnlock(int isr_status)//enable
{
	int status;
	
	if(isr_status == 1)
		apctlIntEnable(status);
	else
		{}
		

}

unsigned char Associated_list[514];

void AP_Get_Sta_List(unsigned char **ptr)
{
	APICMDBUF wlan;
	APICMDBUF *pwlan;
			
//first Read Station Number	
	wlan.cmdCode = APCMD_GET_STA_LIST;
	wlan.seqNum  = 1;
	wlan.cmdBodyLen = 0;
	//wlan.cmdBody = Associated_list;
	
	pwlan = &wlan;
	
	apctl(pwlan);
	
	
	wlan.cmdCode = APCMD_GET_STA_LIST;
	wlan.seqNum  = 1;
	wlan.cmdBodyLen = 514;
	wlan.cmdBody = Associated_list;
	
	pwlan = &wlan;
	
	apctl(pwlan);
	
	if(pwlan->cmdStatus==APCTL_OK)	
	{
		*ptr= Associated_list;
	}
	else
	{
		*ptr= NULL;
	}
	
	
}
/*
typedef enum{
ACCESS_MODE,
FILTER_MODE,
}FILTER_TYPE;
*/
int AP_Set_Wlan_Filter(unsigned char *filterlist,char StaNo,char mode)//mode:0 access   1:filter  //StaNo:FF disable
{
	APICMDBUF wlan;
	APICMDBUF *pwlan;
	unsigned char temp[2+6*StaNo];
	unsigned char disable[2];
	int result;
	
	result = FALSE;//FALSE=0,TRUE=1
	
	
	wlan.cmdCode = APCMD_SET_WLAN_FILTER_LIST;
	wlan.seqNum  = 1;
	
	if(StaNo != 0xFF)//Enable
	{
	wlan.cmdBodyLen = 2+6*StaNo;

	temp[0]=mode;	
	temp[1]=StaNo;
	memcpy(temp+2,filterlist,6*StaNo);
	
	wlan.cmdBody = temp;
	}
	else//disable
	{
		wlan.cmdBodyLen = 2;
		
		disable[0]=0;	
		disable[1]= 0;
		//memcpy(disable+2,"\xff\xaa\xbb\xcc\xdd\xee",6);
		wlan.cmdBody = disable;
	}
	
	
	pwlan = &wlan;
	
	apctl(pwlan);
	
	if(pwlan->cmdStatus==APCTL_OK)	
	{
		result = TRUE;
	}
	else
	{
		result = FALSE;
		goto error;
	}
#if 1	
	wlan.cmdCode = APCMD_BSS_START;
	wlan.seqNum = 1;
	wlan.cmdBodyLen =0; 
	//memcpy(RfBssid,pcmcia.BSSID,32);
	//memcpy(RfBssid,temp,5);
	//wlan.cmdBody = RfBssid;
		
	pwlan = &wlan;
	apctl(pwlan);
	
	if(pwlan->cmdStatus==APCTL_OK)	
	{
		result = TRUE;
	}
	else
	{
		result = FALSE;
		goto error;
	}
#endif	
error:
	if(result == TRUE)
		return 1;
	else
		return 0;
}

uint8	RadioStatus=1;
extern void os_TaskDelay(long long);
void Set_Radio(unsigned char mode)//0:disable 1:enable
{
#if 1
	if(mode == 0)
	{
		//wuming for led
		//apctlGPIOInit(0xFF2F);
		apctlGPIOInit(0xfb20);
		apctlGPIOWrite(6, 1);
		RadioStatus = 0;
		os_TaskDelay((long)(long)200);
	}
	else if(mode == 1)
	{
		//wuming for led
		//apctlGPIOInit(0xFF2F);
		apctlGPIOInit(0xfb20);
		apctlGPIOWrite(6, 0);
		RadioStatus = 1;
	}
#endif
	//wuming temp
	//Wlan_Radio(mode);
}

int Switch_Mode()
{
	int i,status;
	
	
	#if 0
	for( i=0;i<4;i++)
	{
		status=apctlGPIORead(11+i);
		
		if(status==0)
			return (3-i);
	}
	#endif
	return 1;
	
}

void Get_Wan_Speed(BYTE *speed,BYTE *duplex)
{
	APICMDBUF_GET_ETH_PORT_STATUS WanStatus;
	APICMDBUF *pwan;
	
	WanStatus.cmdCode = APCMD_GET_ETH_PORT_STATUS;
	WanStatus.seqNum  = 1;
	WanStatus.cmdBodyLen = sizeof(APICMDBUF_GET_ETH_PORT_STATUS);
	WanStatus.portnumber = 0;	//4:wan 0,1,2,3:lan
	//WanStatus.portnumber = 0;
	
	(APICMDBUF_GET_ETH_PORT_STATUS *)pwan = &WanStatus;
	
	apctl(pwan);
		
	if(pwan->cmdStatus==APCTL_OK)	
	{
		//if(WanStatus.ethDuplex == 0x0a)
		//	*(unsigned char *)duplex = 0;	//simplex mode
		//else
		//	*(unsigned char *)duplex = 1;	//duplex mode
		//*(unsigned char *)speed = WanStatus.ethLinkSpeed;//1:100	0:10
		
		if(WanStatus.ethLinkSpeed == 0x0a)
			*(unsigned char *)speed = 0;	//simplex mode
		else
			*(unsigned char *)speed = 1;	//duplex mode
		*(unsigned char *)duplex = WanStatus.ethDuplex;	 //0 : half , 1: duplex
		
		
	}
	else
	{
		//return 0;
	}
	//return 0;	
	
}