#ifndef __ETH_DEBUG_H__
#define __ETH_DEBUG_H__
/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    eth_debug.h
 * \brief   Public interface for ethernet debug utility
 *
 * Author(s):    Binh Tran 
 * Date:         2003-06-04
 * 
 * $Revision: 1.2 $
 * $Date: 2003/08/22 00:00:53 $
 */
 
 /* ENABLE_ETH_DEBUG is defined in buildModes.h */
#include "buildModes.h"
#include "wltypes.h"

#define DBG_DEFAULT_ETH_IO  "eth0"
#define DBG_DEFAULT_TYPE     0x88cc
#define DBG_BUF_MAX_LEN		512
#define ETH_DBG_HDR_LEN     14
#define ETHERBUG_HDR_LEN	6

#ifdef ENABLE_ETH_DEBUG

extern UINT32 etherBugSend(const char *format, ... );

#define eprintf		etherBugSend
#define printf      etherBugSend
#define assert(expr)  expr?((void *)0):eprintf("%s line %d %s\n",  __FILE__, __LINE__, #expr)

#else

#define eprintf	
#define printf  
#define assert

#endif

typedef struct eth_hdr_dbg{
    UINT8           da[6];
    UINT8           sa[6];
    UINT8           type[2];
} PACK_END eth_hdr_dbg;

typedef struct ethbug_info{
	UINT8           resrv[ETHERBUG_HDR_LEN];
}PACK_END ethbug_info;

#endif /* __ETH_DEBUG_H__ */
