#ifndef _API_H_
#define _API_H_ 
/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */

/*!
 * \file    api.h
 * \brief   This file contains the function prototypes and definitions for the
 *          user commands API
 *
 */


/*============================================================================= */
/*                          API for Sending Commands */
/*============================================================================= */

typedef	enum
{
    API_CMD_BSS_START = 1,
    API_CMD_BSS_START_REPLY,
    API_CMD_GET_SSID,
    API_CMD_GET_SSID_REPLY,
    API_CMD_SET_SSID,
    API_CMD_SET_SSID_REPLY,
    API_CMD_IBSS_START,
    API_CMD_IBSS_START_REPLY,
    API_CMD_MAX
} API_CMD;

typedef enum
{
    API_STATUS_OK = 1,
    API_STATUS_BUF_TOO_SMALL,
    API_STATUS_BAD_CMD,
    API_STATUS_CMD_FAILED,
    API_STATUS_TIMEOUT,
    API_STATUS_ERROR,
}API_STATUS;

typedef UINT16 ApiStatus;

typedef struct ApiCmdBuf_t
{
    UINT16 cmdCode;
    UINT16 seqNum;
    UINT16 cmdStatus;
    UINT16 cmdBodyLen;
    UINT8 *cmdBody;
} ApiCmdBuf_t;

/*
 * Common events
 */
#define EVENT_ETH_DATA      0x00000001
#define EVENT_WL_DATA       0x00000002
#define EVENT_HOST_DATA     0x00000004
#define EVENT_TX_DONE       0x00000008
#define EVENT_HOST_CMD      0x00000010
#define EVENT_MGMT_CMD      0x00000020

#define EVENT_COMMON        0x0000003f
#define EVENT_ALL           0xffffffff

extern WL_STATUS msi_wl_Api(ApiCmdBuf_t * ApiCmdBuf);

#endif /* _API_H_ */




