#ifndef _HANDHSK_H_
#define _HANDHSK_H_

#include "tkip.h"
#include "wl_mib.h"
#include "wl_hal.h"

#define S_SWAP(a,b) do { unsigned char  t = S[a]; S[a] = S[b]; S[b] = t; } while(0)

typedef struct{
  Hsm super;
  State hsk_start;
  State waiting_4_msg_2;
  State waiting_4_msg_4;
  State waiting_4_grpmsg_2;
  State hsk_end;
  Timer timer;
  UINT8 timeout_ctr;
  void *pData;
 }keyMgmthsk_hsm_t;
#if !defined (ECL_WPA)
typedef struct
{
    UINT8 ANonce[NONCE_SIZE];
    UINT8 SNonce[NONCE_SIZE];
    UINT8 EAPOL_MIC_Key[EAPOL_MIC_KEY_SIZE];
    UINT8 EAPOL_Encr_Key[EAPOL_ENCR_KEY_SIZE];
    UINT8 PairwiseTempKey1[TK_SIZE];
    UINT32 RSNPwkTxMICKey[2];
    UINT32 RSNPwkRxMICKey[2];
    UINT8 PairwiseTempKey1_tmp[TK_SIZE];
    UINT32 RSNPwkTxMICKey_tmp[2];
    UINT32 RSNPwkRxMICKey_tmp[2];
    UINT32 counter; /*store only the lower counter */
    /*actually we should store both the lower and the upper counter. But */
    /*  in our implementation we only increment the lower counter */
    UINT8 RsnIEBuf[MAX_SIZE_RSN_IE_BUF];
    UINT32 TxIV32;
    UINT32 RxIV32;
    UINT16 TxIV16;
    UINT8 RSNDataTrafficEnabled;
    UINT8 TimeoutCtr;
    UINT16 Phase1KeyTx[5];
    UINT16 Phase1KeyRx[5];
    /*keyMgmtState_e keyMgmtState; */
}keyMgmtInfo_t;
#endif
typedef enum
{
	STA_ASSO_EVT,
	MSGRECVD_EVT,
	KEYMGMTTIMEOUT_EVT,
	GRPKEYTIMEOUT_EVT,
	UPDATEKEYS_EVT
}keyMgmthsk_event_e;

typedef struct
{
    Timer timer;
    MIC_Fail_State_e status;
    BOOLEAN MICCounterMeasureEnabled;//indicates if counter Measures is enabled
    UINT32 disableStaAsso;//1= Sta Association is disabled
}MIC_Error_t;

void HskCtor(keyMgmthsk_hsm_t *me);
#if !defined(PORTABLE_ARCH)
extern inline UINT32 (*DoWPAAndSchedFrameFp)(WLAN_TX_FRAME *Frame_p, keyMgmtInfo_t *pKeyMgmtInfo,
                                     UINT16 ethertype, BOOLEAN BcastFlag);
extern inline UINT32 DoTKIPAndSchedFrameAP(WLAN_TX_FRAME *Frame_p, keyMgmtInfo_t *pKeyMgmtInfo,
                                     UINT16 ethertype, BOOLEAN BcastFlag);
extern inline USR_BUF_DESC *ProcessTKIPPcktAP(keyMgmtInfo_t *pkeyInfo, USR_BUF_DESC *usp,
                                     WLAN_RX_FRAME **Data11Frame_pp);
extern inline USR_BUF_DESC *(*ProcessWPAPcktFp)(keyMgmtInfo_t *pkeyInfo, USR_BUF_DESC *usp,
                                     WLAN_RX_FRAME **Data11Frame_pp);
#else
extern UINT32 (*DoWPAAndSchedFrameFp)(WLAN_TX_FRAME *Frame_p, keyMgmtInfo_t *pKeyMgmtInfo,
                                     UINT16 ethertype, BOOLEAN BcastFlag);
extern INLINE UINT32 DoTKIPAndSchedFrameAP(WLAN_TX_FRAME *Frame_p, keyMgmtInfo_t *pKeyMgmtInfo,
                                     UINT16 ethertype, BOOLEAN BcastFlag);
extern INLINE USR_BUF_DESC *ProcessTKIPPcktAP(keyMgmtInfo_t *pkeyInfo, USR_BUF_DESC *usp,
                                     WLAN_RX_FRAME **Data11Frame_pp);
extern USR_BUF_DESC *(*ProcessWPAPcktFp)(keyMgmtInfo_t *pkeyInfo, USR_BUF_DESC *usp,
                                     WLAN_RX_FRAME **Data11Frame_pp);
#endif
#endif

