/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
 *
 * $Header: E:\\APCVSDEPOT/wlan/wlandrv/incl/sysinfo.h,v 1.16 2004/03/12 11:54:57 bwswang Exp $
 *
 * Purpose:
 *    This file contains the configuration parameters used for tasks, queues,
 *    and other operating system components.
 *
 * Public Procedures:
 *    None.
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

#ifndef _SYSINFO_H_
#define _SYSINFO_H_
#ifdef USE_NEW_OSIF
#include "osif.h"
#else
#endif


/*============================================================================= */
/*                            PUBLIC DEFINITIONS */
/*============================================================================= */

/*--------------*/
/* System Sizes */
/*--------------*/
#define  sysinfo_MAX_STATIONS        64
#ifndef USE_NEW_OSIF
#ifdef STA
#define  sysinfo_TOTAL_TASKS         8    /* 9 -> 8 */
#define  sysinfo_TOTAL_QUEUES        12
#define  sysinfo_TOTAL_INTERRUPTS    5    /*10 -> 5 */
#define  sysinfo_TOTAL_TIMERS        6    /*10 -> 5 -> 6 */
#define  sysinfo_TOTAL_SEMAPHORES    5
#define  sysinfo_TOTAL_EVENTS        8
#define  sysinfo_TOTAL_CONDITIONS    2
#else
#define  sysinfo_TOTAL_TASKS         20
#define  sysinfo_TOTAL_QUEUES        17
#define  sysinfo_TOTAL_INTERRUPTS    10
#define  sysinfo_TOTAL_TIMERS        8
#define  sysinfo_TOTAL_SEMAPHORES    16
#define  sysinfo_TOTAL_EVENTS        15
#endif
#else
#endif

/*----------*/
/* Task IDs */
/*----------*/
#ifndef USE_NEW_OSIF
#ifdef STA
#define  sysinfo_802_11_TX_NOTIFY_TASK    0
#define  sysinfo_IDLE_TASK                1
#define  sysinfo_CB_PROC_TASK             2
#define  sysinfo_SME_TASK                 3
#define  sysinfo_MAC_MGMT_TASK            4
#define  sysinfo_802_11_MSG_TX_TASK       5
#define  sysinfo_802_11_MSG_RX_TASK       6
#define  sysinfo_BRIDGE_TASK              7
#else
#define  sysinfo_ROOT_TASK                0
#define  sysinfo_IDLE_TASK                1
#define  sysinfo_SME_TASK                 2
#define  sysinfo_MAC_MGMT_TASK            3
#define  sysinfo_802_11_MSG_TX_TASK       4
#define  sysinfo_DS_TASK                  5
#define  sysinfo_TEST_TASK                6
#define  sysinfo_BCNGEN_TASK              7
#define  sysinfo_DHCP_TASK                8
#endif
#else
#endif


/*------------*/
/* Task Names */
/*------------*/
#ifdef STA
#define  sysinfo_ROOT_TASK_NAME              "Root"
#define  sysinfo_IDLE_TASK_NAME              "Idle"
#define  sysinfo_CB_PROC_TASK_NAME           "CB Proc"
#define  sysinfo_SME_TASK_NAME               "SME"
#define  sysinfo_MAC_MGMT_TASK_NAME          "MAC Mgmt"
#define  sysinfo_802_11_MSG_TX_TASK_NAME     "MAC Tx"
#define  sysinfo_802_11_MSG_RX_TASK_NAME     "MAC Rx"
#define  sysinfo_BCN_GENERATION_TASK_NAME    "BCN Gen"
#define  sysinfo_802_11_TX_NOTIFY_TASK_NAME  "MAC Tx Notify"
#define  sysinfo_BRIDGE_TASK_NAME            "Bridge"
#else
#define  sysinfo_ROOT_TASK_NAME              "Root"
#define  sysinfo_IDLE_TASK_NAME              "Idle"
#define  sysinfo_SME_TASK_NAME               "SME"
#define  sysinfo_MAC_MGMT_TASK_NAME          "MAC Mgmt"
#define  sysinfo_802_11_MSG_TX_TASK_NAME     "MAC Tx"
#define  sysinfo_DS_TASK_NAME                "Distribution"
#define  sysinfo_TEST_TASK_NAME              "Test"
#define  sysinfo_BCNGEN_TASK_NAME            "Bcngen"
#define  sysinfo_DHCP_TASK_NAME              "DHCPTask"
#endif

/*-----------------*/
/* Task Priorities */
/*-----------------*/
#ifdef ECOS
#ifdef STA
#define  sysinfo_CB_PROC_TASK_PRI             9 /*2 -> 7 -> 9 */
#define  sysinfo_802_11_TX_NOTIFY_TASK_PRI    5 /*5 -> 2 -> 5 */
#define  sysinfo_802_11_MSG_TX_TASK_PRI       7 /*7 -> 5 -> 7 */
#define  sysinfo_802_11_MSG_RX_TASK_PRI       2 /*9 -> 2 */
#define  sysinfo_MAC_MGMT_TASK_PRI            17
#define  sysinfo_SME_TASK_PRI                 19
#define  sysinfo_ROOT_TASK_PRI                25
#define  sysinfo_IDLE_TASK_PRI                30
#else
#define  sysinfo_ROOT_TASK_PRI                1
#define  sysinfo_IDLE_TASK_PRI               31
#define  sysinfo_SME_TASK_PRI                15
#define  sysinfo_MAC_MGMT_TASK_PRI            5
#define  sysinfo_802_11_MSG_TX_TASK_PRI       4
#define  sysinfo_TEST_TASK_PRI               23
#define  sysinfo_BCNGEN_TASK_PRI             10
#define  sysinfo_DHCP_TASK_PRI               18
#endif
/* Typical stack size ECOS */
#define  sysinfo_STACK_SIZE_TYPICAL           CYGNUM_HAL_STACK_SIZE_TYPICAL

#elif defined (OS_VxW)

#define  sysinfo_ROOT_TASK_PRI                1
#define  sysinfo_TIMER_TASK_PRI               (sysinfo_ROOT_TASK_PRI + 1)

/* each timer is implemented as a high priority task. 
 * So Base low priority start from the last timer task priority.
 */
#define  sysinfo_BASE_LOW_PRI                 (sysinfo_TIMER_TASK_PRI + 1)

#define  sysinfo_802_11_MSG_TX_TASK_PRI       (sysinfo_BASE_LOW_PRI + 4)
#define  sysinfo_MAC_MGMT_TASK_PRI            (sysinfo_BASE_LOW_PRI + 5) 
#define  sysinfo_DS_TASK_PRI                  (sysinfo_BASE_LOW_PRI + 6)
#define  sysinfo_BCNGEN_TASK_PRI              (sysinfo_BASE_LOW_PRI + 10)
#define  sysinfo_BRIDGE_TASK_PRI              (sysinfo_BASE_LOW_PRI + 6)
#define  sysinfo_SME_TASK_PRI                 (sysinfo_BASE_LOW_PRI + 15) 
#define  sysinfo_ETHER_SWITCH_TASK_PRI        (sysinfo_BASE_LOW_PRI + 16)
#define  sysinfo_TEST_TASK_PRI                (sysinfo_BASE_LOW_PRI + 23)
#define  sysinfo_WEB_TASK_PRI                 (sysinfo_BASE_LOW_PRI + 50)
#define  sysinfo_IDLE_TASK_PRI                (sysinfo_BASE_LOW_PRI + 100)

/* Typical stack size VxWorks */
#define  sysinfo_STACK_SIZE_TYPICAL              2048

#endif /* OS_VxW or OS_ECOS */


/*------------------*/
/* Task Stack Sizes */
/*------------------*/
#ifdef STA
#define  sysinfo_IDLE_TASK_STACK_SIZE            460  /*360 -> 460 */
#define  sysinfo_CB_PROC_TASK_STACK_SIZE         472
#define  sysinfo_SME_TASK_STACK_SIZE             440
#define  sysinfo_MAC_MGMT_TASK_STACK_SIZE        1100 /*1256 -> 1200 -> 1100 */
#define  sysinfo_802_11_MSG_TX_TASK_STACK_SIZE   524  /*424 -> 524 */
#define  sysinfo_802_11_MSG_RX_TASK_STACK_SIZE   556  /* 456 -> 556 */
#define  sysinfo_802_11_TX_MAC_DATA_TASK_STACK_SIZE 748  /*648 -> 748 */

#define  sysinfo_TOTAL_STACK_SIZE                     \
            sysinfo_IDLE_TASK_STACK_SIZE +            \
            sysinfo_CB_PROC_TASK_STACK_SIZE +         \
            sysinfo_SME_TASK_STACK_SIZE +             \
            sysinfo_MAC_MGMT_TASK_STACK_SIZE +        \
            sysinfo_802_11_MSG_TX_TASK_STACK_SIZE +   \
            sysinfo_802_11_MSG_RX_TASK_STACK_SIZE +   \
            sysinfo_802_11_TX_MAC_DATA_TASK_STACK_SIZE
#else
#define  sysinfo_ROOT_TASK_STACK_SIZE            sysinfo_STACK_SIZE_TYPICAL
#define  sysinfo_IDLE_TASK_STACK_SIZE            sysinfo_STACK_SIZE_TYPICAL
#define  sysinfo_SME_TASK_STACK_SIZE             (sysinfo_STACK_SIZE_TYPICAL+2048)
#define  sysinfo_MAC_MGMT_TASK_STACK_SIZE        (sysinfo_STACK_SIZE_TYPICAL+2048)
#define  sysinfo_802_11_MSG_TX_TASK_STACK_SIZE   (sysinfo_STACK_SIZE_TYPICAL+4096)
#define  sysinfo_TEST_TASK_STACK_SIZE            (sysinfo_STACK_SIZE_TYPICAL+2048)
#define  sysinfo_BCNGEN_TASK_STACK_SIZE          (sysinfo_STACK_SIZE_TYPICAL+2048)
#define  sysinfo_DHCP_TASK_STACK_SIZE            (sysinfo_STACK_SIZE_TYPICAL+1024)


#define sysinfo_TOTAL_STACK_SIZE      (sysinfo_ROOT_TASK_STACK_SIZE + \
                                      sysinfo_SME_TASK_STACK_SIZE  + \
                                      sysinfo_MAC_MGMT_TASK_STACK_SIZE + \
                                      sysinfo_802_11_MSG_TX_TASK_STACK_SIZE + \
                                      sysinfo_TEST_TASK_STACK_SIZE + \
                                      sysinfo_DHCP_TASK_STACK_SIZE + \
                                      sysinfo_BCNGEN_TASK_STACK_SIZE)
#endif
            
/*-----------*/
/* Queue IDs */
/*-----------*/
#ifdef USE_NEW_OSIF
QUEUE_HANDLE smeQH, apiQH; 
#else
#ifdef STA
#define  sysinfo_CB_PROC_SME_MSG_Q        0
#define  sysinfo_SME_MGMT_MSG_Q           1
#define  sysinfo_SME_CB_PROC_MSG_Q        2
#define  sysinfo_SME_ERROR_MSG_Q          3
#define  sysinfo_SME_TIMER_MSG_Q          4
#define  sysinfo_MAC_MGMT_MSG_Q           5
#define  sysinfo_MAC_MGMT_802_11_MSG_Q    6
#define  sysinfo_MAC_MGMT_SME_MSG_Q       7
#define  sysinfo_MAC_MGMT_CB_PROC_MSG_Q   8
#define  sysinfo_MAC_MGMT_TIMER_MSG_Q     9
#define  sysinfo_802_11_MSG_TX_DATA_Q     10
#define  sysinfo_802_11_MSG_TX_MGMT_Q     11
#define  sysinfo_CB_PROC_USB_DATA_Q       12
#define  sysinfo_CB_PROC_USB_MGMT_Q       13
#else
#define  sysinfo_SME_MGMT_MSG_Q           0
#define  sysinfo_SME_HOST_CMD_Q           1
#define  sysinfo_AP_API_RESP_Q            2
#define  sysinfo_SME_ERROR_MSG_Q          3
#define  sysinfo_MAC_MGMT_802_11_MSG_Q    4
#define  sysinfo_MAC_MGMT_SME_MSG_Q       5
#define  sysinfo_802_11_MSG_TX_Q          6
#define  sysinfo_DS_NOTIFY_Q              7
#define  sysinfo_802_11_DATA_TX_Q         8
#define  sysinfo_802_11_RX_PS_POLL_Q      9
#define  sysinfo_MAC_MGMT_TIMER_MSG_Q     10
#define  sysinfo_DS_LLC_DATA_Q            11
#define  sysinfo_802_3_DATA_TX_Q          12
#define  sysinfo_WPA_Q                    13
#define  sysinfo_TIMER_CALL_BACK_Q        14  

#endif
#endif



/*-----------*/
/* Event IDs */
/*-----------*/
#ifdef USE_NEW_OSIF
EVENT_HANDLE bcngenEH;
EVENT_HANDLE dsEH;
EVENT_HANDLE tx11EH;
EVENT_HANDLE mgmtEH;
EVENT_HANDLE smeEH;
#else
#ifdef STA
#define  sysinfo_CB_PROC_Q_EVENT             0
#define  sysinfo_SME_MAIN_Q_EVENT            1
#define  sysinfo_MAC_MGMT_MAIN_Q_EVENT       2
#define  sysinfo_802_11_TX_NOTIFY_Q_EVENT    3
#define  sysinfo_802_11_RX_EVENT             4
#define  sysinfo_802_11_TX_Q_EVENT           5
#define  sysinfo_BCN_FREE_EVENT              6
#define  sysinfo_BRIDGE_EVENT                7
#else
#define  sysinfo_HOST_CMD_Q_EVENT            0
#define  sysinfo_SME_MAIN_Q_EVENT            1
#define  sysinfo_MAC_MGMT_MAIN_Q_EVENT       2
#define  sysinfo_802_11_TX_NOTIFY_Q_EVENT    3
#define  sysinfo_802_11_RX_EVENT             4
#define  sysinfo_802_11_TX_Q_EVENT           5
#define  sysinfo_BCN_Q_EVENT                 6
#define  sysinfo_DS_EVENT                    7
#define  sysinfo_BCNGEN_EVENT                8
#define  sysinfo_API_RESP_Q_EVENT            9
#endif
#endif


/*---------------*/
/* Semaphore IDs */
/*---------------*/
#ifdef USE_NEW_OSIF
#else
#define  sysinfo_EXT_STA_SEM   0
#ifdef AP_SW
#define  sysinfo_STALIST_SEM   1
#else
#define  sysinfo_TIMER_SEM     1
#endif
#define  sysinfo_TIMER_DB_SEM  2
#define  sysinfo_DMA0_SEM      3
#define  sysinfo_DIAG_SEM      4

#ifdef buildModes_HIF_USB
#define 	sysinfo_RECVQ_SEM     5
#define	sysinfo_XMITQ_SEM     6
#endif

#define sysinfo_POOL_SEM        7

#endif


/*---------------*/
/* Condition IDs */
/*---------------*/
#ifdef USE_NEW_OSIF
#else
#define  sysinfo_TX_BUF_COND   0
#define  sysinfo_TX_INFO_COND  1
#endif


/*---------------*/
/* Interrupt IDs */
/*---------------*/
#ifdef USE_NEW_OSIF
#else
#define  sysinfo_RX_MGMT_MSG_INT          0
#define  sysinfo_RX_DATA_MSG_INT          1
#define  sysinfo_RX_CTL_MSG_INT           2
#define  sysinfo_RX_BCN_INT               3
#define  sysinfo_RX_HOST_MSG_INT          4
#define  sysinfo_TX_NOTIFICATION_INT      5
#define  sysinfo_PWR_MODE_UPDATE_INT      6
#endif


#endif /* _SYSINFO_H_ */
