#if !defined(_WLMAC_MGMT_H_)
#define _WLMAC_MGMT_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */

/*!
 * \file    wlmac_mgmt.h
 * \brief   This file contains the 802.11 management structure definitions based 
 *          on IEEE 802.11 specification.
 *
*/

/*---------------------------------*/
/* IEEE 802.11 Management Messages */
/*---------------------------------*/
typedef struct PACK_START macmgmtQ_MgmtMsg_t
{
#ifdef STA
   w8100_MrvlRxHdr_t     MrvlHdr;
#endif   
   union
   {
       IEEEtypes_MgmtHdr_t   IeeeHdr;
       IEEEtypes_MgmtHdr_t   Hdr;
   }
   union
   {
      IEEEtypes_Bcn_t          Bcn;
      IEEEtypes_DisAssoc_t     DisAssoc;
      IEEEtypes_AssocRqst_t    AssocRqst;
      IEEEtypes_AssocRsp_t     AssocRsp;
      IEEEtypes_ReassocRqst_t  ReassocRqst;
      IEEEtypes_ReassocRsp_t   ReassocRsp;
      IEEEtypes_ProbeRqst_t    ProbeRqst;
      IEEEtypes_ProbeRsp_t     ProbeRsp;
      IEEEtypes_Auth_t         Auth;
      IEEEtypes_Deauth_t       Deauth;
   }Body;
   UINT32  FCS;
} PACK_END macmgmtQ_MgmtMsg_t;


#endif /*_WLMAC_MGMT_H_*/
