#if !defined(_GPIO_H_)
#define _GPIO_H_

/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */


/*!
 * \file    gpio.h
 * \brief   This file contains the GPIO registers definitions
 *
 */


/*--------------------------------------------------------------*/
/*  General Purpose Input/Output (GPIO) registers                        */
/*--------------------------------------------------------------*/
#define WL_GPIO_SELECT7_0     ((WL_LBU_GPU_CFG_BASE)|(0x0000))
#define WL_GPIO_SELECT15_8    ((WL_LBU_GPU_CFG_BASE)|(0x0004))
#define WL_GPIO_BIDIRCTRL     ((WL_LBU_GPU_CFG_BASE)|(0x0008))
#define WL_GPIO_OUTPUT        ((WL_LBU_GPU_CFG_BASE)|(0x000c))
#define WL_GPIO_INPUT         ((WL_LBU_GPU_CFG_BASE)|(0x0010))
#define WL_GPIO_IER           ((WL_LBU_GPU_CFG_BASE)|(0x0014))
#define WL_GPIO_IMR           ((WL_LBU_GPU_CFG_BASE)|(0x0018))
#define WL_GPIO_RESETSEL      ((WL_LBU_GPU_CFG_BASE)|(0x001c))
#define WL_GPIO_ISRSTATUS     ((WL_LBU_GPU_CFG_BASE)|(0x0020))
#define WL_GPIO_LEDOUTENABLE  ((WL_LBU_GPU_CFG_BASE)|(0x0024))
#define WL_GPIO_LEDCYCLE3_0   ((WL_LBU_GPU_CFG_BASE)|(0x0028))
#define WL_GPIO_LEDCYCLE7_4   ((WL_LBU_GPU_CFG_BASE)|(0x002c))
#define WL_GPIO_LEDCYCLE11_8  ((WL_LBU_GPU_CFG_BASE)|(0x0030))
#define WL_GPIO_LEDCYCLE15_12 ((WL_LBU_GPU_CFG_BASE)|(0x0034))
#define WL_GPIO_LEDDUTY3_0    ((WL_LBU_GPU_CFG_BASE)|(0x0038))
#define WL_GPIO_LEDDUTY7_4    ((WL_LBU_GPU_CFG_BASE)|(0x003c))
#define WL_GPIO_LEDDUTY11_8   ((WL_LBU_GPU_CFG_BASE)|(0x0040))
#define WL_GPIO_LEDDUTY15_12  ((WL_LBU_GPU_CFG_BASE)|(0x0044))
#define WL_GPIO_STATUSSIGNAL  ((WL_LBU_GPU_CFG_BASE)|(0x0048))
#define WL_GPIO_STRETCH       ((WL_LBU_GPU_CFG_BASE)|(0x004c))
#define WL_GPIO_CLOCKDIVIDER  ((WL_LBU_GPU_CFG_BASE)|(0x0050))

#endif /* _GPIO_H_ */

